
#include "baghira.h"
#include "bitmaps.h"
#include "embeddata.h" 
//#include "htmlmasks.h"
//#include <private/qeffects_p.h> 
// test for blend in popups - the qt function seems to be a bit bugg
// first: the widget does not release its focus
// second: qalhawidget::render() crashes, if you call an existing popup menu (but i don't kno why)
// anyway: that would be worth to have - nice animation
#include <qrangecontrol.h>
#include <qlistview.h>
//#include "qcleanuphandler.h"
#include <qgroupbox.h>

#include <X11/X.h>
#include <X11/Xlib.h>

// allthough it seems to be called (sometimes) in the include structure, we better call it explicitly - sorry for all the problems this caused
#include <cmath>

#define _SCALE_    65536
#define _NORMALIZE_ >>16

#define QCOORDARRLEN(x) sizeof(x)/(sizeof(QCOORD)*2)

static const int windowsItemFrame	= 1; // menu item frame width
static const int windowsSepHeight	= 2; // separator item height
static const int windowsItemHMargin	= 3; // menu item hor text margin
static const int windowsItemVMargin	= 1; // menu item ver text margin
static const int windowsArrowHMargin	= 6; // arrow horizontal margin
static const int windowsTabSpacing	= 12; // space between text and tab
static const int windowsCheckMarkHMargin	= 2; // horiz. margins of check mark
static const int windowsRightBorder	= 12; // right border on windows
static const int windowsCheckMarkWidth	= 12; // checkmarks width on windows


class LiquidStylePlugin : public QStylePlugin {
	public:
		LiquidStylePlugin() {
			;
			}
		~LiquidStylePlugin() {
			;
			}

		QStringList keys() const {
			return ( QStringList() << "Baghira" );
			}
		QStyle *create( const QString & );
	};

QStyle *LiquidStylePlugin::create( const QString &s ) {
	if ( s.lower() == "baghira" )
		return ( new LiquidStyle() );
	return ( 0 );
	}

Q_EXPORT_PLUGIN( LiquidStylePlugin )

static const int itemFrame = 1;
static const int itemHMargin = 3;
static const int itemVMargin = 1;
static const int arrowHMargin = 6;
static const int rightBorder = 12;

OptionHandler::OptionHandler( QObject *parent ) : QObject( parent ) {
	QIntDict<KPixmap>popupDict(499);
	fillPixmap = NULL;
	directFollower = true;
	menusProcessed = false;
	menuActive = false;
	scrollerActive = false;
	menuItemActive = false;
	menuLevelCounter = 0;
	groupShadowButton = false;
	lastPopupRect;// = new QRect;
	popupDict.setAutoDelete(true);
	dropShadowsInited = false;
	indicatedMenuItemPix = NULL;
	lastIndicatedMenuItemPix = NULL;
	indicatedMenuItemRect = new QRect(0,0,0,0);
	lastIndicatedMenuItemRect = new QRect(0,0,0,0);
	daddyWasAPopup = false;
	reloadSettings();
	}

	
const QColor& OptionHandler::textColor() {
	return ( useCustomMenuColor ? fgColor : qApp->palette().active().text() );
	}

const QColor& OptionHandler::bgColor() {
	LiquidStyle * style = ( LiquidStyle* ) parent();
	if ( !menuColorButton )
		return ( style->isKicker ? style->origPanelBrush.color() : qApp->palette().active().background() );
	else{
		qWarning("we have button color");
		return ( qApp->palette().active().button() );
		}
	return (color);

	}

const QColor& OptionHandler::buttonColor() {
	LiquidStyle * style = ( LiquidStyle* ) parent();
	if ( !menuColorButton )
		return ( style->isKicker ? style->origPanelBrush.color() : qApp->palette().active().button() );
	else{
		qWarning("we have button color");
		return ( qApp->palette().active().background() );
		}
	return (color);

	}

void OptionHandler::reloadSettings() {
	popupDict.setAutoDelete(true);
	popupDict.clear();
	currentPopupWinID = -1;
	currentPopup = NULL;
	lastPopupID = -1;
	lastIndicatedMenuItemID = -1;
	// gather options...
	QSettings settings;

	// menu stuff
	stippleMenu = settings.readBoolEntry( "/qt/Baghira/stippleMenu", true);
	menuTranslucency =  settings.readNumEntry( "/qt/Baghira/menuTranslucency", DefaultTrans);
	if (menuTranslucency >= CustomTrans)
		opacity = settings.readNumEntry( "/qt/Baghira/customMenuOpacity", 9);
	menuColorButton = settings.readBoolEntry( "/qt/Baghira/menuColorButton", false);
	shadowText = settings.readBoolEntry( "/qt/Baghira/shadowedText", true);
	menuDropShadows = settings.readBoolEntry( "/qt/Baghira/menuDropShadows", true);
	if (menuDropShadows){
		shadowOffset = settings.readNumEntry( "/qt/Baghira/shadowOffset", 8);
		dropShadowDarkness = settings.readNumEntry( "/qt/Baghira/dropShadowDarkness", 2);
	}
	else{
		shadowOffset = 0;
		dropShadowDarkness = 0;
	}

	// color stuff
	// widgets
	customWidgetColor  =  settings.readBoolEntry( "/qt/Baghira/useCustomWidgetColor", false);
	if ( customWidgetColor ) {
		customColors[ CustomRadioOn ].setRgb( settings.readNumEntry( "/qt/Baghira/customRadioOnColor", ( int ) buttonColor().rgb() ) );
		customColors[ CustomRadioOff ].setRgb( settings.readNumEntry( "/qt/Baghira/customRadioOffColor", ( int ) bgColor().rgb() ) );
		customColors[ CustomCBOn ].setRgb( settings.readNumEntry( "/qt/Baghira/customCheckOnColor", ( int ) buttonColor().rgb() ) );
		customColors[ CustomCBOff ].setRgb( settings.readNumEntry( "/qt/Baghira/customCheckOffColor", ( int ) bgColor().rgb() ) );
		customColors[ CustomTabOn ].setRgb( settings.readNumEntry( "/qt/Baghira/customActiveTabColor", ( int ) buttonColor().rgb() ) );
		customColors[ CustomTabOff ].setRgb( settings.readNumEntry( "/qt/Baghira/customInactiveTabColor", ( int ) bgColor().rgb() ) );
		customColors[ CustomSBSlider ].setRgb( settings.readNumEntry( "/qt/Baghira/customSliderColor", ( int ) bgColor().rgb() ) );
		customColors[ CustomSBSliderHover ].setRgb( settings.readNumEntry( "/qt/Baghira/customHoveredSliderColor", ( int ) buttonColor().rgb() ) );
		customColors[ CustomSBSliderPressed ].setRgb( settings.readNumEntry( "/qt/Baghira/customPressedSliderColor", ( int ) buttonColor().dark(110).rgb() ) );
		customColors[ CustomSBGroove ].setRgb( settings.readNumEntry( "/qt/Baghira/customSliderGrooveColor", ( int ) bgColor().rgb() ) );
	}
	// menu
	useCustomMenuColor = settings.readBoolEntry( "/qt/Baghira/useCustomMenuStyle", false);
	if (useCustomMenuColor){
		color = QColor( settings.readNumEntry( "/qt/Baghira/customMenuColor", 0 ) );
		fgColor = QColor( settings.readNumEntry( "/qt/Baghira/customMenuTextColor", 0 ) );
	}
	// Panel
	panelCustom = settings.readBoolEntry( "/qt/Baghira/useCustomPanelColor", false );
	if (panelCustom)
		customPanelColor = QColor( settings.readNumEntry( "/qt/Baghira/customPanelColor", ( int ) bgColor().rgb() ) );
	// inactive Button
	inactiveButtonColor = settings.readNumEntry( "/qt/Baghira/inactiveButtonColor", Background);
	if (inactiveButtonColor == Custom)
		customInactiveButtonColor = QColor( settings.readNumEntry( "/qt/Baghira/customInactiveButtonColor", (int) bgColor().rgb()));

	//design stuff
	//stipple
	bgStipple = settings.readBoolEntry( "/qt/Baghira/stippleBackground", true );
	panelStipple = settings.readBoolEntry( "/qt/Baghira/stipplePanel", true );
	contrast = settings.readNumEntry( "/qt/Baghira/stippleContrast", 3);
	//shadows
	groupboxshadow = settings.readBoolEntry( "/qt/Baghira/useGroupShadows", true );
	shadowDarkness = settings.readNumEntry( "/qt/Baghira/shadowDarkness", 3);
	//ListViews
	expanderStyle = settings.readNumEntry( "/qt/Baghira/expanderStyle", Apple);
	useCustomExpanderColor = settings.readBoolEntry( "/qt/Baghira/useCustomExpanderColor", false);
	if (useCustomExpanderColor)
		expanderColor = QColor( settings.readNumEntry( "/qt/Baghira/expanderColor", (int) qApp->palette().active().text().rgb()));
	drawDotlines = settings.readBoolEntry( "/qt/Baghira/drawDotlines", true);
	if (drawDotlines){
		dotlineStyle = settings.readNumEntry( "/qt/Baghira/dotlineStyle", Line);
		dotlineColor = QColor( settings.readNumEntry( "/qt/Baghira/dotlineColor", (int) qApp->palette().active().mid().rgb()));
	}
	//slider
	squeezesbslider = settings.readBoolEntry( "/qt/Baghira/squeezeSbSlider", true );
	shadowsbslider = settings.readBoolEntry( "/qt/Baghira/shadowSbSlider", true );
	// toolbar
	tbFrame = settings.readBoolEntry( "/qt/Baghira/drawToolbarButtonFrames", true );

	// tweaks
	alignStipples = settings.readBoolEntry( "/qt/Baghira/alignStipples", false);
	centerTabs = settings.readBoolEntry( "/qt/Baghira/centerTabs", false);
	engageFB = settings.readBoolEntry( "/qt/Baghira/engageFB", false);
	smoothListViewHeaders = settings.readBoolEntry( "/qt/Baghira/smoothListViewHeaders", false);
	smootherLVH = settings.readBoolEntry( "/qt/Baghira/smootherLVH", false);
	icyButtons = settings.readBoolEntry( "/qt/Baghira/icyButtons", false);
	saturation = settings.readNumEntry( "/qt/Baghira/saturation", 2);
	forceRectButton = settings.readBoolEntry( "/qt/Baghira/forceRectButtons", false);
	progressBar = settings.readNumEntry( "/qt/Baghira/progressBar", baghira);
	removeKickerBevel = settings.readBoolEntry( "/qt/Baghira/removeKickerBevel", false);
	smoothToolbuttons = settings.readBoolEntry( "/qt/Baghira/smoothToolbuttons", false);
	drawProgressLabel = settings.readBoolEntry( "/qt/Baghira/drawProgressLabel", false);

	// Option gathered
	}


void OptionHandler::rightShadow(QImage& dst, int swh)
{
	int swh2;
	if (dst.depth() != 32)
		dst = dst.convertDepth(32);
		
	if (dst.height() < 2*swh){
		swh = dst.height()/2;
		swh2 = dst.height() - swh;
	}
	else
		swh2 = swh;

	// blend top-right corner.
	int pixels = dst.width() * dst.height();
#ifdef WORDS_BIGENDIAN
	register unsigned char* data = dst.bits() + 1;	// Skip alpha
#else
	register unsigned char* data = dst.bits();		// Skip alpha
#endif
	for(register int i = 0; i < dst.width()*swh; i++) {
		*data++ = (unsigned char)(((*data)*top_right_corner[i])_NORMALIZE_);
		*data++ = (unsigned char)(((*data)*top_right_corner[i])_NORMALIZE_);
		*data++ = (unsigned char)(((*data)*top_right_corner[i])_NORMALIZE_);
		data++;	// skip alpha
	}

	pixels -= (dst.width()*swh + dst.width()*swh2);	// tint right strip without rounded edges.
	register int c = 0;
	for(register int i = 0; i < pixels; i++) {
		*data++ = (unsigned char)(((*data)*shadow_strip[c])_NORMALIZE_);
		*data++ = (unsigned char)(((*data)*shadow_strip[c])_NORMALIZE_);
		*data++ = (unsigned char)(((*data)*shadow_strip[c])_NORMALIZE_);
		data++; // skip alpha
		c = ++c % dst.width();
	}

	// tint bottom edge
	for(register int i = 0; i < dst.width()*swh2; i++) {
		*data++ = (unsigned char)(((*data)*bottom_right_corner[i])_NORMALIZE_);
		*data++ = (unsigned char)(((*data)*bottom_right_corner[i])_NORMALIZE_);
		*data++ = (unsigned char)(((*data)*bottom_right_corner[i])_NORMALIZE_);
		data++;	// skip alpha
	}
}

void OptionHandler::leftShadow(QImage& dst, int swh)
{
	int swh2;
	if (dst.depth() != 32)
		dst = dst.convertDepth(32);
		
	if (dst.height() < 2*swh){
		swh = dst.height()/2;
		swh2 = dst.height() - swh;
	}
	else
		swh2 = swh;

	// blend top-right corner.
	int pixels = dst.width() * dst.height();
#ifdef WORDS_BIGENDIAN
	register unsigned char* data = dst.bits() + 1;	// Skip alpha
#else
	register unsigned char* data = dst.bits();		// Skip alpha
#endif
	for(register int i = 0; i < dst.width()*swh; i++) {
		*data++ = (unsigned char)(((*data)*top_left_corner[i])_NORMALIZE_);
		*data++ = (unsigned char)(((*data)*top_left_corner[i])_NORMALIZE_);
		*data++ = (unsigned char)(((*data)*top_left_corner[i])_NORMALIZE_);
		data++;	// skip alpha
	}

	pixels -= (dst.width()*swh + dst.width()*swh2);	// tint right strip without rounded edges.
	register int c = 0;
	for(register int i = 0; i < pixels; i++) {
		*data++ = (unsigned char)(((*data)*shadow_strip[swh-1-c])_NORMALIZE_);
		*data++ = (unsigned char)(((*data)*shadow_strip[swh-1-c])_NORMALIZE_);
		*data++ = (unsigned char)(((*data)*shadow_strip[swh-1-c])_NORMALIZE_);
		data++; // skip alpha
		c = ++c % dst.width();
	}

	// tint bottom edge
	for(register int i = 0; i < dst.width()*swh2; i++) {
		*data++ = (unsigned char)(((*data)*bottom_left_corner[i])_NORMALIZE_);
		*data++ = (unsigned char)(((*data)*bottom_left_corner[i])_NORMALIZE_);
		*data++ = (unsigned char)(((*data)*bottom_left_corner[i])_NORMALIZE_);
		data++;	// skip alpha
	}
}

void OptionHandler::bottomShadow(QImage& dst, int swh)
{
	if (dst.depth() != 32)
		dst = dst.convertDepth(32);
	
	if (dst.width() < swh)
		swh = dst.width();

	int line = 0;
	int width = dst.width()/* - swh*/;
	int strip_data = shadow_strip[0];
//	double* corner = const_cast<double*>(bottom_left_corner);

#ifdef WORDS_BIGENDIAN
	register unsigned char* data = dst.bits() + 1;	// Skip alpha
#else
	register unsigned char* data = dst.bits();	// Skip alpha
#endif
	for(int y = 0; y < dst.height(); y++)
	{
		// Bottom-left Corner
/*		for(register int x = 0; x < swh; x++) {
			*data++ = (unsigned char)((*data)*(*corner));
			*data++ = (unsigned char)((*data)*(*corner));
			*data++ = (unsigned char)((*data)*(*corner));
			data++; // skip alpha
			corner++;
		}*/

		// Scanline
		for(register int x = 0; x < width; x++) {
			*data++ = (unsigned char)(((*data)*strip_data)_NORMALIZE_);
			*data++ = (unsigned char)(((*data)*strip_data)_NORMALIZE_);
			*data++ = (unsigned char)(((*data)*strip_data)_NORMALIZE_);
			data++;
		}

		strip_data = shadow_strip[++line];
	}
}

// Create a shadow of variable thickness
void OptionHandler::createShadowWindows(const QPopupMenu* p, PopupStuff *popupStuff/*QPixmap *cleanPix*/, int swh/*, int leftOffset*/)
{
// first, we should check, if we allready rendered the dropshadows for this popup...
	if (popupStuff->hasShadows){
		ShadowElements *se = popupStuff->shadow;
		// Show the 'shadow' just before showing the popup menu window
		// Don't use QWidget::show() so we don't confuse QEffects, thus causing broken focus.
//		if (p->height() >= swh){
		if (se->w1) XMapWindow(qt_xdisplay(), se->w1->winId());
		if (se->w3) XMapWindow(qt_xdisplay(), se->w3->winId());
//		}
//		if (p->width() >= swh)
		if (se->w2) XMapWindow(qt_xdisplay(), se->w2->winId());
	}
	else{ // this is a new shadow, so we have to render it from scratch
		ShadowElements *se = new ShadowElements;
		int leftOffset = 0;
		KPixmap *cleanPix;
		if (popupStuff) {leftOffset = popupStuff->leftOffset; cleanPix = popupStuff->cleanPix;}
		QImage img;
		if (p->height() >= swh){ // right shadows
			QRect *tmpRect;
			QRect shadow1;
			int x2 = p->x()+p->width();
			int x3 = p->x()-leftOffset;
			if (cleanPix){
				shadow1 = QRect(x2, p->y(), cleanPix->width()-p->width()-leftOffset, cleanPix->height());
			}
			else{
				shadow1 = QRect(x2, p->y() + swh, swh, p->height());
			}
			se->w1 = new QWidget(0, 0, WStyle_Customize | WType_Popup | WX11BypassWM );
			se->w1->setGeometry(shadow1);
			// Create a fake drop-down shadow effect via blended Xwindows
			XSelectInput(qt_xdisplay(), se->w1->winId(), StructureNotifyMask );
			// Some hocus-pocus here to create the drop-shadow.
			QPixmap pix_shadow1;
			if (cleanPix){  // we have a proper pixmap to take background information from...
				pix_shadow1.resize(cleanPix->width()-p->width()-leftOffset, cleanPix->height());
				// as the shadows may conflict with the menuindicator, we "reclean" the the clean pix by patching the menuindicator in ;-)
				// if you think of removing this for the right side shadows: remember someone could use kicker on the right side... :}
				if (daddyWasAPopup){
					// obviously, this is also for the left shadows, but we do it a bit before to avoid using unhandled cleanpix!
					QRect tmpRect2 = QRect(x3,p->y(),cleanPix->width(),cleanPix->height());
					if (tmpRect = sharedRect(lastIndicatedMenuItemRect,&tmpRect2)){
						bitBlt(cleanPix,tmpRect->x() - x3, tmpRect->y() - p->y(), lastIndicatedMenuItemPix, tmpRect->x() - lastIndicatedMenuItemRect->x(), tmpRect->y() - lastIndicatedMenuItemRect->y(), tmpRect->width(), tmpRect->height());
					}
				}
				// can't create shadow pixmap before, as cleanpix was just handled
				bitBlt( &pix_shadow1, 0, 0, cleanPix, p->width()+leftOffset, 0, cleanPix->width()-p->width()-leftOffset, cleanPix->height());
				if (daddyWasAPopup){
					if (tmpRect = sharedRect(indicatedMenuItemRect,&shadow1)){
						bitBlt(&pix_shadow1,shadow1.width()-tmpRect->width(),tmpRect->y()-shadow1.y(),indicatedMenuItemPix,/*this will pretty much allways be zero*/tmpRect->x()-indicatedMenuItemRect->x(),/*this will pretty much allways be zero*/ tmpRect->y()-indicatedMenuItemRect->y(),tmpRect->width(),tmpRect->height());
					}
				}
			}
			else{  // ... otherwise we have to take a new (probably ugly) screenshot.
				qWarning("NULL pixmap received for shadows");
				pix_shadow1 = QPixmap::grabWindow(qt_xrootwin(), shadow1.x(), shadow1.y(), shadow1.width(), shadow1.height());
			}
			if (pix_shadow1.width() > 0){
				img = pix_shadow1.convertToImage();
				rightShadow(img, swh);
				KImageEffect::addNoise(img);
				pix_shadow1.convertFromImage(img);
				// Set the background pixmaps
				se->w1->setErasePixmap(pix_shadow1);
				// Show the 'shadow' just before showing the popup menu window
				// Don't use QWidget::show() so we don't confuse QEffects, thus causing broken focus.	
				XMapWindow(qt_xdisplay(), se->w1->winId());
			}
			// and left shadows...
			QRect shadow3;
			if (cleanPix){
				shadow3 = QRect(x3, p->y(), leftOffset, cleanPix->height());
			}
			else{
				shadow3 = QRect(p->x()-swh, p->y() + swh, swh, p->height());
			}
			se->w3 = new QWidget(0, 0, WStyle_Customize | WType_Popup | WX11BypassWM );
			se->w3->setGeometry(shadow3);
			// Create a fake drop-down shadow effect via blended Xwindows
			XSelectInput(qt_xdisplay(), se->w3->winId(), StructureNotifyMask );
			// Some hocus-pocus here to create the drop-shadow.
			QPixmap pix_shadow3;
			if (cleanPix){  // we have a proper pixmap to take background information from...
				pix_shadow3.resize(leftOffset, cleanPix->height());
				bitBlt( &pix_shadow3, 0, 0, cleanPix, 0, 0, leftOffset, cleanPix->height());
				// as the shadows may conflict with the menuindicator, we "reclean" the the clean pix by patching the menuindicator in ;-)
				if (daddyWasAPopup && (tmpRect = sharedRect(indicatedMenuItemRect,&shadow3))){
					bitBlt(&pix_shadow3,shadow3.width()-tmpRect->width(),tmpRect->y()-shadow3.y(),indicatedMenuItemPix,/*this will pretty much allways be zero*/tmpRect->x()-indicatedMenuItemRect->x(),/*this will pretty much allways be zero*/ tmpRect->y()-indicatedMenuItemRect->y(),tmpRect->width(),tmpRect->height());
				}
			}
			else{  // ... otherwise we have to take a new (probably ugly) screenshot.
				qWarning("NULL pixmap received for shadows");
				pix_shadow1 = QPixmap::grabWindow(qt_xrootwin(), shadow3.x(), shadow3.y(), shadow3.width(), shadow3.height());
			}
			if (pix_shadow3.width() > 0){
				img = pix_shadow3.convertToImage();
				leftShadow(img, swh);
				KImageEffect::addNoise(img);
				pix_shadow3.convertFromImage(img);
				// Set the background pixmaps
				se->w3->setErasePixmap(pix_shadow3);
				// Show the 'shadow' just before showing the popup menu window
				// Don't use QWidget::show() so we don't confuse QEffects, thus causing broken focus.	
				XMapWindow(qt_xdisplay(), se->w3->winId());
			}
		}
		if (p->width() >= swh){ // bottom shadows
			QRect shadow2;
			int y2 = p->y()+p->height();
			if (cleanPix){
				shadow2 = QRect(p->x(), y2, p->width(), cleanPix->height()-p->height());
			}
			else{			
				shadow2 = QRect(p->x() + swh, y2, p->width() - swh, swh);
			}			
			se->w2 = new QWidget(0, 0, WStyle_Customize | WType_Popup | WX11BypassWM );
			se->w2->setGeometry(shadow2);
			// Create a fake drop-down shadow effect via blended Xwindows
			XSelectInput(qt_xdisplay(), se->w2->winId(), StructureNotifyMask );
			// Some hocus-pocus here to create the drop-shadow.
			QPixmap pix_shadow2;
			if (cleanPix){  // we have a proper pixmap to take background information from...
				pix_shadow2.resize(p->width(), cleanPix->height()-p->height());
				bitBlt( &pix_shadow2, 0, 0, cleanPix, leftOffset, cleanPix->height()-(cleanPix->height()-p->height()), p->width(), cleanPix->height()-p->height());
			}
			else{  // ... otherwise we have to take a new (probably ugly) screenshot.
				qWarning("NULL pixmap received for shadows");
				pix_shadow2 = QPixmap::grabWindow(qt_xrootwin(), shadow2.x(), shadow2.y(), shadow2.width(), shadow2.height());
			}
			if (pix_shadow2.height() > 0){
				img = pix_shadow2.convertToImage();
				bottomShadow(img, swh);
				KImageEffect::addNoise(img);
				pix_shadow2.convertFromImage(img);
				// Set the background pixmaps
				se->w2->setErasePixmap(pix_shadow2);
				// Show the 'shadow' just before showing the popup menu window
				// Don't use QWidget::show() so we don't confuse QEffects, thus causing broken focus.
				XMapWindow(qt_xdisplay(), se->w2->winId());
			}			
		}
		
		// Insert a new ShadowMap entry
		popupStuff->shadow = se;
		popupStuff->hasShadows = true;
	}
	daddyWasAPopup = false;
}

void OptionHandler::removeShadowWindows(const QPopupMenu* p)
{
	PopupStuff *popupStuff = popupDict.find(p->winId());
	if (popupStuff && popupStuff->shadow)
	{
	ShadowElements *se = popupStuff->shadow;
	if (se->w1)
		XUnmapWindow(qt_xdisplay(), se->w1->winId());	// hide
	if (se->w2)
		XUnmapWindow(qt_xdisplay(), se->w2->winId());
	if (se->w3)
		XUnmapWindow(qt_xdisplay(), se->w3->winId());
	XFlush(qt_xdisplay());							// try to hide faster
	}
}

void OptionHandler::prepareMenus() {
	if ( menusProcessed )
		return ;

	if ( fillPixmap )
		delete fillPixmap;
	fillPixmap = NULL;
	if ( (menuTranslucency == Solid) && stippleMenu ) {
		QColor c( bgColor() );
		fillPixmap = new QPixmap( 32, 32 );
		fillPixmap->fill( c.rgb() );
		int i;
		QPainter painter;
		painter.begin( fillPixmap );
		painter.setPen( c.dark( 103 ) );
		for ( i = 0; i < 32; i += 4 ) {
			painter.drawLine( 0, i, 32, i );
			//            painter.drawLine(0, i+1, 32, i+1);
			}
		painter.end();
		}
	menusProcessed = true;
	}

void OptionHandler::stripePixmap( KPixmap &pix, const QColor &color ) {
	QImage img( pix.convertToImage() );
	if ( img.depth() < 32 )
		img = img.convertDepth( 32 );
	KImageEffect::fade( img, 0.9, color );
	int x, y;
	int r, g, b;
	for ( y = 0; y < img.height(); y += 3 ) {
		unsigned int * data = ( unsigned int * ) img.scanLine( y );
		for ( x = 0; x < img.width(); ++x ) {
			r = qRed( data[ x ] );
			g = qGreen( data[ x ] );
			b = qBlue( data[ x ] );
			r = r - 10 >= 0 ? r - 10 : 0;
			g = g - 10 >= 0 ? g - 10 : 0;
			b = b - 10 >= 0 ? b - 10 : 0;
			data[ x ] = qRgb( r, g, b );
			}
		}
	pix.convertFromImage( img );
	}

void OptionHandler::stripePixmap( KPixmap &pix, const QColor &color, int density )    // density in percent, therefore use 0..100
	{
	density > 100 ? density = 100 : density < 0 ? density = 0 : density = density;
	QImage img( pix.convertToImage() );
	if ( img.depth() < 32 )
		img = img.convertDepth( 32 );
	KImageEffect::fade( img, (float) density / 100, color );
	int x, y;
	int r, g, b;
	for ( y = 0; y < img.height(); y += 3 ) {
		unsigned int * data = ( unsigned int * ) img.scanLine( y );
		for ( x = 0; x < img.width(); ++x ) {
			r = qRed( data[ x ] );
			g = qGreen( data[ x ] );
			b = qBlue( data[ x ] );
			r = r - 10 >= 0 ? r - 10 : 0;
			g = g - 10 >= 0 ? g - 10 : 0;
			b = b - 10 >= 0 ? b - 10 : 0;
			data[ x ] = qRgb( r, g, b );
			}
		}
	pix.convertFromImage( img );
	}

void OptionHandler::renderMenuBlendPixmap( KPixmap *blendPix, QColor c, QPopupMenu *p, int leftOffset ){
	QImage gr = KImageEffect::gradient(QSize(p->width(),4), c.dark(150), c.light(170), KImageEffect::HorizontalGradient );
	QPixmap grT(gr);
	QPainter p2(blendPix);
	p2.drawTiledPixmap(leftOffset,0, p->width(), p->height(), grT);
	p2.end();
}

void OptionHandler::initDropShadows(int swh){
	top_right_corner = new int[swh*swh];
	top_left_corner = new int[swh*swh];
	bottom_right_corner = new int[swh*swh];
	bottom_left_corner = new int[swh*swh];
	shadow_strip = new int[swh];
	double slow = (double)swh / 2.5;
	int dark = dropShadowDarkness;
	for (int i = 0; i < swh; i++){ // top 2 bottom ....
		for (int j = 0; j < swh; j++){ // left 2 right ...
			top_right_corner[swh*i+j] =// pow(-exp(-(((swh-i)+j)/slow)-1)+1,dark); // x = 0 -> inf (swh)
			top_left_corner[swh*i+(swh-1-j)] =  int(pow(-exp(-(((swh-i)+j)/slow)-1)+1,dark) * _SCALE_);
			bottom_right_corner[swh*i+j] =// pow(-exp(-((i+j)/slow)-1)+1,dark);
//			bottom_left_corner[swh*i+j] = pow(-exp(-((i+(swh-j))/slow)-1)+1,dark);
			bottom_left_corner[swh*i+(swh-1-j)] = int(pow(-exp(-((i+j)/slow)-1)+1,dark) * _SCALE_);
		}
		shadow_strip[i] = int(pow(-exp(-(i/slow)-1)+1,dark) * _SCALE_);
	}
	dropShadowsInited = true;
}

bool OptionHandler::eventFilter( QObject *obj, QEvent *ev ) {
	//prepareMenus();
	QPopupMenu * p = ( QPopupMenu * ) obj;
	const int swh = shadowOffset;
	bool secMenuDropShadows = menuDropShadows;// && (p->height() > swh) && (p->width() > swh);
	int leftOffset = swh;

	if ( ev->type() == QEvent::Show ) {
		menuLevelCounter++; // one more menu
		if (secMenuDropShadows && ! dropShadowsInited) initDropShadows(swh);
		KPixmap *cleanPix = NULL;
		PopupStuff *newPopupStuff;
		if (secMenuDropShadows || (menuTranslucency >= DefaultTrans)){
			newPopupStuff = new PopupStuff;
		}
		if ((menuTranslucency >= DefaultTrans)) {
			KPixmap *pix = new KPixmap;
			KPixmap *blendPix;
			KPixmap *blendPixFract;
			QImage blendImg;
			QImage backImg;
			//search ONCE for the old and or current popupstuff
			PopupStuff *popupStuff = popupDict.find(p->winId());
			PopupStuff *oldPopupStuff = popupDict.find(lastPopupID);
			//now either we have it, or not!
			if ( p->testWFlags( Qt::WType_Popup ) ) { // switch these lines for permormance...!
				if (popupStuff){
					//qFadeEffect(p, 500);
					if (secMenuDropShadows) createShadowWindows(p, popupStuff, swh);
					directFollower = false;
					return (false); //skip unnessecary following stuff
				}
				else{
					QRect r( p->x()-swh, p->y(), p->width()+2*swh, p->height()+swh );
					QRect *rShare;
					if (directFollower && oldPopupStuff && oldPopupStuff->pix){
						KPixmap *oldPix;
						if ((menuTranslucency == Gradient || secMenuDropShadows) && oldPopupStuff && oldPopupStuff->cleanPix){
							qWarning("old clean Pix used");
							oldPix = oldPopupStuff->cleanPix;
						}else
							oldPix = oldPopupStuff->pix;
						rShare = sharedRect(&r, &lastPopupRect );

						QRect deskR = QApplication::desktop() ->rect();
						if ( r.right() > deskR.right()) r.setRight( deskR.right() );
						if ( r.left() < deskR.left()){leftOffset = swh - (deskR.left()-r.left()) ;r.setLeft( deskR.left() );}
						if (r.bottom() > deskR.bottom() ) r.setBottom( deskR.bottom() );

						QApplication::syncX();
						*pix = QPixmap::grabWindow( qt_xrootwin(), r.x(), r.y(), r.width(), r.height());
						if (menuTranslucency == Gradient || secMenuDropShadows){
							cleanPix = new KPixmap(*pix);
						}
						if (menuTranslucency == Gradient){
							blendPix = (KPixmap *)(new QPixmap(pix->width(), pix->height()));
							renderMenuBlendPixmap( blendPix, useCustomMenuColor ? color : bgColor(), p, leftOffset );
						}

						if (rShare /*&& rShare->width()*rShare->height() > ??? (for speed optimization, it could be useful to precheck if the following work is worth it)*/){
/*
						Now we want to fract the grabbed Pixmap, depending on the shared rect.
						There can be a maximum of 5 fracts (OK, if we were gtkRadiant, there could be severel thousands and thousands :) - Don't take this serious: fracting in gtkRadiant is a bit more complex than this...
						A possible fraction can be like this:
								|---------------------------------------------------------------|
								|			top					|
								|---------------------------------------------------------------|
								|	l	|				|	r	|
								|	e	|	center			|	i	|
								|	f	|	(this is rShare!)	|	g	|
								|	t	|				|	h	|
								|-----------------------------------------------|	t	|
								|		bottom				|		|
								---------------------------------------------------------------
						So all we have to do, is checking if the different sections exist and if so, transform them and copy them to the resulting pixmap
*/
							QPainter icyApainter;
//							QPainter icyAnotherpainter;
							KPixmap *tmpFractPix;
							int topHeight = 0, rightWidth = 0, bottomHeight = 0, leftWidth = 0;
							tmpFractPix = (KPixmap *)(new QPixmap(rShare->width(), rShare->height())); // as there IS a share, we start with this!
							bitBlt( tmpFractPix, 0, 0, oldPix, rShare->x() - lastPopupRect.x(), rShare->y() - lastPopupRect.y(), rShare->width(), rShare->height());
							if (menuTranslucency == Gradient || secMenuDropShadows){
								// first clean the new Pix
								icyApainter.begin( cleanPix );
								icyApainter.drawPixmap(rShare->x() - (p->x()-leftOffset),rShare->y() - p->y(),*tmpFractPix);
								icyApainter.end();
								// then store our new clean pixmap
								newPopupStuff->cleanPix = cleanPix;
							}
							if (menuTranslucency == Gradient){
								icyApainter.begin( pix );
								icyApainter.drawPixmap(rShare->x() - (p->x()-leftOffset),rShare->y() - p->y(),*tmpFractPix);
								icyApainter.end();
								if (opacity < 10){
									// blend me
									blendImg = blendPix->convertToImage();
									backImg  = pix->convertToImage();
									KImageEffect::blend(blendImg, backImg, (( float ) opacity )  * 0.1);
									pix->convertFromImage(backImg); // tmpFractPix should now be fractpart blended
								}
								else 
									pix = blendPix;
								newPopupStuff->pix = pix;
								newPopupStuff->leftOffset = leftOffset;
								popupDict.insert(p->winId(),newPopupStuff);
								//qFadeEffect(p, 500);
								if (secMenuDropShadows) createShadowWindows(p, newPopupStuff, swh);
								// fracting is slow for gradients because of the pixmap-image converter function
								// as fracting also doesn't improve anythig for gradients: out here
								directFollower = false;
								return (false);
							}
							if (menuTranslucency == Gradient || secMenuDropShadows)
								oldPix = oldPopupStuff->pix;
							bitBlt( tmpFractPix, 0, 0, oldPix, rShare->x() - lastPopupRect.x(), rShare->y() - lastPopupRect.y(), rShare->width(), rShare->height());
							icyApainter.begin( pix );
							icyApainter.drawPixmap(rShare->x() - (p->x()-leftOffset),rShare->y() - p->y(),*tmpFractPix);

							if (rShare->y() > p->y()){ // top fract, as (0,0) is upper left corner
								delete tmpFractPix;
								tmpFractPix = (KPixmap *)(new QPixmap(p->width()+leftOffset+swh, topHeight = rShare->y() - p->y()));
								bitBlt( tmpFractPix, 0, 0, pix, 0, 0, p->width()+leftOffset+swh, topHeight);

								if (stippleMenu){
									if (menuTranslucency == CustomTrans)
										stripePixmap(*tmpFractPix, useCustomMenuColor ? color : bgColor(), opacity * 10);
									else
										stripePixmap( *tmpFractPix, useCustomMenuColor ? color : bgColor() );
								}
								else {
									if (menuTranslucency == CustomTrans)
										KPixmapEffect::fade( *tmpFractPix, (  ( float ) opacity )  * 0.1, useCustomMenuColor ? color : bgColor() );
									else
										KPixmapEffect::fade( *tmpFractPix, 0.9, useCustomMenuColor ? color : bgColor() );
								}
								icyApainter.drawPixmap(0, 0, *tmpFractPix);
							}

							if (p->x() + p->width()+swh > rShare->x() + rShare->width()){ // right fract
								delete tmpFractPix;
								tmpFractPix = (KPixmap *)(new QPixmap(rightWidth = (p->x() + p->width() + swh) - (rShare->x() + rShare->width()), p->height() + swh - topHeight));
								bitBlt( tmpFractPix, 0, 0, pix, p->width() + leftOffset+swh - rightWidth, topHeight, rightWidth, p->height() + swh - topHeight);


								if (stippleMenu){
									if (menuTranslucency == CustomTrans)
										stripePixmap(*tmpFractPix, useCustomMenuColor ? color : bgColor(), opacity * 10);
									else
										stripePixmap( *tmpFractPix, useCustomMenuColor ? color : bgColor() );
								}
								else {
									if (menuTranslucency == CustomTrans)
										KPixmapEffect::fade( *tmpFractPix, (  ( float ) opacity )  * 0.1, useCustomMenuColor ? color : bgColor() );
									else
										KPixmapEffect::fade( *tmpFractPix,  0.9, useCustomMenuColor ? color : bgColor() );
								}
								icyApainter.drawPixmap(p->width() + leftOffset+swh - rightWidth, topHeight, *tmpFractPix);
							}

							if (p->y() + p->height() + swh > rShare->y() + rShare->height()){ // bottom fract
								delete tmpFractPix;
								tmpFractPix = (KPixmap *)(new QPixmap(p->width() + leftOffset+swh - rightWidth, bottomHeight = p->height() + swh - topHeight - rShare->height()));
								bitBlt( tmpFractPix, 0, 0, pix, 0, topHeight + rShare->height(), p->width() + leftOffset+swh - rightWidth, bottomHeight);

								if (stippleMenu){
									if (menuTranslucency == CustomTrans)
										stripePixmap(*tmpFractPix, useCustomMenuColor ? color : bgColor(), opacity * 10);
									else
										stripePixmap( *tmpFractPix, useCustomMenuColor ? color : bgColor() );
								}
								else {
									if (menuTranslucency == CustomTrans)
										KPixmapEffect::fade( *tmpFractPix, (  ( float ) opacity )  * 0.1, useCustomMenuColor ? color : bgColor() );
									else
										KPixmapEffect::fade( *tmpFractPix, 0.9, useCustomMenuColor ? color : bgColor() );
								}
								icyApainter.drawPixmap(0, p->height() + swh - bottomHeight, *tmpFractPix);
							}

							if (rShare->x() > p->x()){ // left fract
								delete tmpFractPix;
								tmpFractPix = (KPixmap *)(new QPixmap(leftWidth = rShare->x() - (p->x()-swh), rShare->height()));
								bitBlt( tmpFractPix, 0, 0, pix, 0, topHeight, leftWidth, rShare->height());

								if (stippleMenu){
									if (menuTranslucency == CustomTrans)
										stripePixmap(*tmpFractPix, useCustomMenuColor ? color : bgColor(), opacity * 10);
									else
										stripePixmap( *tmpFractPix, useCustomMenuColor ? color : bgColor() );
								}
								else {
									if (menuTranslucency == CustomTrans)
										KPixmapEffect::fade( *tmpFractPix, (  ( float ) opacity )  * 0.1, useCustomMenuColor ? color : bgColor() );
									else
										KPixmapEffect::fade( *tmpFractPix, 0.9, useCustomMenuColor ? color : bgColor() );
								}
								icyApainter.drawPixmap(0, topHeight, *tmpFractPix);
							}

							icyApainter.end();
						}
						else{
							if (menuTranslucency == Gradient || secMenuDropShadows)
								cleanPix = new KPixmap(*pix);
							if (menuTranslucency == Gradient){
								blendImg = blendPix->convertToImage();
								backImg  = pix->convertToImage();
								KImageEffect::blend(blendImg, backImg, (( float ) opacity )  * 0.1);
								pix->convertFromImage(backImg); // pix should now be blended
							}
							else if (stippleMenu){
								if (menuTranslucency == CustomTrans)
									stripePixmap(*pix, useCustomMenuColor ? color : bgColor(), opacity * 10);
								else
									stripePixmap( *pix, useCustomMenuColor ? color : bgColor() );
							}
							else {
								if (menuTranslucency == CustomTrans)
									KPixmapEffect::fade( *pix, (  ( float ) opacity )  * 0.1, useCustomMenuColor ? color : bgColor() );
								else
									KPixmapEffect::fade( *pix, 0.9, useCustomMenuColor ? color : bgColor() );
							}
						}
					}
					else{
						QRect deskR = QApplication::desktop() ->rect();
						if ( r.right() > deskR.right()) r.setRight( deskR.right() );
						if ( r.left() < deskR.left()){leftOffset = swh - (deskR.left()-r.left()) ;r.setLeft( deskR.left() );}
						if (r.bottom() > deskR.bottom() ) r.setBottom( deskR.bottom() );

						QApplication::syncX();
						*pix = QPixmap::grabWindow( qt_xrootwin(), r.x(), r.y(), r.width(), r.height() );
						if (menuTranslucency == Gradient || secMenuDropShadows)
							cleanPix = new KPixmap(*pix);
						if (menuTranslucency == Gradient){
							blendPix = (KPixmap *)(new QPixmap(pix->width(), pix->height()));
							renderMenuBlendPixmap( blendPix, useCustomMenuColor ? color : bgColor(), p, leftOffset);
							blendImg = blendPix->convertToImage();
							backImg  = pix->convertToImage();
							KImageEffect::blend(blendImg, backImg, (( float ) opacity )  * 0.1);
							pix->convertFromImage(backImg); // pix should now be blended
						}
						else if (stippleMenu){
							if (menuTranslucency == CustomTrans)
								stripePixmap(*pix, useCustomMenuColor ? color : bgColor(), opacity * 10);
							else
								stripePixmap( *pix, useCustomMenuColor ? color : bgColor() );
						}
						else {
							if (menuTranslucency == CustomTrans)
								KPixmapEffect::fade( *pix, (  ( float ) opacity )  * 0.1, useCustomMenuColor ? color : bgColor() );
							else
								KPixmapEffect::fade( *pix, 0.9, useCustomMenuColor ? color : bgColor() );
						}
					}
				}
				if (menuTranslucency == Gradient || secMenuDropShadows){
					newPopupStuff->cleanPix = cleanPix;
				}
				if (popupDict.count() == 499) {popupDict.setAutoDelete(true);popupDict.clear();currentPopupWinID=-1;currentPopup = NULL;lastIndicatedMenuItemID = -1;}
				newPopupStuff->pix = pix;
				newPopupStuff->leftOffset = leftOffset;
				popupDict.insert( p->winId(), newPopupStuff );
				//qFadeEffect(p, 500);
				if (secMenuDropShadows) createShadowWindows(p, newPopupStuff, swh);
			}
			//==============================================================================
			else{ // tear off menu
				pix = (KPixmap *)(new QPixmap(p->width(), p->height()));
				if (menuTranslucency == Gradient){
				renderMenuBlendPixmap( pix, useCustomMenuColor ? color : bgColor(), p, leftOffset);
				}
				else if (stippleMenu){
					pix->fill( Qt::black.rgb() );
					if (menuTranslucency == CustomTrans)
						stripePixmap(*pix, useCustomMenuColor ? color : bgColor(), opacity * 10);
					else
						stripePixmap( *pix, useCustomMenuColor ? color : bgColor() );
				}
				else {
					pix->fill( Qt::black.rgb() );
					if (menuTranslucency == CustomTrans)
						KPixmapEffect::fade( *pix, (  ( float ) opacity )  * 0.1, useCustomMenuColor ? color : bgColor() );
					else
						KPixmapEffect::fade( *pix, 0.9, useCustomMenuColor ? color : bgColor() );
				}
				if (popupDict.count() == 499) {popupDict.setAutoDelete(true);popupDict.clear();currentPopupWinID=-1;currentPopup = NULL;lastIndicatedMenuItemID = -1;}
				newPopupStuff->pix = pix;
				newPopupStuff->leftOffset = leftOffset;
				popupDict.insert( p->winId(), newPopupStuff );
			}
			//======================================================================================
		}
		else if (secMenuDropShadows){ // solid with dropshadows (need buffering / offscreenbuffercleaning - sorry)
			QRect r( p->x()-swh, p->y(), p->width()+2*swh, p->height()+swh );
			cleanPix = new KPixmap;
			PopupStuff *oldPopupStuff = popupDict.find(lastPopupID);
			QRect deskR = QApplication::desktop() ->rect();
			leftOffset = swh;
			if ( r.right() > deskR.right()) r.setRight( deskR.right() );
			if ( r.left() < deskR.left()){leftOffset = swh - (deskR.left()-r.left()) ;r.setLeft( deskR.left() );}
			if (r.bottom() > deskR.bottom() ) r.setBottom( deskR.bottom() );
			QApplication::syncX();
			*cleanPix = QPixmap::grabWindow( qt_xrootwin(), r.x(), r.y(), r.width(), r.height());
			if (oldPopupStuff && oldPopupStuff->cleanPix){
				KPixmap *oldPix = oldPopupStuff->cleanPix;
				QRect *rShare = sharedRect(&r, &lastPopupRect );
				if (rShare){
					KPixmap *tmpFractPix = (KPixmap *)(new QPixmap(rShare->width(), rShare->height()));
					bitBlt( tmpFractPix, 0, 0, oldPix, rShare->x() - lastPopupRect.x(), rShare->y() - lastPopupRect.y(), rShare->width(), rShare->height());
					// first clean the new Pix
					QPainter icyApainter;
					icyApainter.begin( cleanPix );
					icyApainter.drawPixmap(rShare->x() - (p->x()-leftOffset),rShare->y() - p->y(),*tmpFractPix);
					icyApainter.end();
				}
			}
			// then store our new clean pixmap
			if (popupDict.count() == 499) {popupDict.setAutoDelete(true);popupDict.clear();currentPopup = NULL; lastIndicatedMenuItemID = -1;}
			newPopupStuff->cleanPix = cleanPix;
			newPopupStuff->leftOffset = leftOffset;
// 			if (menuTranslucency == SolidGradient) {
// 				newPopupStuff->pix = (KPixmap *)(new QPixmap(r.width(), r.height()));
// 				renderMenuBlendPixmap( newPopupStuff->pix, useCustomMenuColor ? color : bgColor(), p, leftOffset );
// 			}
			popupDict.insert( p->winId(), newPopupStuff );
			//qFadeEffect(p, 500);
			createShadowWindows(p, newPopupStuff, swh);
		}
		directFollower = false;
	}
	else if ( ev->type() == QEvent::Hide ) {
		if ( (menuTranslucency >= DefaultTrans) || secMenuDropShadows) {
			menuLevelCounter--;
			lastPopupID = p->winId();
			QRect deskR = QApplication::desktop() ->rect();
			int tmp = p->x() - deskR.x();
			leftOffset = (tmp  > swh ? swh : tmp);
			lastPopupRect = QRect( p->x()-leftOffset, p->y(), p->width() + leftOffset+swh, p->height() + swh);
   			if (secMenuDropShadows) removeShadowWindows(p);
			if (menuLevelCounter <= 0 && !menuItemActive ){
				popupDict.setAutoDelete(true);
				popupDict.clear();
				currentPopupWinID = -1;
				currentPopup = NULL;
				lastPopupID = -1;
				lastIndicatedMenuItemID = -1;
				indicatedMenuItemRect->setRect(0,0,0,0);
				lastIndicatedMenuItemRect->setRect(0,0,0,0);
				qWarning("popoup cleared! (1)");
			}
		}
		directFollower = true;
	}
	else if ( ev->type() == QEvent::ApplicationPaletteChange ) {
		if ( (menuTranslucency >= DefaultTrans)) {
			/*            QBrush brush(bgColor(), *bgPixmap());
			            QPalette pal = p->palette();
			            pal.setBrush(QColorGroup::Background, brush);
			            p->setPalette(pal);*/
			p->hide();
		}
		else if ( stippleMenu && (menuTranslucency == Solid) ) {
			prepareMenus();
			QBrush brush( bgColor(), *bgPixmap() );
			QPalette pal = p->palette();
			pal.setBrush( QColorGroup::Background, brush );
			p->setPalette( pal );
		}
		else if ( (menuTranslucency == Solid) && !stippleMenu ) {
			prepareMenus();
			QBrush brush( bgColor() );
			QPalette pal = p->palette();
			pal.setBrush( QColorGroup::Background, brush );
			p->setPalette( pal );
		}
	}
	return ( false );
}

/*returns congruent area of r1 and r2 - or NULL*/
QRect *OptionHandler::sharedRect(QRect *r1, QRect *r2){
	if (!(r1 && r2)) return NULL;
	QRect *r = new QRect;
	int x2,y2;
	(r1->x() >= r2->x()) ? r->setX(r1->x()) : r->setX(r2->x());
	(r1->y() >= r2->y()) ? r->setY(r1->y()) : r->setY(r2->y());
	(r1->y() + r1->height() <= r2->y() + r2->height()) ? y2 = r1->y() + r1->height() : y2 = r2->y() + r2->height();
	if (y2 <= r->y())
		return NULL;
	else
		r->setHeight(y2 - r->y()); // first cause it'll probably happen more often (kicker!)
	(r1->x() + r1->width() <= r2->x() + r2->width()) ? x2 = r1->x() + r1->width() : x2 = r2->x() + r2->width();
	if (x2 <= r->x())
		return NULL;
	else
		r->setWidth(x2 - r->x());
	return r;
}



LiquidStyle::LiquidStyle() : KStyle( /*AllowMenuTransparency |*/ FilledFrameWorkaround, ThreeButtonScrollBar ) {
	headerHoverID = -1;
	highlightWidget = NULL;
	currentTaskContainer = NULL;
	taskContainerHover = false;
	isTaskContainer = false;
	isHTMLButton = false;
	inExitPolish = false;

	btnDict.setAutoDelete( true );
	btnShadowedDict.setAutoDelete( true );
	bevelFillDict.setAutoDelete( true );
	smallBevelFillDict.setAutoDelete( true );
//	inverseTabDict.setAutoDelete( true );
//	tabDict.setAutoDelete( true );
	initialPaletteLoaded = false;
	qtrcModificationTime = 0;
	
	// animations kram!
	progAnimShift = 0;
	prog2AnimShift = 0;
	sliderAnimShift = 0;
	QTimer* timer = new QTimer( this );
	timer->start(50, false);
	connect(timer, SIGNAL(timeout()), this, SLOT(updateProgressPos()));
	connect(timer, SIGNAL(timeout()), this, SLOT(updateSliderPos()));
	activeScroller = NULL;
//	activeProgress = NULL;
	//--------------------------------------

	tooltipPalette = qApp->palette();
	tooltipPalette.setBrush( QColorGroup::Background, QColor( 255, 255, 220 ) );
	tooltipPalette.setBrush( QColorGroup::Foreground, Qt::black );

	rMatrix.rotate( 90.0 );
	lMatrix.rotate( 270.0 );
	iMatrix.rotate( 180.0 );
	btnBorderImg = new QImage( liquid_findImage( "button-base" ) );
	if ( btnBorderImg->depth() < 32 )
		* btnBorderImg = btnBorderImg->convertDepth( 32 );
	btnShadowImg = new QImage( liquid_findImage( "button-shadow" ) );
	if ( btnShadowImg->depth() < 32 )
		* btnShadowImg = btnShadowImg->convertDepth( 32 );

	slider_top = new QImage( liquid_findImage( "sbslider_top" ) );
	if ( slider_top->depth() < 32 )
		* slider_top = slider_top->convertDepth( 32 );

	slider_btm = new QImage( liquid_findImage( "sbslider_btm" ) );
	if ( slider_btm->depth() < 32 )
		* slider_btm = slider_btm->convertDepth( 32 );

	slider_top_shd = new QImage( liquid_findImage( "sbslider_top_shd" ) );
	if ( slider_top_shd->depth() < 32 )
		* slider_top_shd = slider_top_shd->convertDepth( 32 );

	slider_btm_shd = new QImage( liquid_findImage( "sbslider_btm_shd" ) );
	if ( slider_btm_shd->depth() < 32 )
		* slider_btm_shd = slider_btm_shd->convertDepth( 32 );

	rectbutton = new QImage( liquid_findImage( "rectbutton" ) );
	if ( rectbutton->depth() < 32 )
		* rectbutton = rectbutton->convertDepth( 32 );

 	combo = new QImage( liquid_findImage( "combo" ) );
	if ( combo->depth() < 32 )
		* combo = combo->convertDepth( 32 );

	comboShadow = new QImage( liquid_findImage( "combo-shadow" ) );
	if ( comboShadow->depth() < 32 )
		* comboShadow = comboShadow->convertDepth( 32 );

	buttonGlow = new QImage( liquid_findImage( "button-glow" ) );
	if ( buttonGlow->depth() < 32 )
		* buttonGlow = buttonGlow->convertDepth( 32 );

	bevelFillPix = new QPixmap;
	bevelFillPix->convertFromImage( liquid_findImage( "clear_fill_large" ) );

	smallBevelFillPix = new QPixmap;
	smallBevelFillPix->convertFromImage( liquid_findImage( "clear_fill_small" ) );

	menuPix = NULL;
	tmpBtnPix = NULL;

	optionHandler = new OptionHandler( this );

	int i;
	for ( i = 0; i < BITMAP_ITEMS; ++i ) {
		pixmaps[ i ] = NULL;
		}

	sbLeft = new QBitmap( 7, 7, sbarrow_left_bits, true );
	sbLeft->setMask( *sbLeft );
	sbRight = new QBitmap( 7, 7, sbarrow_right_bits, true );
	sbRight->setMask( *sbRight );
	sbUp = new QBitmap( 7, 7, sbarrow_up_bits, true );
	sbUp->setMask( *sbUp );
	sbDown = new QBitmap( 7, 7, sbarrow_down_bits, true );
	sbDown->setMask( *sbDown );

	isKicker = ( qstrcmp( qApp->argv() [ 0 ], "kicker" ) == 0 ) ||
	           ( qstrcmp( qApp->argv() [ 0 ], "appletproxy" ) == 0 );

	groupShadow = new QPixmap( 64, 64 );
	//    QColor c((w->palette()).active().background());
	QColor c;// = optionHandler->bgColor();
	( optionHandler->MenuColorButton()) ? c = QColor( optionHandler->buttonColor() ) : c = QColor( optionHandler->bgColor() );
	groupShadow->fill( ( c.dark( 100 + optionHandler->ShadowDarkness() ) ).rgb() );
	if ( optionHandler->useBgStipple() ) {
		QPainter p;
		p.begin( groupShadow );
		p.setPen( c.dark( 100 + optionHandler->ShadowDarkness() + optionHandler->stippleContrast() ) );
		for ( int i = 0; i < 63; i += 4 ) {
			p.drawLine( 0, i, 63, i );
			p.drawLine( 0, i + 1, 63, i + 1 );
		}
		//    p.~QPainter();
	}
}

LiquidStyle::~LiquidStyle() {
//	btnDict.setAutoDelete(true);
	btnDict.clear();
//	btnShadowedDict.setAutoDelete(true);
	btnShadowedDict.clear();
//	buttonGlowDict.setAutoDelete(true);
	buttonGlowDict.clear();
//	comboDict.setAutoDelete(true);
	comboDict.clear();
//	comboShadowedDict.setAutoDelete(true);
	comboShadowedDict.clear();
//	if (! tabDict.isEmpty()) tabDict.clear();
//	if (! inverseTabDict.isEmpty()) inverseTabDict.clear();
//	rectBtnDict.setAutoDelete(true);
	rectBtnDict.clear();
//	bevelFillDict.setAutoDelete(true);
	bevelFillDict.clear();
//	smallBevelFillDict.setAutoDelete(true);
	smallBevelFillDict.clear();
//	progress2Dict.setAutoDelete(true);
	progress2Dict.clear();

	delete optionHandler;

	delete sbUp;
	delete sbDown;
	delete sbLeft;
	delete sbRight;


	if ( btnBorderImg )
		delete btnBorderImg;
	if ( btnShadowImg )
		delete btnShadowImg;

	if ( tmpBtnPix )
		delete tmpBtnPix;

	if ( bevelFillPix )
		delete bevelFillPix;

	if ( smallBevelFillPix )
		delete smallBevelFillPix;

	if ( menuPix )
		delete menuPix;

	int i;
	for ( i = 0; i < BITMAP_ITEMS; ++i ) {
		if ( pixmaps[ i ] )
			delete pixmaps[ i ];
		}
	if ( groupShadow )
		delete groupShadow;

	}
	
void inline LiquidStyle::updateProgressPos()
{
	progAnimShift++;
	prog2AnimShift++;
	if (progAnimShift == 20)
		progAnimShift = 0;
	if (prog2AnimShift == 38)
		prog2AnimShift = 0;
}

void inline LiquidStyle::updateSliderPos(){
	sliderAnimShift++;
	if (sliderAnimShift == 32)
		sliderAnimShift = 0;
}

bool LiquidStyle::isPlain() const {
	return ( !optionHandler->useBgStipple() );
	}


void LiquidStyle::drawPrimitive( PrimitiveElement pe, QPainter *p,
                                 const QRect &r, const QColorGroup &cg,
                                 SFlags flags, const QStyleOption &opt ) const {
	bool down = flags & Style_Down;
	bool on = flags & Style_On;

	switch ( pe ) {
			case PE_TabBarBase: {
				optionHandler->IcyButtons() ? p->setPen( /*cg.button().light(120)*/cg.background().dark(160)) : p->setPen( cg.button().dark( 158 ) );
				p->drawLine( r.x()+1, r.y(), r.right() - 1, r.y() );
				p->drawLine( r.x(), r.y()+1, r.x(), r.bottom() );

				p->drawLine( r.right(), r.y() + 1, r.right(), r.bottom() );
				optionHandler->IcyButtons() ? p->setPen( cg.button().light( 130) ) : p->setPen( cg.button().dark( 110 ) );
				p->drawLine( r.x() + 1, r.y() + 1, r.right() - 1, r.y() + 1 );
				p->drawLine( r.x() + 1, r.y() + 3, r.right() - 1, r.y() + 3 );
				optionHandler->IcyButtons() ? p->setPen( cg.button().light( 140) ) : p->setPen( cg.button().light( 110 ) );
				p->drawLine( r.x() + 1, r.y() + 2, r.right() - 1, r.y() + 2 );
				optionHandler->IcyButtons() ? p->setPen( cg.background().dark( 130 ) ) : p->setPen( cg.button().dark( 158 ) );
				p->drawLine( r.x(), r.bottom(), r.right(), r.bottom() );
				break;
				}
			case PE_ButtonCommand:
			case PE_ButtonDefault: {
				bool sunken = on || down;
				bool hover = flags & Style_MouseOver;
				bool focused = flags & Style_HasFocus;

				QColor newColor;
				if ( ( optionHandler->InactiveButtonColorType() == 2 ) || cg.button() != qApp->palette().active().button() )
					newColor = sunken ? cg.button().dark( 110 ) :
					           hover ? cg.button().light( 120 ) :
					           focused ? optionHandler->InactiveButtonColor() : cg.button();
				else {
					newColor = sunken ? cg.button().dark( 110 ) : hover ? cg.button() :
					           focused ? cg.button() : /*cg.background()*/ optionHandler->InactiveButtonColor();

					}
/*				if ((flags & Style_Horizontal)){
				drawRectangularButton( p, newColor, r.x(), r.y(), r.width(), r.height(), sunken, hover, false);
				break;
				}*/
				if (optionHandler->ForceRectButton())
					drawRoundButton( p, cg, newColor, /*optionHandler->InactiveButtonColor()*/cg.background(), r.x(), r.y(), r.width(), r.height(), false, sunken, hover, false, true);
				else if ( !isPlain() && !isHTMLButton )
					drawRoundButton( p, cg, newColor, cg.background(), r.x(), r.y(), r.width(), r.height(), !isHTMLButton, sunken, hover, false, isHTMLButton, btnOffset.x(), btnOffset.y() );
//				drawCombo( p, cg, newColor, r.x(), r.y(), r.width(), r.height(), sunken, hover, false, full);
				else
					drawRoundButton( p, cg, newColor, /*optionHandler->InactiveButtonColor()*/cg.background(), r.x(), r.y(), r.width(), r.height(), !isHTMLButton, sunken, hover, false, isHTMLButton);
				break;
				}
			case PE_ButtonBevel:
			case PE_ButtonDropDown: {
				bool sunken = on || down;
				bool hover = flags & Style_MouseOver;
//				drawClearBevel( p, r.x(), r.y(), r.width(), r.height(), sunken ? cg.button().dark( 110 ) : hover ? cg.button() : optionHandler->InactiveButtonColor(), cg.background() );
				drawRectangularButton( p, sunken ? cg.button().dark( 110 ) : hover ? cg.button() : optionHandler->InactiveButtonColor(), r.x(), r.y(), r.width(), r.height(), sunken, hover, false);
				break;
				}
			case PE_ButtonTool: {
				bool sunken = on || down;
				bool hover = flags & Style_MouseOver;
//				drawClearBevel( p, r.x(), r.y(), r.width(), r.height(), sunken ? cg.button().dark( 110 ) : hover ? cg.button() : cg.background(), cg.background() );
				drawRectangularButton( p, sunken ? cg.button().dark( 110 ) : hover ? cg.button() : optionHandler->InactiveButtonColor(), r.x(), r.y(), r.width(), r.height(), sunken, hover, false);
//				drawCombo( p, cg, sunken ? cg.button().dark( 110 ) : hover ? cg.button() : optionHandler->InactiveButtonColor(), r.x(), r.y(), r.width(), r.height(), sunken, hover, false );
				/*        drawRoundButton(p, r.x(), r.y(), r.width(), r.height(),
				                       sunken ? cg.button().dark(110) : hover ? cg.button() :
				                       cg.background(), cg.background());*/
				/*	drawRoundButton(p, cg, sunken ? cg.button().dark(110) : hover ? cg.button() : cg.background(), cg.background(),
				                                  r.x(), r.y(), r.width(), r.height(),
				                                  !isHTMLButton, sunken, false, isHTMLButton, btnOffset.x(), btnOffset.y());*/
				break;
				}
			case PE_HeaderSection: {
				bool sunken = on || down;
				bool hover = flags & Style_MouseOver;
				QPen oldpen(p->pen());
				if ( isTaskContainer ) { // kicker?
					if (optionHandler->SmoothListViewHeaders()){
						drawCombo( p, cg, sunken ? cg.button() : taskContainerHover ? cg.button().light( 110 ) : origPanelBrush.color(), r.x(), r.y(), r.width(), isKicker ? r.height() + 2 : r.height(), sunken, hover, false, optionHandler->SmootherLVH() ? full : center );
						if (isKicker && !optionHandler->SmootherLVH()){
						p->setPen(cg.background().dark(150));
						p->drawRect(r.x(), r.y(), r.width(), r.height());
							if (sunken){
								p->setPen(cg.background().dark(200));
								p->drawRect(r.x()+1, r.y()+1, r.width()-2, r.height()-2);
							}
						}
					}
					else
						drawRectangularButton( p, sunken ? cg.background() : taskContainerHover ? cg.background().light( 110 ) : origPanelBrush.color(), r.x(), r.y(), r.width(), r.height(), sunken, hover, false);
					const_cast<LiquidStyle*>( this ) ->isTaskContainer = false;
					const_cast<LiquidStyle*>( this ) ->taskContainerHover = false;
					}
				else {
					if ( currentHeader == p->device() ) {
						int id = currentHeader->sectionAt( r.x() );
						hover = id != -1 && id == headerHoverID;
						}
					if (optionHandler->SmoothListViewHeaders()){
						drawCombo( p, cg, sunken ? cg.button().dark( 110 ) : hover ? cg.button() : optionHandler->InactiveButtonColor(), r.x(), r.y(), r.width(), r.height(), sunken, hover, false, center);
					}
					else
						drawRectangularButton( p, sunken ? cg.button().dark( 110 ) : hover ? cg.button() : optionHandler->InactiveButtonColor(), r.x(), r.y(), r.width(), r.height(), sunken, hover, false);
					}
				p->setPen(oldpen);
				break;
				}
			case PE_FocusRect: {
				p->drawWinFocusRect( r );
				break;
				}
			/**********************************************************************************************************
			*********************Scrollbar****************************************************************************
			***********************************************************************************************************/
			case PE_ScrollBarSlider:
			case PE_ScrollBarAddPage:
			case PE_ScrollBarSubPage: {
				QColor sbBgColor = optionHandler->useCustomColors() ?
				                   optionHandler->customColor( CustomSBGroove ) :
				                   isKicker ? origPanelBrush.color() :
				                   qApp->palette().active().background();

				QPixmap *bgPix = bevelFillDict.find( sbBgColor.rgb() );
				if ( !bgPix ) {
					bgPix = new QPixmap( *bevelFillPix );
					adjustHSV( *bgPix, sbBgColor );
					const_cast<LiquidStyle*>( this ) ->bevelFillDict.insert( sbBgColor.rgb(),
					        bgPix );
					}
				//	QWidget* helpWidget = (QWidget*)(currentScrollBar->parent());
				bool isActive = optionHandler->ScrollerActive();
				bool isHover =    /*highlightWidget == */currentScrollBar->hasMouse();
				//bool isPressed = ( flags & Style_Active ) || ( flags & Style_Down );
				bool isPressed = currentScrollBar->draggingSlider();
				
				// horizontal slider
				if ( flags & Style_Horizontal ) {
					int extent = currentScrollBar->height();
					QRect bgR( extent, 0, currentScrollBar->width() - extent * 3 + 1,
					           extent );
					if ( sbBuffer.size() != currentScrollBar->size() )
						const_cast<LiquidStyle*>( this ) ->
						sbBuffer.resize( currentScrollBar->size() );
					QPainter painter;
					painter.begin( &sbBuffer );
					// pixmaps
					painter.drawPixmap( bgR.x(), bgR.y() + 1, *getPixmap( HSBSliderBtmBg ) );
					painter.drawTiledPixmap( bgR.x() + 8, bgR.y() + 1, bgR.width() - 16, 13, *getPixmap( HSBSliderMidBg ) );
					painter.drawPixmap( bgR.right() - 8, bgR.y() + 1, *getPixmap( HSBSliderTopBg ) );
					
					// lines
//					painter.setPen( sbBgColor.light( 105 ) );
//					painter.drawLine( bgR.x()+8, bgR.y() + 1, bgR.right()-16, bgR.y() + 1);
					painter.setPen( sbBgColor.dark( 110 ) );
					painter.drawLine( bgR.x(), bgR.y(), bgR.right(), bgR.y());
					painter.drawLine( bgR.x(), bgR.bottom(), bgR.right(), bgR.bottom());


					if ( pe == PE_ScrollBarSlider ) {
					int offset = isPressed * ( optionHandler->squeezeSbSlider()*1 + optionHandler->shadowSbSlider()*2);
					int offset3 = optionHandler->shadowSbSlider()*2;
					int offset4 = (isPressed && optionHandler->squeezeSbSlider())*1;

						painter.drawPixmap( r.x() + offset, r.y() + 1,
						                    isPressed ? *getPixmap( HSBSliderBtmPressed ) :
//						                    isHover ? *getPixmap( HSBSliderBtmHover ) :
								    (isHover || isActive) ? *getPixmap( HSBSliderBtmActive ) :
						                    *getPixmap( HSBSliderBtm));
    
						painter.drawPixmap( r.right() - 6 - offset3 - offset4, r.y() + 1,
						                    isPressed ? *getPixmap( HSBSliderTopPressed ) :
//						                    isHover ? *getPixmap( HSBSliderTopHover ) :
								    (isHover || isActive) ? *getPixmap( HSBSliderTopActive ) :
						                    *getPixmap( HSBSliderTop ) );
						// mid part last, as i have to redefine clip section
						painter.setClipRect(r.x() + 7 + offset3 + offset4, r.y() + 1, r.width() - 14 - 2*offset3 - 2*offset4, 13, QPainter::CoordPainter);
						painter.drawTiledPixmap( r.x() + 7 + offset3 + offset4 + ((isHover || isPressed) ? (sliderAnimShift - 32) : 0), r.y() + 1, r.width() - 14 - 2*offset3 - 2*offset4 - ((isHover || isPressed) ? (sliderAnimShift - 32) : 0), 13,
						                         isPressed ? *getPixmap( HSBSliderMidPressed ) :
//						                         isHover ? *getPixmap( HSBSliderMidHover ) :
									 (isHover || isActive) ? *getPixmap( HSBSliderMidActive ) :
						                         *getPixmap( HSBSliderMid ) );
					}

					painter.end();
					}

				// vertical slider
				else {
					int extent = currentScrollBar->width();
					QRect bgR( 0, extent, extent, currentScrollBar->height() - extent * 3 + 1 );
					
					if ( sbBuffer.size() != currentScrollBar->size() )
						const_cast<LiquidStyle*>( this ) -> sbBuffer.resize( currentScrollBar->size() );
					QPainter painter;
					painter.begin( &sbBuffer ); // set painter to pixelbuffer
					// top slidergroove rounder
					painter.drawPixmap( bgR.x() + 1, bgR.y(), *getPixmap( VSBSliderTopBg ) );
					// the groove
					painter.drawTiledPixmap( bgR.x() + 1, bgR.y() + 8, 13, bgR.height() - 16, *getPixmap( VSBSliderMidBg ) );
					// bottom slidergroove rounder
					painter.drawPixmap( bgR.x() + 1, bgR.bottom() - 8, *getPixmap( VSBSliderBtmBg ) );
					
//					painter.setPen( sbBgColor.light( 105 ) );
//					painter.drawLine( bgR.x() + 1, bgR.y() + 8, bgR.x() + 1, bgR.bottom() - 16 );
					painter.setPen( sbBgColor.dark( 110 ) );
					painter.drawLine( bgR.x(), bgR.y(), bgR.x(), bgR.bottom() );
					painter.drawLine( bgR.right(), bgR.y(), bgR.right(), bgR.bottom() );

					
					// here we are, now the slider
					if ( pe == PE_ScrollBarSlider ) {
						int offset = isPressed * ( optionHandler->squeezeSbSlider()*1 + optionHandler->shadowSbSlider()*2);
						int offset3 = optionHandler->shadowSbSlider()*2;
						int offset4 = (isPressed && optionHandler->squeezeSbSlider())*1;
						
						painter.drawPixmap( r.x() + 1, r.y() + offset,
						                    isPressed ? *getPixmap( VSBSliderTopPressed ) :
//						                    isHover ? *getPixmap( VSBSliderTopHover ) :
								    (isHover || isActive) ? *getPixmap( VSBSliderTopActive ) :
						                    *getPixmap( VSBSliderTop));
						painter.drawPixmap( r.x() + 1, r.bottom()  - 6 - offset3 - offset4,
						                    isPressed ? *getPixmap( VSBSliderBtmPressed ) :
//						                    isHover ? *getPixmap( VSBSliderBtmHover ) :
								    (isHover || isActive) ? *getPixmap( VSBSliderBtmActive ) :
						                    *getPixmap( VSBSliderBtm ) );
						// mid part last, as i have to redefine clipping section
						painter.setClipRect(r.x() + 1, r.y() + 7+offset3 +offset4, 13, r.height() - 14 - 2*offset3 - 2*offset4, QPainter::CoordPainter);
						painter.drawTiledPixmap( r.x() + 1, r.y() + 7+offset3 +offset4 - ((isHover || isPressed) ? sliderAnimShift : 0), 13, r.height() - 14 - 2*offset3 - 2*offset4 + ((isHover || isPressed) ? sliderAnimShift : 0),
						                         isPressed ? *getPixmap( VSBSliderMidPressed ) :
//						                         isHover ? *getPixmap( VSBSliderMidHover ) :
									 (isHover || isActive) ? *getPixmap( VSBSliderMidActive ) :
						                         *getPixmap( VSBSliderMid ) );    
					}
					painter.end();
					}
				p->drawPixmap( r.x(), r.y(), sbBuffer, r.x(), r.y(), r.width(), r.height() );

				break;
				}
			/******************************************************************************************
			******************************************************************************************/
			case PE_ScrollBarAddLine: {
				QColor c( optionHandler->useCustomColors() ?
				          optionHandler->customColor( CustomSBGroove ) :
				          isKicker ? origPanelBrush.color() :
				          qApp->palette().active().background() );
				QColor pixColor = flags & Style_Down ?
				                  qApp->palette().active().button() : c;
						  
				if ( flags & Style_Horizontal ) {
					p->drawTiledPixmap( r.x(), r.y() + 1, r.width(), 13, *getPixmap(HSBSliderMidBgI));
					p->setPen( c.dark( 110 ) );
					p->drawLine( r.x(), r.y(), r.right(), r.y());
					p->drawLine( r.x(), r.bottom(), r.right(), r.bottom());
				} else {
					p->drawTiledPixmap( r.x() + 1, r.y(), 13, r.height(), *getPixmap(VSBSliderMidBgI));
					p->setPen( c.dark( 110 ) );
					p->drawLine( r.x(), r.y(), r.x(), r.bottom());
					p->drawLine( r.right(), r.y(), r.right(), r.bottom());
				}
				p->setPen( flags & Style_Down ? cg.button() : Qt::black );
				p->setBrush( flags & Style_Down ? cg.button() : Qt::black );
				p->drawPixmap( r.x() + 4, r.y() + 4, flags & Style_Horizontal ? *sbRight : *sbDown );
				break;
				}
			case PE_ScrollBarSubLine: {
				QColor c( optionHandler->useCustomColors() ?
				          optionHandler->customColor( CustomSBGroove ) :
				          isKicker ? origPanelBrush.color() :
				          qApp->palette().active().background() );
				QColor pixColor = flags & Style_Down ?
				                  qApp->palette().active().button() : c;
				bool top = flags & Style_Horizontal ? r.x() == 0 :
				           r.y() == 0;
				if ( flags & Style_Horizontal ) {
					if ( top ) {
						p->drawTiledPixmap( r.x(), r.y() + 1, r.width(), 13, *getPixmap(HSBSliderMidBgI));
						} else {
						p->drawTiledPixmap( r.x(), r.y() + 1, r.width(), 13, *getPixmap(HSBSliderMidBgI));
						}
						p->setPen( c.dark( 110 ) );
						p->drawLine( r.x(), r.y(), r.right(), r.y());
						p->drawLine( r.x(), r.bottom(), r.right(), r.bottom());
					} else {
					if ( top ) {
						p->drawTiledPixmap( r.x() + 1, r.y(), 13, r.height(), *getPixmap(VSBSliderMidBgI));
						} else {
						p->drawTiledPixmap( r.x() + 1, r.y(), 13, r.height(), *getPixmap(VSBSliderMidBgI));
						}
						p->setPen( c.dark( 110 ) );
						p->drawLine( r.x(), r.y(), r.x(), r.bottom());
						p->drawLine( r.right(), r.y(), r.right(), r.bottom());
					}
				p->setPen( flags & Style_Down ? cg.button() : Qt::black );
				p->setBrush( flags & Style_Down ? cg.button() : Qt::black );
				p->drawPixmap( r.x() + 4, r.y() + 4, flags & Style_Horizontal ? *sbLeft : *sbUp );
				break;
				}
			case PE_Indicator: {
				bool hover = flags & Style_MouseOver;
				bool pressed = flags & Style_Down;
				bool isMasked = p->device() && p->device() ->devType() == QInternal::Widget && ( ( QWidget * ) p->device() ) ->autoMask();
				if ( isMasked ) {
					if ( !( flags & Style_Off ) )
						p->drawPixmap( r.x(), r.y(),
						               //			pressed ? *getPixmap(HTMLCBDownPressed) :
						               hover ? *getPixmap( HTMLCBDownHover ) :
						               *getPixmap( HTMLCBDown ) );
					else
						p->drawPixmap( r.x(), r.y(), hover ?
						               *getPixmap( HTMLCBHover ) : *getPixmap( HTMLCB ) );
					} else {
					if ( !( flags & Style_Off ) )
						p->drawPixmap( r.x(), r.y(),
						               pressed ? *getPixmap( CBDownPressed ) :
						               hover ? *getPixmap( CBDownHover ) :
						               *getPixmap( CBDown ) );
					else
						p->drawPixmap( r.x(), r.y(),
						               pressed ? *getPixmap( CBPressed ) :
						               hover ? *getPixmap( CBHover ) :
						               *getPixmap( CB ) );
					}
				break;
				}
			case PE_IndicatorMask: {
				p->fillRect( r, Qt::color1 );
				/*p->setPen(Qt::color0);
				p->drawPoint(r.x(), r.y());
				p->drawPoint(r.right(), r.y());
				p->drawPoint(r.x(), r.bottom());
				p->drawPoint(r.right(), r.bottom());*/
				//p->setPen(Qt::color1);
				//p->drawPixmap(r.x(), r.y(), *getPixmap(CB)->mask());
				break;
				}
			case PE_ExclusiveIndicator: {
				bool hover = flags & Style_MouseOver;
				bool isMasked = p->device() && p->device() ->devType() == QInternal::Widget && ( ( QWidget * ) p->device() ) ->autoMask();
				bool pressed = flags & Style_Down;


				if ( isMasked ) {
					if ( on || down )
						p->drawPixmap( r.x(), r.y(), hover ?
						               *getPixmap( HTMLRadioOnHover ) :
						               *getPixmap( HTMLRadioOn ) );
					else
						p->drawPixmap( r.x(), r.y(), hover ?
						               *getPixmap( HTMLRadioOffHover ) :
						               *getPixmap( HTMLRadioOff ) );
					} else {
					if ( on || down )
						p->drawPixmap( r.x(), r.y(),
						               pressed ? *getPixmap( RadioOnPressed ) :
						               hover ? *getPixmap( RadioOnHover ) :
						               *getPixmap( RadioOn ) );
					else
						p->drawPixmap( r.x(), r.y(),
						               pressed ? *getPixmap( RadioOffPressed ) :
						               hover ? *getPixmap( RadioOffHover ) :
						               *getPixmap( RadioOff ) );
					}
				break;
				}
			case PE_ExclusiveIndicatorMask: {
				p->setPen( Qt::color1 );
				p->drawPixmap( r.x(), r.y(), *getPixmap( HTMLRadioOn ) ->mask() );
				break;
				}
			case PE_DockWindowResizeHandle:
			case PE_Splitter: {
				QPen oldpen(p->pen());
				QBrush oldbrush(p->brush());
				if (highlightWidget == p->device()){
					drawClearBevel( p, r.x(), r.y(), r.width(), r.height(), cg.background().dark(102), cg.background() );
					p->setPen(cg.button().dark(140));
					p->setBrush(cg.button().dark(140));
					if (flags & Style_Horizontal)
						p->drawEllipse(r.x()+1,r.y() + (int)(r.height() / 2.5), r.width()-2, r.width()-2);
					else
						p->drawEllipse(r.x()+r.width()/2,r.y() + 1, r.height()-2, r.height()-2);

				}
				else{
					drawClearBevel( p, r.x(), r.y(), r.width(), r.height(), cg.background().dark(105), cg.background() );
					p->setPen(cg.background().dark(130));
					p->setBrush(cg.background().dark(150));
					if (flags & Style_Horizontal)
						p->drawEllipse(r.x()+1,r.y() + (int)(r.height() / 2.5), r.width()-2, r.width()-2);
					else
						p->drawEllipse(r.x()+r.width()/2,r.y() + 1, r.height()-2, r.height()-2);
				}
				p->setPen(oldpen);
				p->setBrush(oldbrush);
				break;
				}
			///////////////////////////////////////////////////////////////////////////////
			///////////////////////////////////////////////////////////////////////////////
			// 3D effect for groupboxes
			// !!! if you notice an error and know, which widget class was used, just drop me (thomas - not mosfet) a mail ;-)
//			    case PE_BoxFrame:
			case PE_PanelGroupBox:
			case PE_GroupBoxFrame: {
//				QColor light1( cg.background().light( 120 ) );
				QColor bgColor;
//				int multi = 1;
/*				if (p->device()->devType() == QInternal::Widget){
				QWidget *parent = (QWidget *)(p->device());
				if (parent->inherits( "QGroupBox" ) && ( ((QGroupBox *)parent)->frameShape() == QFrame::GroupBoxPanel ) && !(((QGroupBox *)parent)->isFlat()))
					multi = 2;
				}*/
				optionHandler->drawGroupBoxShadow() ? bgColor = QColor(cg.background().dark( 100 + optionHandler->ShadowDarkness() )) : bgColor = QColor(cg.background());
				QColor bright( bgColor.dark( 110 ) );
				//        QColor dark1(cg.background().dark(110));
				QColor mid( bgColor.dark( 130 ) );
				QColor dark( bgColor.dark( 150 ) );

				int titleVertOffset = p->fontMetrics().height() / 2 + 1;
				int x = r.x(); int right = r.right(); int bottom = r.bottom();
				int y2 = r.y() + titleVertOffset;
				// fill (dark sunken color - we just paint us our own box, owerwriting coded style...)
				if ( optionHandler->drawGroupBoxShadow()){
//					QPoint xyOffset = p->device() && (p->device()->devType() == QInternal::Widget) ? ((QWidget *)(p->device()))->backgroundOffset() : QPoint(0,0);
/*					if (p->device() && (p->device()->devType() == QInternal::Widget)){
						const QPixmap *widgetPix = ((QWidget *)(p->device()))->paletteBackgroundPixmap ();
						QPixmap tmpPix = QPixmap(1,3);
						bitBlt( &tmpPix, 0, 0, widgetPix, x, y2 + 2, 1, 3 );
						QImage tmpImg = tmpPix.convertToImage();
						unsigned int *data = ( unsigned int * ) tmpImg.bits();
						int current, last;
						(last = getBrightness(data[0])) > (current = getBrightness(data[1])) ? yOffset = 0 :
						last < current ? yOffset = 2 :
						current > getBrightness(data[2]) ? yOffset = 3 :
						yOffset = 1;
						qWarning("%d",yOffset);
					}*/
					if (isKicker){
						QPixmap *shadow = new QPixmap( 64, 64 );
						//    QColor c((w->palette()).active().background());
						QColor c;// = QColor( optionHandler->bgColor());
						( optionHandler->MenuColorButton() ) ? c = QColor( optionHandler->buttonColor() ) : c = QColor( optionHandler->bgColor() );
						shadow->fill( ( c.dark( 100 + optionHandler->ShadowDarkness()) ).rgb() );
						if ( optionHandler->useBgStipple() ) {
							QPainter p;
							p.begin( shadow );
							p.setPen( c.dark( 100 + optionHandler->ShadowDarkness() + optionHandler->stippleContrast() ) );
							for ( int i = 0; i < 63; i += 4 ) {
								p.drawLine( 0, i, 63, i );
								p.drawLine( 0, i + 1, 63, i + 1 );
							}
							//    p.~QPainter();
						}
						p->drawTiledPixmap( QRect(x + 2, y2 + 3, r.width() - 4, r.height() - titleVertOffset - 4), *shadow/*,xyOffset*/);
						delete shadow;
					}
					else
//						p->device() && (p->device()->devType() == QInternal::Widget) ? qWarning("%d - %d",((QWidget *)(p->device()))->y(), ((QWidget *)(p->device()))->topLevelWidget()->y()) : qWarning("Can't calc geometry");

/// TOP 
/*
###BMMDDDDDDDDDDDDDDDD
##MDDMMMMMMMMMMMMMMMMM
#MDMBBBBBBBBBBBBBBBBB
BDMB
MMB#
DB##
*/

// BOTTOM
/*
DB
MM
BM##
#MM#
##MM
###BMMMMMMMMMMMMMMMM
*/
						p->drawTiledPixmap( QRect(x + 2, y2 + 3, r.width() - 4, r.height() - titleVertOffset - 4), *groupShadow/*,xyOffset*/);
				}


				//outer rect
				// top
				p->setPen( dark );
				p->drawLine( x + 6, y2, right - 6, y2 );
				// left points
				p->drawPoint(x+3,y2+1);p->drawPoint(x+4,y2+1);
				p->drawPoint(x+2,y2+2);
				p->drawPoint(x+1,y2+3);
				// right points
				p->drawPoint(right-3,y2+1);p->drawPoint(right-4,y2+1);
				p->drawPoint(right-2,y2+2);
				p->drawPoint(right-1,y2+3);
				// vertcal outer lines
				p->drawLine(x,y2+5,x,bottom-5);
				p->drawLine(right,r.y()+ titleVertOffset+5,right,bottom-5);
				
				p->setPen( mid );
				// top stuff
				p->drawPoint(x+4, y2);p->drawPoint(x+5,y2);
				p->drawPoint(right-4, y2);p->drawPoint(right-5,y2);
				p->drawPoint(x+2, y2+1);
				p->drawPoint(right-2, y2+1);
				p->drawLine(x+5,y2 + 1, right - 5, y2 + 1);
				p->drawPoint(x+1,y2+2);
				p->drawPoint(right-1,y2+2);
				p->drawPoint(x+2,y2+3);
				p->drawPoint(right-2,y2+3);
				p->drawPoint(x,y2+4);p->drawPoint(x+1,y2+4);
				p->drawPoint(right,y2+4);p->drawPoint(right+1,y2+4);
				// bottom stuff
				p->drawPoint(x,bottom - 4); p->drawPoint(x+1,bottom - 4);
				p->drawPoint(right,bottom - 4); p->drawPoint(right-1,bottom - 4);
				p->drawPoint(x+1,bottom - 3);
				p->drawPoint(right-1,bottom - 3);
				p->drawPoint(x+1,bottom - 2); p->drawPoint(x+2,bottom - 2);
				p->drawPoint(right-1,bottom - 2); p->drawPoint(right-2,bottom - 2);
				p->drawPoint(x+2, bottom - 1); p->drawPoint(x+3, bottom - 1);
				p->drawPoint(right-2, bottom - 1); p->drawPoint(right-3, bottom - 1);
				p->drawLine(x + 4, bottom,right - 4, bottom);
				
				p->setPen(bright);
				// top stuff
				p->drawPoint(x+3,y2);p->drawPoint(right-3,y2);
				p->drawLine(x+4,y2+2,right-4,y2+2);
				p->drawPoint(x,y2+3);p->drawPoint(x+3,y2+3);
				p->drawPoint(right,y2+3);p->drawPoint(right-3,y2+3);
				p->drawPoint(x+2,y2+4);p->drawPoint(right-2,y2+4);
				// vertical lines
				p->drawLine(x+1,r.y()+ titleVertOffset+5,x+1,bottom-5);
				p->drawLine(right-1,r.y()+ titleVertOffset+5,right-1,bottom-5);
				// bottom stuff
				p->drawPoint(x, bottom-3);p->drawPoint(right, bottom-3);
				p->drawPoint(x+3, bottom);p->drawPoint(right-3, bottom);
				

				break;
				///////////////////////////////////////////////////////////////////////////////
				///////////////////////////////////////////////////////////////////////////////
				}

			case PE_Panel: {
				bool sunken = flags & Style_Sunken;
				int lw = opt.isDefault() ? pixelMetric( PM_DefaultFrameWidth ) :
				         opt.lineWidth();
				QPen oldPen( p->pen() );
				if ( lw == 1) {
				if (!(isKicker && optionHandler->RemoveKickerBevel())){
					QColor light( cg.background().light( 120 ) );
					QColor dark( cg.background().dark( 140 ) );
					QColor mid( cg.background().dark( 120 ) );
					p->setPen( mid );
					p->drawPoint( r.x(), r.bottom() );
					p->drawPoint( r.right(), r.y() );

					p->setPen( sunken ? dark : light );
					p->drawLine( r.x(), r.y(), r.right() - 1, r.y() );
					p->drawLine( r.x(), r.y() + 1, r.x(), r.bottom() - 1 );
					p->setPen( sunken ? light : dark );
					p->drawLine( r.x() + 1, r.bottom(), r.right(), r.bottom() );
					p->drawLine( r.right(), r.y() + 1, r.right(), r.bottom() - 1 );
					}
					} else if ( lw == 2) {
					if (!(isKicker && optionHandler->RemoveKickerBevel())){
					QColor light1, light2, light3, dark1, dark2, dark3;
					QColor mid( cg.background().dark( 110 ) );
					if ( !sunken ) {
						light1 = cg.background().light( 101 );
						light2 = cg.background().light( 120 );
						light3 = cg.background().light( 110 );
						dark1 = cg.background().dark( 115 );
						dark2 = cg.background().dark( 130 );
						dark3 = cg.background().dark( 110 );
						} else {
						light1 = cg.background().dark( 115 );
						light2 = cg.background().dark( 130 );
						light3 = cg.background().dark( 110 );
						dark1 = cg.background().light( 101 );
						dark2 = cg.background().light( 120 );
						dark3 = cg.background().light( 110 );
						}
					p->setPen( light1 );
					p->drawPoint( r.x(), r.y() );
					p->setPen( dark1 );
					p->drawPoint( r.right(), r.bottom() );
					p->setPen( mid );
					p->drawPoint( r.x(), r.bottom() );
					p->drawPoint( r.right(), r.y() );

					p->setPen( light2 );
					p->drawLine( r.x() + 1, r.y(), r.right() - 1, r.y() );
					p->drawLine( r.x(), r.y() + 1, r.x(), r.bottom() - 1 );

					p->setPen( light3 );
					p->drawLine( r.x() + 1, r.y() + 1, r.right() - 1, r.y() + 1 );
					p->drawLine( r.x() + 1, r.y() + 1, r.x() + 1, r.bottom() - 1 );

					p->setPen( dark2 );
					p->drawLine( r.x() + 1, r.bottom(), r.right() - 1, r.bottom() );
					p->drawLine( r.right(), r.y() + 1, r.right(), r.bottom() - 1 );

					p->setPen( dark3 );
					p->drawLine( r.x() + 1, r.bottom() - 1, r.right() - 1, r.bottom() - 1 );
					p->drawLine( r.right() - 1, r.y() + 1, r.right() - 1, r.bottom() - 1 );
					}
					} else
					KStyle::drawPrimitive( pe, p, r, cg, flags, opt );
				p->setPen( oldPen );
				break;
				}
			case PE_PanelTabWidget: {
				p->setPen( cg.background().dark( 140 ) );
				p->drawRect( r );
				p->setPen( cg.background() );
				p->drawLine( r.right() - 1, r.y() + 1, r.right() - 1, r.bottom() - 1 );
				p->drawLine( r.x() + 1, r.bottom() - 1, r.right() - 1, r.bottom() - 1 );
				p->setPen( cg.background().light( 130 ) );
				p->drawLine( r.x() + 1, r.y() + 1, r.right() - 1, r.y() + 1 );
				p->drawLine( r.x() + 1, r.y() + 1, r.x() + 1, r.bottom() - 1 );
				break;
				}
			case PE_PanelLineEdit: {
				bool focused = flags & Style_HasFocus;
				bool isHTML = p->device() &&
				              p->device() ->devType() == QInternal::Widget &&
				              isHTMLWidget( ( QWidget * ) p->device() );
				drawEditFrame( p, r, cg, isHTML, focused );
				break;
				}
			case PE_PanelPopup: {
//				if ( (optionHandler->MenuTranslucency() == Solid) && !optionHandler->StippleMenu() ){
//					KStyle::drawPrimitive( pe, p, r, cg, flags, opt );
//					break;
//				}
				int x, y, w , h;
				r.rect( &x, &y, &w, &h );

				optionHandler->prepareMenus();
				QColor c( optionHandler->bgColor() );
				p->setPen( c.dark( 140 ) );
				p->drawRect( x, y, w, h );
				p->setPen( c.light( 120 ) );
				p->drawRect( x + 1, y + 1, w - 2, h - 2 );
				break;
				}
			case PE_PanelMenuBar: {
				if ( p->device() && p->device() ->devType() == QInternal::Widget ) {
					QWidget * w = ( QWidget * ) p->device();
					if ( w->backgroundMode() == PaletteButton )
						w->setBackgroundMode( PaletteBackground );
					// this is for perfect menu translucency - DO NOT REMOVE!!!
					if (w->isActiveWindow() && optionHandler->MenuLevelCounter() > 0){
						optionHandler->setMenuItemActive();
					}
					else if (optionHandler->MenuItemActive()){
						optionHandler->popupDict.setAutoDelete(true);
						optionHandler->popupDict.clear();
						qWarning("popupdict cleared! (2)");
						optionHandler->currentPopupWinID = -1;
						optionHandler->currentPopup = NULL;
						optionHandler->indicatedMenuItemRect->setRect(0,0,0,0);
						optionHandler->lastIndicatedMenuItemRect->setRect(0,0,0,0);
						optionHandler->lastIndicatedMenuItemID = -1;
						optionHandler->setMenuItemInactive();
					}
					//-------------------------------------------------------------------------
					if ( w->isTopLevel() )
						qDrawShadePanel( p, r.x(), r.y(), r.width(), r.height(), cg, false, 1,
						                 &cg.brush( QColorGroup::Background ) );
					}
				}
			case PE_PanelDockWindow: {
/*				// This method draws toolbars
				if(p->device() && p->device()->devType() == QInternal::Widget){
				    // check if background brush is set properly - Qt sometimes
				    // resets it to PaletteButton even after my polish() sets it
				    // to PaletteBackground. I think they do it just to mess with
				    // my head ;-)
				    QWidget *w = (QWidget *)p->device();
				    if(w->backgroundMode() != Qt::PaletteBackground){
				        w->setBackgroundMode(Qt::PaletteBackground);
				        w->setBackgroundOrigin(QWidget::WindowOrigin);
				        w->erase();
				    }
					}*/
				break;
				}
			case PE_Separator:
			case PE_DockWindowSeparator: {
				if ( !( flags & Style_Horizontal ) ) {
					p->setPen( cg.mid() );
					p->drawLine( 4, r.height() / 2, r.width() - 5, r.height() / 2 );
					p->setPen( cg.light() );
					p->drawLine( 4, r.height() / 2 + 1, r.width() - 5, r.height() / 2 + 1 );
					} else {
					p->setPen( cg.mid() );
					p->drawLine( r.width() / 2, 4, r.width() / 2, r.height() - 5 );
					p->setPen( cg.light() );
					p->drawLine( r.width() / 2 + 1, 4, r.width() / 2 + 1, r.height() - 5 );
					}
				break;
				}
			case PE_SpinWidgetUp:
			case PE_SpinWidgetDown: {
				bool sunken = on || down;
				//bool hover = flags & Style_MouseOver;;
				int x = r.x() + ( r.width() - 8 ) / 2;
				int y = r.y() + ( r.height() - 7 ) / 2 + 2;
				QPen oldPen( p->pen() );
				QBrush oldBrush( p->brush() );
				QPointArray a;
				p->setPen( sunken ? Qt::white : cg.buttonText() );
				p->setBrush( sunken ? Qt::white : cg.buttonText() );
				pe == PE_SpinWidgetUp ? a.setPoints( 3, x, y + 3, x + 4, y-1, x + 8, y + 3) : a.setPoints( 3, x, y, x + 4, y + 4, x + 8, y );
//				p->drawPixmap( x, y, pe == PE_SpinWidgetUp ? *sbUp : *sbDown );
				p->drawPolygon(a);
				p->setBrush( oldBrush );
				p->setPen( oldPen );
				break;
				}
			case PE_CheckMark:{
				QPen oldPen( p->pen() );
				QBrush oldBrush( p->brush() );
				p->setPen( flags & Style_On ? cg.highlightedText() : optionHandler->textColor() );
				p->setBrush( flags & Style_On ? cg.highlightedText() : optionHandler->textColor() );
				QPointArray a;
				int y = r.y()+(int)(r.height()/2)-2;
				a.setPoints(6,r.x()+5,/*r.y()+12*/y+3,
							r.x()+8,/*r.y()+15*/y+6,
							r.x()+14,/*r.y()+9*/y,
							r.x()+14,/*r.y()+6*/y-3,
							r.x()+8,/*r.y()+12*/y+3,
							r.x()+5,/*r.y()+9*/y);
				p->drawPolygon(a);
				p->setBrush( oldBrush );
				p->setPen( oldPen );
				break;
			}
			default: {
				if ( (pe >= PE_ArrowUp && pe <= PE_ArrowLeft ) || pe == PE_HeaderArrow) {
					QPen oldPen( p->pen() );
					QBrush oldBrush(p->brush());
					// arrows
					p->setPen( flags & Style_Enabled ? (flags & Style_Down || flags & Style_Sunken) && !PE_HeaderArrow ? cg.light() : cg.buttonText() : cg.mid() );
					p->setBrush( flags & Style_Enabled ? (flags & Style_Down || flags & Style_Sunken) && !PE_HeaderArrow ? cg.light() : cg.buttonText() : cg.mid() );
					int x = r.x();
					int y = r.y();

					if ( r.width() > 8 ) {
						x = x + ( r.width() - 8 ) / 2;
						y = y + ( r.height() - 8 ) / 2;
					}
					else if (r.width() < 8)
						x = x - (9 - r.width());
					QPointArray a;
					switch ( pe ) {
						case PE_ArrowUp:{
							a.setPoints( 3, x, y + 4, x + 4, y, x + 8, y + 4 );
							break;
						}
						case PE_ArrowDown:{
							a.setPoints( 3, x, y, x + 4, y + 4, x + 8, y );
							break;
						}
						case PE_ArrowLeft:{
							a.setPoints( 3, x + 4, y, x, y+4, x + 4, y + 8 );
							break;
						}
						case PE_HeaderArrow:{
							if (flags & Style_Up)
								a.setPoints( 3, x, y + 4, x + 4, y, x + 8, y + 4 );
							else
								a.setPoints( 3, x, y, x + 4, y + 4, x + 8, y );
								break;
						}
						default:{
							a.setPoints( 3, x, y, x + 4, y+4, x, y + 8 );
							break;
						}
					}
					p->drawPolygon(a);
					p->setBrush( oldBrush );
					p->setPen( oldPen );
				}
				else
					KStyle::drawPrimitive( pe, p, r, cg, flags, opt );
			}
		}
	}

void LiquidStyle::drawKStylePrimitive( KStylePrimitive kpe, QPainter* p,
                                       const QWidget* widget, const QRect &r,
                                       const QColorGroup &cg, SFlags flags,
                                       const QStyleOption &opt ) const {
	switch ( kpe ) {
			case KPE_ToolBarHandle: {
//				drawClearBevel( p, r.x(), r.y(), r.width(), r.height(), cg.button(), cg.background() );
//				optionHandler->SmoothListViewHeaders() ?
//				drawCombo( p, cg, cg.button(), r.x(), r.y(), r.width(), r.height(), false, false, false, full ) :
				drawRectangularButton( p, cg.button(), r.x(), r.y(), r.width(), r.height(), false, false, false);
				p->setPen(cg.button().dark(160));
				p->drawRect(r);
				break;
				}
			case KPE_GeneralHandle: {
				optionHandler->prepareMenus();
				if ( widget->inherits( "AppletHandleDrag" ) && optionHandler->usePanelCustomColor() ) {
					QColor c( optionHandler->panelCustomColor() );
					drawClearBevel( p, r.x(), r.y(), r.width(), r.height(), highlightWidget == widget ? c.light( 110 ) : c, c );
				}
				else{
//					drawClearBevel( p, r.x(), r.y(), r.width(), r.height(), highlightWidget == widget ? cg.button().light( 110 ) : cg.button(), cg.button() );
					QColor c( widget->hasMouse() ? cg.button() : cg.background() );
					p->fillRect(r,c);
					p->setPen(c.dark( 100 + optionHandler->stippleContrast() ));
					int x=r.x();
					int y=r.y();
					int w=r.width();
					int h=r.height();
					for (int i = y;i < y+h; i += 4 ) {
						p->drawLine( x, i, x+w, i );
						p->drawLine( x, i + 1, x+w, i + 1 );
					}
				}
				break;
				}
			case KPE_SliderGroove: {
				QColor c = (optionHandler->drawGroupBoxShadow() && widget->parentWidget() && widget->parentWidget()->inherits("QGroupBox")/* && ((QGroupBox *)(widget->parentWidget()))->frameShape() == QFrame::GroupBoxPanel*/) ? cg.background().dark(100 + optionHandler->ShadowDarkness()) : widget->hasFocus() ? cg.background().dark( 120 ) : cg.background();
				int x, y, w, h;
				r.rect( &x, &y, &w, &h );
				if (qstrcmp( qApp->argv() [ 0 ], "kmix" ) == 0) x = x+3;
				if ( ( ( const QSlider * ) widget ) ->orientation() == Qt::Horizontal ) {
					int x2 = x + w - 1;
					y = y + ( h - 5 ) / 2;
					p->setPen( c.dark( 130 ) );
					p->drawLine( x + 1, y, x2 - 1, y );
					p->setPen( c.dark( 150 ) );
					p->drawLine( x, y + 1, x2, y + 1 );
					p->setPen( c.dark( 125 ) );
					p->drawLine( x, y + 2, x2, y + 2 );
					p->setPen( c.dark( 130 ) );
					p->drawLine( x, y + 3, x2, y + 3 );
					p->setPen( c.dark( 120 ) );
					p->drawLine( x, y + 4, x2, y + 4 );
					p->setPen( c.light( 110 ) );
					p->drawLine( x + 1, y + 5, x2 - 1, y + 5 );
					} else {
					int y2 = y + h - 1;
					x = x + ( w - 5 ) / 2;
					p->setPen( c.dark( 130 ) );
					p->drawLine( x, y + 1, x, y2 - 1 );
					p->setPen( c.dark( 150 ) );
					p->drawLine( x + 1, y, x + 1, y2 );
					p->setPen( c.dark( 125 ) );
					p->drawLine( x + 2, y, x + 2, y2 );
					p->setPen( c.dark( 130 ) );
					p->drawLine( x + 3, y, x + 3, y2 );
					p->setPen( c.dark( 120 ) );
					p->drawLine( x + 4, y, x + 4, y2 );
					p->setPen( c.light( 110 ) );
					p->drawLine( x + 5, y + 1, x + 5, y2 - 1 );
					}
				break;
				}
			case KPE_SliderHandle: {
			if ((( const QSlider * ) widget ) ->orientation() == Qt::Horizontal)
				p->drawPixmap( r.x(), r.y()+2, *getPixmap( HSlider ));
			else{
				bool right = (( const QSlider * ) widget )->tickmarks() == QSlider::NoMarks || (( const QSlider * ) widget )->tickmarks() == QSlider::Right;
				p->drawPixmap( /*(qstrcmp( qApp->argv() [ 0 ], "kmix" ) == 0) ? r.x() :*/ right ? r.x()+5 : r.x()-3, r.y(), *getPixmap( right ? VSlider : VSliderAbove ));
			}
			break;
				}
			case KPE_ListViewExpander: {
				int radius = ( r.width() - 4 ) / 2;
				int centerx = r.x() + r.width() / 2;
				int centery = r.y() + r.height() / 2;

				int red, green, blue;
				red = ( cg.dark().red() >> 1 ) + ( cg.base().red() >> 1 );
				green = ( cg.dark().green() >> 1 ) + ( cg.base().green() >> 1 );
				blue = ( cg.dark().blue() >> 1 ) + ( cg.base().blue() >> 1 );
				QColor blendColor( red, green, blue );

				p->setPen( cg.dark() );
				p->drawLine( r.x() + 1, r.y(), r.right() - 1, r.y() );
				p->drawLine( r.x() + 1, r.bottom(), r.right() - 1, r.bottom() );
				p->drawLine( r.x(), r.y() + 1, r.x(), r.bottom() - 1 );
				p->drawLine( r.right(), r.y() + 1, r.right(), r.bottom() - 1 );
				p->setPen( blendColor );
				p->drawPoint( r.x(), r.y() );
				p->drawPoint( r.right(), r.y() );
				p->drawPoint( r.x(), r.bottom() );
				p->drawPoint( r.right(), r.bottom() );
				p->setPen( cg.light() );
				p->drawRect( r.x() + 1, r.y() + 1, r.width() - 2, r.height() - 2 );
				p->fillRect( r.x() + 2, r.y() + 2, r.width() - 4, r.height() - 4,
				             cg.background() );
				p->setPen( cg.text() );
				p->drawLine( centerx - radius, centery, centerx + radius, centery );
				if ( flags & Style_On )
					p->drawLine( centerx, centery - radius, centerx, centery + radius );
				break;
				}
			default:
			KStyle::drawKStylePrimitive( kpe, p, widget, r, cg, flags, opt );
		}
	}

void LiquidStyle::drawControl( ControlElement element, QPainter *p,
                               const QWidget *widget, const QRect &r,
                               const QColorGroup &cg, SFlags flags,
                               const QStyleOption &opt ) const {
	switch ( element ) {
			case CE_ProgressBarGroove: {
					p->setPen(cg.background().dark(160));
				        p->drawRect(r);
//					if (/*optionHandler->useLiquidProgressBar()*/false){
//				        	p->fillRect(r.x()+1, r.y()+1, r.width()-2, r.height()-2, cg.base());
/*						int y = r.y()+(int)((r.height()-20)/2);
						QPixmap *pix = getPixmap(Progress);
						p->drawTiledPixmap(r.x(), y+1, r.width()-1, 20, *pix);*/
//					}
//					else{
						drawCombo( p, cg, cg.background(), r.x()+1, r.y()+1, r.width()-2, r.height()+1, false, false, false, center );
//					}
//				QPen oldPen(p->pen());
//				p->setPen(cg.background().dark(160));
//				p->drawRect(r);
//				p->setPen(oldPen);
//				drawClearBevel( p, r.x() + 1, r.y() + 1, r.width() - 2, r.height() - 2, cg.background(), cg.background() );
				break;
				}
			case CE_ProgressBarContents: {
				const QProgressBar *progress = ( const QProgressBar * ) widget;
				QRect contentsR( subRect( SR_ProgressBarContents, widget ) );
				double val = progress->progress();
				bool reverse = QApplication::reverseLayout();
				val = val / progress->totalSteps();
				if ( val > 0.0 ) {
					int w = QMIN( contentsR.width(), ( int ) (val * contentsR.width() ) );
					if ( w > 1 ) {
//						progress->progress() < 0 ? activeProgress = NULL : activeProgress = progress;
						int x = contentsR.x();
						int y = contentsR.y();
						int x2 = contentsR.x() + w - 1;
						int y2 = contentsR.bottom();
//						if ( w > 2 ) {
							QRect progressRect;
							if (reverse)
								progressRect = QRect(contentsR.x()+(contentsR.width()-w), contentsR.y(), w, contentsR.height()+1);
							else
								progressRect = QRect(contentsR.x(), contentsR.y(), w, contentsR.height()+1);


							
							if (optionHandler->ProgressBar() == liquid){
								//Clip to the old rectangle
								p->setClipRect(progressRect, QPainter::CoordPainter);
								//Expand
								progressRect.setLeft(progressRect.x() - progAnimShift);
								p->setPen(cg.button().dark(120));
								p->drawLine(x, y, x2, y);
								p->drawLine(x, y, x, y2);
								p->drawLine(x+1, y2+1, x2-1, y2+1);
								p->setPen(cg.button().dark(110));
								p->drawLine(x2, y, x2, y2);
								p->drawLine(x, y2, x2, y2);
								QPixmap * pix = getPixmap( Progress );
								p->drawTiledPixmap(/*x+1, y+1, w-2, contentsR.height()-2*/progressRect, *pix);
							}
							else if (optionHandler->ProgressBar() == baghira) {
								drawClearBevel( p, r.x(), r.y(), w - 1, contentsR.height()+1, cg.button(), cg.button() );
							}
							else{
								ButtonTile *progress2Tile = progress2Dict.find( cg.button().rgb() );
								if ( !progress2Tile ) {
									QPixmap *pix = getPixmap(progress2);
									progress2Tile = separateTiles( pix, 0, 15, 38, 1, 0, true, false );
								}
								if ( !progress2Tile ) {
									qWarning( "Tab tile is NULL!" );
									return ;
								} else{
									LiquidStyle *ptr = const_cast<LiquidStyle*>( this );
									ptr->progress2Dict.insert( cg.button().rgb(), progress2Tile );
								}
								//Clip to the old rectangle
								p->setClipRect(progressRect, QPainter::CoordPainter);
								//Expand
								progressRect.setLeft(progressRect.x() - 38 + prog2AnimShift);
								int x = progressRect.x();int y = progressRect.y();int w = progressRect.width();int h = progressRect.height();
								bool tooSmall = h < 32;
								int mid = h/2;
								p->drawTiledPixmap(x,tooSmall ? mid + 1 : progressRect.bottom()-15,w,16, *progress2Tile->pixmap(TileBtm));
								p->drawTiledPixmap(x,tooSmall ? mid : y+15,w,tooSmall ? 1 : h-31, *progress2Tile->pixmap(TileMiddle));
								p->drawTiledPixmap(x,tooSmall ? mid - 15 : y,w,15, *progress2Tile->pixmap(TileTop));
//								p->setPen(cg.background().dark(160));
//				        			p->drawLine(r.x()+1,r.y()+contentsR.height()+1,r.x()+w-1,r.y()+contentsR.height()+1);
//								p->setPen(cg.button().dark(140));
//								p->drawLine(r.x()+w-1,r.y()+2,r.x()+w-1,r.y()+contentsR.height()-2);
							}
//						}
					}
				}
				break;
			}
			case CE_ProgressBarLabel: {
				if (optionHandler->DrawProgressLabel()){
					QRect contentsR( subRect( SR_ProgressBarContents, widget ) );
					if ( !contentsR.isValid() )
						return ;
					QFont font( p->font() );
					font.setBold( true );
					p->setFont( font );
					p->setPen( widget->colorGroup().buttonText() );
					p->setClipRect(r, QPainter::CoordPainter);
					p->drawText( contentsR, AlignCenter, ( ( const QProgressBar * ) widget ) ->progressString() );
				}
				break;
			}

			case CE_TabBarTab: { // new style with tiled pixmaps
				if ( !widget || !widget->parentWidget() )
					break;
				const QTabBar *tabBar = ( const QTabBar * ) widget;
				LiquidStyle *ptr = const_cast<LiquidStyle*>( this );
				bool selected = flags & Style_Selected;
				bool above = tabBar->shape() == QTabBar::RoundedAbove;
				bool below = tabBar->shape() == QTabBar::RoundedBelow;
				if ( !above && !below ) {
					KStyle::drawControl( element, p, widget, r, cg, flags, opt );
					return ;
					}
				QPixmap *pix;
				if (above)
					pix = selected ? getPixmap( TabDown ) : getPixmap( Tab );
				else
					pix = selected ? getPixmap( belowTabDown ) : getPixmap( belowTab );

				QColor c;
				if (selected)
					if (optionHandler->useCustomColors())
						c = optionHandler->customColor(CustomTabOn);
					else
						c = optionHandler->buttonColor();
				else
					if (optionHandler->useCustomColors())
						c = optionHandler->customColor(CustomTabOff);
					else
						c = optionHandler->InactiveButtonColor();
				ButtonTile *tabTile = above ? tabDict.find( c.rgb() ) : inverseTabDict.find(c.rgb());
				//	ButtonTile *tabTile;
				if ( !tabTile ) {
					tabTile = separateTiles( pix, 9, 15, 67, 1, 0, false, true );
					}
				if ( !tabTile ) {
					qWarning( "Tab tile is NULL!" );
					return ;
					} else
					above ? ptr->tabDict.insert( c.rgb(), tabTile ) : ptr->inverseTabDict.insert( c.rgb(), tabTile );

				int offset;
				selected ? offset = 0 : offset = 2;

				if ( r.width() > 18 ) {
					p->drawTiledPixmap( r.x() + 9, r.y() + offset, r.width() - 18, 15, *tabTile->pixmap( TileTop ) );
					p->drawTiledPixmap( r.x() + 9, r.height() - 11, r.width() - 18, 11, *tabTile->pixmap( TileBtm ) );
					}
				if ( r.height() + offset > 26 ) {
					p->drawTiledPixmap( r.x() + 0, r.y() + 15 + offset, 9, r.height() - 26 - offset, *tabTile->pixmap( TileLeft ) );
					p->drawTiledPixmap( r.right() - 8, r.y() + 15 + offset, 9, r.height() - 26 - offset, *tabTile->pixmap( TileRight ) );
					}
				if ( r.width() > 18 && r.height() + offset > 22 )
					p->drawTiledPixmap( r.x() + 9, r.y() + 15 + offset, r.width() - 18, r.height() - 26 - offset, *tabTile->pixmap( TileMiddle ) );
				p->drawPixmap( r.x() + 0, r.y() + offset, *tabTile->pixmap( TileTopLeft ) );
				p->drawPixmap( r.right() - 8, r.y() + offset, *tabTile->pixmap( TileTopRight ) );
				p->drawPixmap( r.x() + 0, r.height() - 11, *tabTile->pixmap( TileBtmLeft ) );
				p->drawPixmap( r.right() - 8, r.height() - 11, *tabTile->pixmap( TileBtmRight ) );


				if ( !selected ) {
					p->setPen( c.dark( 158 ) );
					p->drawLine( r.x(), r.bottom(), r.right(), r.bottom() );
					}
				break;
				}

			case CE_TabBarLabel: {
				if ( opt.isDefault() )
					return ;
				QTab *t = opt.tab();
				const QTabBar * tb = ( const QTabBar * ) widget;
				int vertOffs = 1;
				int horOffs = 1;
				int y = t->rect().y();
				/*        if((flags & Style_HasFocus) && !t->text().isEmpty()){
				            const QColor tmp(cg.button().dark(130));
				            drawItem(p, QRect(r.x()+1, r.y()+1, r.width(), r.height()), AlignCenter | ShowPrefix, cg, flags & Style_Enabled, 0, t->text(), -1, &tmp);
				            drawItem(p, QRect(r.x()+2, r.y()+2, r.width(), r.height()), AlignCenter | ShowPrefix, cg, flags & Style_Enabled, 0, t->text(), -1, &tmp);
				        }*/
				if ( ( tb->currentTab() == t->identifier() ) ) {
					drawItem( p, QRect( r.x() + 3, /*r.y()-5*/y, r.width(), r.height() ), AlignCenter | ShowPrefix, cg, flags & Style_Enabled, 0, t->text() );
					} else if (flags & Style_MouseOver)
					drawItem( p, QRect( r.x() + 3, r.y() + 2, r.width(), r.height() ), AlignCenter | ShowPrefix, cg, flags & Style_Enabled, 0, t->text() );
					else
					drawItem( p, QRect( r.x() + 3, /*r.y()*/y + 2, r.width(), r.height() ), AlignCenter | ShowPrefix, cg, flags & Style_Enabled, 0, t->text() );
				break;
				}
			case CE_PushButton: {
				const QPushButton *btn = ( const QPushButton* ) widget;
				const_cast<LiquidStyle*>( this ) ->isHTMLButton = isHTMLWidget( btn );
				if ( widget == highlightWidget )
					flags |= Style_MouseOver;
				// Qt messes this up with WindowOrigin, so we do it ourselves :P
				if ( !isPlain() && !btn->autoMask() )
					const_cast<LiquidStyle*>( this ) ->btnOffset = btn->backgroundOffset();

				// groupbox shadow code...
				if (optionHandler->drawGroupBoxShadow()){
					if (btn->parentWidget(true) && btn->parentWidget(true)->inherits("QGroupBox") /*&& ((QGroupBox *)(btn->parentWidget()))->frameShape() == QFrame::GroupBoxPanel*/){
						optionHandler->setGroupShadowButton();
					}
					else{
						optionHandler->setNotGroupShadowButton();
					}
				}
				else{
					optionHandler->setNotGroupShadowButton();
				}


				if ( btn->isDefault() )
					drawPrimitive( PE_ButtonDefault, p, r, cg, flags );
				else
					drawPrimitive( PE_ButtonCommand, p, r, cg, flags );
				break;
				}
			case CE_PushButtonLabel: {
				const QPushButton *btn = ( const QPushButton* ) widget;
				int x, y, w, h;
				r.rect( &x, &y, &w, &h );
				bool highlighted = btn->isOn() || btn->isDown() || btn->hasFocus() || btn == highlightWidget;

//				y += 1;

				if ( btn->isOn() || btn->isDown() ) {
					//            ++x;
//					y += 1;
					flags |= Style_Sunken;
					}
				/*        if(btn->isDefault()){
				            int tmpX = x+4;
				            int tmpY = y+(h-11)/2;
				            p->setPen(highlighted ? cg.background().dark(140) : cg.button().dark(140));
				            p->drawLine(tmpX, tmpY, tmpX, tmpY+11);
				            p->drawLine(tmpX, tmpY+11, tmpX+5, tmpY+6);
				            p->setPen(highlighted ? cg.background().dark(125) : cg.button().dark(125));
				            p->drawLine(tmpX, tmpY, tmpX+5, tmpY+5);
				            x += 8;
				            w -= 8;
				        }*/
				if ( btn->isMenuButton() ) {
					int ih = r.height() / 3;
					int iw = ih;
					int ix = r.width() - iw - 7;
					int iy = ( r.height() - ih ) / 2;
					drawPrimitive( PE_ArrowDown, p, QRect( ix, iy, iw, ih ) , cg, flags, opt );
					w -= iw;
					}
				if ( btn->iconSet() && !btn->iconSet() ->isNull() ) {
					QIconSet::Mode mode = btn->isEnabled() ? QIconSet::Normal : QIconSet::Disabled;
					if ( mode == QIconSet::Normal && btn->hasFocus() )
						mode = QIconSet::Active;

					QIconSet::State state = QIconSet::Off;
					if ( btn->isToggleButton() && btn->isOn() )
						state = QIconSet::On;

					QPixmap pix( btn->iconSet() ->pixmap( QIconSet::Small, mode, state ) );
					int pixW = pix.width();
					int pixH = pix.height();
					p->drawPixmap( x + 4, y + ( h - pixH ) / 2, pix );
					x += pixW + 4;
					w -= pixW + 4;
					}

				QColor tmp;
				        if(!(btn->isDown())){
				            tmp = (highlighted) ? btn->colorGroup().button().dark(130) : optionHandler->InactiveButtonColor().dark(130);
				            drawItem(p, QRect(x, y+1, w, h), AlignCenter | ShowPrefix, cg, btn->isEnabled(), btn->pixmap(), btn->text(), -1, &tmp);
//				            drawItem(p, QRect(x, y+2, w, h), AlignCenter | ShowPrefix, cg, btn->isEnabled(), btn->pixmap(), btn->text(), -1, &tmp);
				        }
				int text_flags = AlignVCenter;
//				p->setPen(btn->colorGroup().button().dark(130));
//				p->drawText( x,y+1,w,h, text_flags, btn->text() );
				tmp = btn->isDown() && !optionHandler->IcyButtons() ? btn->colorGroup().highlightedText() : btn->colorGroup().buttonText();
				drawItem( p, QRect( x, y, w, h ), AlignCenter | ShowPrefix, cg, btn->isEnabled(), btn->pixmap(), btn->text(), -1, &tmp );
				break;
				}
			case CE_MenuBarItem: {
				QMenuItem *mi = opt.menuItem();
				bool active = flags & Style_Active;
				bool focused = flags & Style_HasFocus;

				if ( active && focused ) {
//					drawClearBevel( p, r.x(), r.y(), r.width(), r.height(), qApp->palette().active().button(), cg.background() );
					optionHandler->daddyWasAPopup = false;
					p->fillRect(r,cg.highlight());
				}

				QColor tmpColor( cg.background().dark( 120 ) );
				if ( optionHandler->useShadowText() && !( active && focused )) {
					drawItem( p, QRect( r.x() + 1, r.y() + 1, r.width(), r.height() ), AlignCenter | AlignVCenter | ShowPrefix | DontClip | SingleLine, cg, flags & Style_Enabled, mi->pixmap(), mi->text(), -1, &tmpColor );
					}
				drawItem( p, r, AlignCenter | AlignVCenter | ShowPrefix | DontClip | SingleLine, cg, flags & Style_Enabled, mi->pixmap(), mi->text(), -1, ( active && focused ) ? &(cg.highlightedText()) : &(cg.text()) );
				break;
				}
			case CE_PopupMenuItem: {
			
				int x,x1, y,y1, w, h;
				r.rect( &x1, &y1, &w, &h );

				const QPopupMenu *popupmenu = ( const QPopupMenu * ) widget;
				QMenuItem *mi = opt.menuItem();
				
				int tab = opt.tabWidth();
				int maxpmw = opt.maxIconWidth();
				bool dis = mi && !mi->isEnabled();
				bool checkable = popupmenu->isCheckable();
				bool act = flags & Style_Active;
				bool enabled = flags & Style_Enabled;
				int checkcol = maxpmw;

				optionHandler->prepareMenus();
				QColor menuBgColor(  optionHandler->UseCustomMenuColor() ? optionHandler->Color() : optionHandler->bgColor() );

				if ( checkable )
					checkcol = QMAX( maxpmw, 20 );

				if ( mi && mi->isSeparator() ) {
					p->setPen( menuBgColor.dark( 130 ) );
					p->drawLine( x1 + 1, y1, x1 + w - 1, y1 );
					p->setPen( menuBgColor.light( 120 ) );
					p->drawLine( x1+1, y1 + 1, x1 + w - 1 , y1 + 1 );
					return ;
					}
				
				// if we have an item for childs, we'll have to do some store stuff for providing indicators under the shadow ;-)
				QPaintDevice *oldPaintDevice;
				if (mi && mi->popup()){
					QFont oldFont;
					if (act && enabled){
						x = 0;y=0;
						oldFont = p->font();
						oldPaintDevice = p->device();
						if (optionHandler->indicatedMenuItemPix)
							optionHandler->indicatedMenuItemPix->resize(r.width(),r.height());
						else
							optionHandler->indicatedMenuItemPix = new QPixmap(r.width(),r.height());
						p->end();
						p->begin(optionHandler->indicatedMenuItemPix);
						p->setFont(oldFont);
					}
					else if (mi->id() == optionHandler->lastIndicatedMenuItemID){
						x = 0;y=0;
						oldFont = p->font();
						oldPaintDevice = p->device();
						if (optionHandler->lastIndicatedMenuItemPix)
							optionHandler->lastIndicatedMenuItemPix->resize(r.width(),r.height());
						else
							optionHandler->lastIndicatedMenuItemPix = new QPixmap(r.width(),r.height());
						p->end();
						p->begin(optionHandler->lastIndicatedMenuItemPix);
						p->setFont(oldFont);
					}
					else {
						x = x1;
						y = y1;
					}
				}
				else{
					x = x1;
					y = y1;
				}
				
				if ( act && mi && enabled){
					optionHandler->daddyWasAPopup = false;
					p->fillRect(x,y,w,h,cg.highlight());
				}
				else if ( (optionHandler->MenuTranslucency() == Solid) && optionHandler->StippleMenu() ) {
					p->drawTiledPixmap( x, y, w, h, *optionHandler->bgPixmap(), x, y );
					if (act){
						p->setPen(cg.highlight());
						p->drawRect(x,y,w,h);
					}
				}
				else if ( (optionHandler->MenuTranslucency() >= DefaultTrans)) {
					PopupStuff *popupStuff = optionHandler->popup( popupmenu->winId() );
					KPixmap * pixmap = popupStuff ? popupStuff->pix : NULL;
					if ( pixmap ) {
						int tmp = popupStuff ? popupStuff->leftOffset : 0;
						p->drawPixmap( x, y, *pixmap, x1+ (tmp  > optionHandler->ShadowOffset() ? optionHandler->ShadowOffset() : tmp), y1, w, h );
					}
					if (act){
						p->setPen(cg.highlight());
						p->drawRect(x,y,w,h);
					}
				}				
				else {
					p->fillRect( x, y, w, h, menuBgColor );
					if (act){
						p->setPen(cg.highlight());
						p->drawRect(x,y,w,h);
					}
				}
				if ( !mi )
					return ;

				// Menu contents drawing code based on Qt's styles. Qt is property of
				// TrollTech: www.trolltech.com. Used with permission.
				int xpos = x;
				QRect vrect = visualRect( QRect( xpos, y, checkcol, h ), r );
				int xvis = vrect.x();

				// checkbox
/*				if ( mi->isChecked() ) {
					if ( act && !dis )
						qDrawShadePanel( p, xvis, y, checkcol, h,
						                 cg, TRUE, 1, &cg.brush( QColorGroup::Button ) );
					else {
						qDrawShadePanel( p, xvis, y, checkcol, h, cg, TRUE, 1 );
						}
					}*/

				// icon
				if ( mi->iconSet() ) {
					QIconSet::Mode mode = dis ? QIconSet::Disabled : QIconSet::Normal;
					if ( act && !dis )
						mode = QIconSet::Active;
					QPixmap pixmap;
					if ( checkable && mi->isChecked() )
						pixmap = mi->iconSet() ->pixmap( QIconSet::Small, mode, QIconSet::On );
					else
						pixmap = mi->iconSet() ->pixmap( QIconSet::Small, mode );
					int pixw = pixmap.width();
					int pixh = pixmap.height();
					QRect pmr( 0, 0, pixw, pixh );
					pmr.moveCenter( vrect.center() );
					p->setPen( cg.text() );
					p->drawPixmap( pmr.topLeft(), pixmap );
					} else if ( checkable ) {
					if ( mi->isChecked() ) {
						int xp = xpos + windowsItemFrame;

						SFlags cflags = Style_Default;
						if ( !dis )
							cflags |= Style_Enabled;
						if ( act )
							cflags |= Style_On;
						drawPrimitive( PE_CheckMark, p, visualRect( QRect( xp, y + windowsItemFrame, checkcol - 2 * windowsItemFrame, h - 2 * windowsItemFrame ), r ), cg, cflags );
						}
					}
				QColor discol;
				if ( dis ) {
					discol = cg.text();
					p->setPen( discol );
					}

				int xm = windowsItemFrame + checkcol + windowsItemHMargin;
				xpos += xm;

				vrect = visualRect( QRect( xpos, y + windowsItemVMargin,
				                           w - xm - tab + 1, h - 2 * windowsItemVMargin ), r );
				xvis = vrect.x();
				if ( mi->custom() ) {
					p->save();
					if ( dis && !act ) {
						p->setPen( cg.light() );
						mi->custom() ->paint( p, cg, act, !dis,
						                      xvis + 1, y + windowsItemVMargin + 1,
						                      w - xm - tab + 1, h - 2 * windowsItemVMargin );
						p->setPen( discol );
						}
					mi->custom() ->paint( p, cg, act, !dis, xvis, y + windowsItemVMargin,
					                      w - xm - tab + 1, h - 2 * windowsItemVMargin );
					p->restore();
					}

				// Text
				QString s = mi->text();
				if ( !s.isNull() ) {
					QColor textColor, shadowColor;
					shadowColor = optionHandler->bgColor().dark( 130 );

					if ( dis )
						textColor = shadowColor.light( 115 );
					else if (act && mi)
						textColor = cg.highlightedText();
					else if ( optionHandler->UseCustomMenuColor())
						textColor = optionHandler->textColor();
					else
						textColor = cg.text();

					int t = s.find( '\t' );
					int text_flags = AlignVCenter | ShowPrefix | DontClip | SingleLine;
					text_flags |= ( QApplication::reverseLayout() ? AlignRight : AlignLeft );
					if ( t >= 0 ) {                         // draw tab text
						int xp;
						xp = x + w - tab - 20 - windowsItemHMargin - windowsItemFrame + 1;
						QString tabStr( s.right( s.length() - t - 1 ) );
						if ( !tabStr.isEmpty() ) {
							if ( optionHandler->useShadowText() ) {
								p->setPen( shadowColor );
								p->drawText( xp + 1, y + windowsItemVMargin + 1, w - xm - tab + 1, h - 2 * windowsItemVMargin, text_flags, tabStr );
							}
							p->setPen( textColor );
							p->drawText( xp, y + windowsItemVMargin, w - xm - tab + 1, h - 2 * windowsItemVMargin, text_flags, tabStr );
						}
						s = s.left( t );
						}
					if ( optionHandler->useShadowText() && !(act && mi) ) {
						p->setPen( shadowColor );
						p->drawText( xvis + 1, y + windowsItemVMargin + 1, w - xm - tab + 1, h - 2 * windowsItemVMargin, text_flags, s, t );
					}
					p->setPen( textColor );
					p->drawText( xvis, y + windowsItemVMargin, w - xm - tab + 1, h - 2 * windowsItemVMargin, text_flags, s, t );
				}
				else if ( mi->pixmap() ) {                        // draw pixmap
					QPixmap * pixmap = mi->pixmap();
					if ( pixmap->depth() == 1 )
						p->setBackgroundMode( OpaqueMode );
					p->drawPixmap( xvis, y + windowsItemFrame, *pixmap );
					if ( pixmap->depth() == 1 )
						p->setBackgroundMode( TransparentMode );
				}

				// Child menu
				if ( mi->popup() ) {
					int dim = (int)((float)( h - 2 * windowsItemFrame ) / 2);
					PrimitiveElement arrow;
					arrow = ( QApplication::reverseLayout() ? PE_ArrowLeft : PE_ArrowRight );
					xpos = x + w - windowsArrowHMargin - windowsItemFrame/* - dim*/-8;
					vrect = visualRect( QRect( xpos, y + h / 2 - dim / 2, /*dim*/8, dim ), r );
					if ( act ) {
						if ( !dis )
							discol = cg.highlightedText();
						QColorGroup g2( discol, cg.highlight(), white, white, dis ? discol : white, discol, white );
						drawPrimitive( arrow, p, vrect, g2, Style_Enabled );
					if (enabled){
					optionHandler->lastIndicatedMenuItemID = mi->id();
					*(optionHandler->lastIndicatedMenuItemRect) = *(optionHandler->indicatedMenuItemRect);
					optionHandler->indicatedMenuItemRect->setRect(r.x()+popupmenu->x(),r.y()+popupmenu->y(),r.width(),r.height());
					optionHandler->daddyWasAPopup = true;
					p->end();
					p->begin(oldPaintDevice);
					p->drawPixmap(r.x(),r.y(),*optionHandler->indicatedMenuItemPix);
					}
					}
					else {
						if ( !dis )
							discol = optionHandler->textColor();
						QColorGroup g2( discol, cg.background(), white, white, dis ? discol : white, discol, white );
						drawPrimitive( arrow, p, vrect, g2, mi->isEnabled() ? Style_Enabled : Style_Default );
						if (mi->id() == optionHandler->lastIndicatedMenuItemID){
							p->end();
							p->begin(oldPaintDevice);
							p->drawPixmap(r.x(),r.y(),*optionHandler->lastIndicatedMenuItemPix);
						}
						
					}
				}
				break;
			}
			default:
			KStyle::drawControl( element, p, widget, r, cg, flags, opt );
		}
	}


void LiquidStyle::drawControlMask( ControlElement element, QPainter *p, const QWidget *widget, const QRect &r, const QStyleOption& opt ) const {
	switch ( element ) {
			case CE_PushButton: {
				p->fillRect( r, Qt::color1 );
				break;
				}
			default:
			KStyle::drawControlMask( element, p, widget, r, opt );
			break;
		}
	}

void LiquidStyle::drawComplexControlMask( ComplexControl control, QPainter *p, const QWidget *widget, const QRect &r, const QStyleOption &opt ) const {
	switch ( control ) {
			case CC_ComboBox: {
				drawControlMask( CE_PushButton, p, widget, r, opt );
				break;
				}
			default:
			KStyle::drawComplexControlMask( control, p, widget, r, opt );
		}
	}

void LiquidStyle::drawComplexControl( ComplexControl control, QPainter *p, const QWidget *widget, const QRect &r, const QColorGroup &cg, SFlags flags, SCFlags controls, SCFlags active, const QStyleOption &opt ) const {
	switch ( control ) {
			case CC_ComboBox: {
				QPen oldPen( p->pen() );
				if ( controls & SC_ComboBoxArrow ) {
					if ( isHTMLWidget( widget ) || optionHandler->ForceRectButton()) {
						drawRectangularButton( p, cg.button(), r.x(), r.y(), r.width(), r.height(), active == SC_ComboBoxArrow, widget == highlightWidget, true );
						return ;
					}
					else{
						drawCombo( p, cg, cg.button(), r.x(), r.y(), r.width(), r.height(), active == SC_ComboBoxArrow, widget == highlightWidget, true, full );
						if ( controls & SC_ComboBoxEditField ) {
							if ( ( ( const QComboBox * ) widget ) ->editable() ) {
								p->setPen( widget == highlightWidget ? cg.button().dark( 115 ) : cg.background().dark( 140 ));
						//		p->drawLine(r.width()-20,r.y()+1,r.width()-20,r.height()-1);
						//		p->drawLine(r.width()-19,r.y()+1,r.width()-19,r.height()-1);
						//               p->drawRect(r.x()+9, r.y()+1, r.width()-26, r.height()-3);
								p->drawLine( r.x() + 9, r.y() + 1, r.x() + 9, r.bottom() - 3 );
								p->drawLine( r.x() + 10, r.y() + 1, r.right() - 18, r.y() + 1 );
							}
						}
						return;
					}
				}
				p->setPen( oldPen );
				break;
			}
			case CC_ToolButton: {
				const QToolButton *toolbutton = ( const QToolButton * ) widget;

				QRect button, menuarea;
				button = querySubControlMetrics( control, widget, SC_ToolButton, opt );
				menuarea = querySubControlMetrics( control, widget, SC_ToolButtonMenu, opt );
				menuarea.setX(menuarea.x() - 1);

				SFlags bflags = flags,
				                mflags = flags;

				if ( active & SC_ToolButton )
					bflags |= Style_Down;
				if ( active & SC_ToolButtonMenu )
					mflags |= Style_Down;

				if ( widget == highlightWidget )
					bflags |= Style_MouseOver;
				if ( controls & SC_ToolButton ) {
					bool sunken = mflags & ( Style_Down | Style_On );
					bool hover = bflags & Style_MouseOver;
					if ( !optionHandler->useToolButtonFrame() ) {
//						if ( toolbutton->parent() && ( toolbutton->parent() ->inherits( "QToolBar" ) ) ) {
							if ( hover || sunken ){
								if (optionHandler->SmoothToolbuttons()){
//									drawRoundButton( p, cg, cg.button(), cg.background(), button.x(), button.y(), button.width(), button.height(), true, sunken, hover, false, false, btnOffset.x(), btnOffset.y() );
 									drawCombo( p, cg, sunken ? cg.button().dark( 120 ) : cg.button(), button.x(), button.y(), button.width(), button.height()+2, sunken, hover, false, full );
 									p->setPen(cg.background());
 									int x1 = button.x();int x2 = button.x()+1;int x3 = button.width()-1;int x4 = button.width()-2;int y1 = button.height()-1;int y2 = button.height()-2;
 									p->drawPoint(x1,y2);
 									p->drawPoint(x1,y1);
 									p->drawPoint(x2,y1);
 									p->drawPoint(x3,y2);
									p->drawPoint(x3,y1);
									p->drawPoint(x4,y1);
								}
								else{
									drawRectangularButton( p, sunken ? cg.button().dark( 120 ) : cg.button(), button.x(), button.y(), button.width(), button.height(), sunken, hover, false);
									p->setPen(cg.button().dark(160));
									p->drawRect(r);
									p->setPen(cg.background());
									int x1 = button.x();int x2 = button.width()-1;int y1 = button.y();int y2 = button.height()-1;
									p->drawPoint(x1,y1);
									p->drawPoint(x1,y2);
									p->drawPoint(x2,y1);
									p->drawPoint(x2,y2);
								}
							}
							else if (!(toolbutton->parent() && ( toolbutton->parent() ->inherits( "QToolBar" ) ))){
								if (toolbutton->parentWidget() && toolbutton->parentWidget()->backgroundPixmap() && !toolbutton->parentWidget()->backgroundPixmap()->isNull()) {
                    							QPixmap pixmap = *(toolbutton->parentWidget()->backgroundPixmap());
                    							p->drawTiledPixmap( r, pixmap, toolbutton->pos() );
								}
								else if (optionHandler->SmoothToolbuttons()){
									drawCombo( p, cg, sunken ? cg.button().dark( 110 ) : (hover ||  (cg.button() != qApp->palette().active().button())) ? cg.button() : optionHandler->InactiveButtonColor(), button.x(), button.y(), button.width(), button.height()+2, sunken, hover, false, full );
									p->setPen(cg.background());
									int x1 = button.x();int x2 = button.x()+1;int x3 = button.width()-1;int x4 = button.width()-2;int y1 = button.height()-1;int y2 = button.height()-2;
									p->drawPoint(x1,y2);
									p->drawPoint(x1,y1);
									p->drawPoint(x2,y1);
									p->drawPoint(x3,y2);
									p->drawPoint(x3,y1);
									p->drawPoint(x4,y1);
								}
								else{
									drawRectangularButton( p, sunken ? cg.button().dark( 110 ) : (hover ||  (cg.button() != qApp->palette().active().button())) ? cg.button() : optionHandler->InactiveButtonColor(), button.x(), button.y(), button.width(), button.height(), sunken, hover, false);
									p->setPen(cg.background());
									int x1 = button.x();int x2 = button.width()-1;int y1 = button.y();int y2 = button.height()-1;
									p->drawPoint(x1,y1);
									p->drawPoint(x1,y2);
									p->drawPoint(x2,y1);
									p->drawPoint(x2,y2);
								}
							}
					}
					else{
						if (optionHandler->SmoothToolbuttons()){
							drawCombo( p, cg, sunken ? cg.button().dark( 110 ) : (hover ||  (cg.button() != qApp->palette().active().button())) ? cg.button() : optionHandler->InactiveButtonColor(), button.x(), button.y(), button.width(), button.height()+2, sunken, hover, false, full );
						}
						else{
							drawRectangularButton( p, sunken ? cg.button().dark( 110 ) : (hover ||  (cg.button() != qApp->palette().active().button())) ? cg.button() : optionHandler->InactiveButtonColor(), r.x(), r.y(), r.width(), r.height(), sunken, hover, false);
							p->setPen(sunken || hover ? cg.button().dark(160) : cg.background().dark(200));
							p->drawRect(r);
						}
						}
					}
				// Draw a toolbutton menu indicator if required
				if ( controls & SC_ToolButtonMenu ) {
					if ( mflags & ( Style_Down | Style_On | Style_Raised ) )
						drawPrimitive( PE_ButtonDropDown, p, menuarea, cg, mflags, opt );
					drawPrimitive( PE_ArrowDown, p, menuarea, cg, mflags, opt );
					}

				if ( toolbutton->hasFocus() && !toolbutton->focusProxy() ) {
					QRect fr = toolbutton->rect();
					fr.addCoords( 3, 3, -3, -3 );
					drawPrimitive( PE_FocusRect, p, fr, cg );
					}
				break;
				}
			case CC_ScrollBar: {
				const_cast<LiquidStyle*>( this ) ->currentScrollBar =
				    ( QScrollBar * ) widget;
				KStyle::drawComplexControl( control, p, widget, r, cg, flags,
				                            controls, active, opt );
				break;
				}
/*			case CC_Slider:{
			if (optionHandler->drawGroupBoxShadow() && widget->parentWidget() && widget->parentWidget()->inherits("QGroupBox")){
			    QRect groove = querySubControlMetrics(CC_Slider, widget,
			                                          SC_SliderGroove, opt);
			    QRect handle = querySubControlMetrics(CC_Slider, widget,
			                                          SC_SliderHandle, opt);
			    if((controls & SC_SliderGroove) && groove.isValid())
			        drawKStylePrimitive(KPE_SliderGroove, p, widget, groove, cg,
			                            flags, opt);
			    if(controls & SC_SliderTickmarks)
			        QCommonStyle::drawComplexControl(control, p, widget, r, cg,
			                                         flags, SC_SliderTickmarks,
			                                         active, opt);
			    if((controls & SC_SliderHandle) && handle.isValid())
			        drawKStylePrimitive(KPE_SliderHandle, p, widget, handle, cg,
			                            flags, opt);
			    break;
			}else{
				KStyle::drawComplexControl( control, p, widget, r, cg, flags, controls, active, opt );
				break;
				}
			}*/

		// SLIDER - KDE code for double buffering
		// -------------------------------------------------------------------
		case CC_Slider: {
			const QSlider* slider = (const QSlider*)widget;
			QRect groove = querySubControlMetrics(CC_Slider, widget, SC_SliderGroove, opt);
			QRect handle = querySubControlMetrics(CC_Slider, widget, SC_SliderHandle, opt);

			// Double-buffer slider for no flicker
			QPixmap pix(widget->size());
			QPainter p2;
			p2.begin(&pix);
			bool gbs;

			if ( slider->parentWidget() &&
				 ((gbs = (optionHandler->drawGroupBoxShadow() && slider->parentWidget()->inherits("QGroupBox"))) || (slider->parentWidget()->backgroundPixmap() && !slider->parentWidget()->backgroundPixmap()->isNull() ))) {
				QPixmap pixmap = /*(optionHandler->drawGroupBoxShadow() && slider->parentWidget()->inherits("QGroupBox")/* && ((QGroupBox *)(slider->parentWidget()))->frameShape() == QFrame::GroupBoxPanel)*/ gbs ? *groupShadow : *(slider->parentWidget()->backgroundPixmap());
				p2.drawTiledPixmap(r, pixmap, slider->pos());
			} else
				pix.fill(cg.background());

			// Draw slider groove
			if ((controls & SC_SliderGroove) && groove.isValid()) {
				drawKStylePrimitive( KPE_SliderGroove, &p2, widget, groove, cg, flags, opt );

				// Draw the focus rect around the groove
/*				if (slider->hasFocus())
					drawPrimitive(PE_FocusRect, &p2, groove, cg);*/
			}

			// Draw the tickmarks
			if (controls & SC_SliderTickmarks)
				QCommonStyle::drawComplexControl(control, &p2, widget,
						r, cg, flags, SC_SliderTickmarks, active, opt);

			// Draw the slider handle
			if ((controls & SC_SliderHandle) && handle.isValid()) {
				if (active == SC_SliderHandle)
					flags |= Style_Active;
				drawKStylePrimitive( KPE_SliderHandle, &p2, widget, handle, cg, flags, opt );
			}

			p2.end();
			bitBlt((QWidget*)widget, r.x(), r.y(), &pix);
			break;
		}

#ifndef QT_NO_LISTVIEW
			case CC_ListView: {
				if ( controls & SC_ListView ) {
					QCommonStyle::drawComplexControl( control, p, widget, r, cg, flags, controls, active, opt );
					}
				if ( controls & ( SC_ListViewBranch | SC_ListViewExpand ) ) {
					if ( opt.isDefault() )
						break;

					QListViewItem *item = opt.listViewItem();
					QListViewItem *child = item->firstChild();
					QListView* v = item->listView();
					bool drawDotlines = optionHandler->DrawDotlines();
					static QBitmap *verticalLine = 0, *horizontalLine = 0;
					static QCleanupHandler<QBitmap> qlv_cleanup_bitmap;
					int dotoffset = 0;

					if (drawDotlines && (optionHandler->DotlineStyle() == Dots)){
						if ( !verticalLine ) {
							// make 128*1 and 1*128 bitmaps that can be used for
							// drawing the right sort of lines.
							verticalLine = new QBitmap( 1, 129, TRUE );
							horizontalLine = new QBitmap( 128, 1, TRUE );
							QPointArray a( 64 );
							QPainter p;
							p.begin( verticalLine );
							int i;
							for( i=0; i<64; i++ )
								a.setPoint( i, 0, i*2+1 );
							p.setPen( optionHandler->DotlineColor() );
							p.drawPoints( a );
							p.end();
							QApplication::flushX();
							verticalLine->setMask( *verticalLine );
							p.begin( horizontalLine );
							for( i=0; i<64; i++ )
								a.setPoint( i, i*2+1, 0 );
							p.setPen( optionHandler->DotlineColor() );
							p.drawPoints( a );
							p.end();
							QApplication::flushX();
							horizontalLine->setMask( *horizontalLine );
							qlv_cleanup_bitmap.add( &verticalLine );
							qlv_cleanup_bitmap.add( &horizontalLine );
						}
					}


					int y = r.y();
					int c;
					QPointArray dotlines;
					if ( drawDotlines && active == SC_All && controls == SC_ListViewExpand ) {
						c = 2;
						dotlines.resize( 2 );
						dotlines[ 0 ] = QPoint( r.right(), r.top() );
						dotlines[ 1 ] = QPoint( r.right(), r.bottom() );
						} else {
						int linetop = 0, linebot = 0;
						// each branch needs at most two lines, ie. four end points
						dotoffset = (item->itemPos() + item->height() - y) %2;
						dotlines.resize( item->childCount() * 4 );
						c = 0;

						// skip the stuff above the exposed rectangle
						while ( child && y + child->height() <= 0 ) {
							y += child->totalHeight();
							child = child->nextSibling();
							}

						int bx = r.width() / 2;

						// paint stuff in the magical area
						while ( child && y < r.height() ) {
							int lh;
							if ( !item->multiLinesEnabled() )
								lh = child ? child->height() : 0;
							else
								lh = p->fontMetrics().height() + 2 * v->itemMargin();
							lh = QMAX( lh, QApplication::globalStrut().height() );
							if ( lh % 2 > 0 )
								lh++;
							linebot = y + lh / 2;
							if ( ( child->isExpandable() || child->childCount() ) &&
							        ( child->height() > 0 ) ) {
								if ( optionHandler->ExpanderStyle() == MS ) { // f****** M$ +/- style :-(
									// needs a box
									p->setPen( optionHandler->DotlineColor() );
									p->drawRect( bx - 4, linebot - 4, 9, 9 );
									// plus or minus
									p->setPen( optionHandler->UseCustomExpanderColor() ? optionHandler->CustomExpanderColor() : cg.text() );
									p->drawLine( bx - 2, linebot, bx + 2, linebot );
									if ( !child->isOpen() )
										p->drawLine( bx, linebot - 2, bx, linebot + 2 );
									} else { // ultracool triangles ;-)
									QPointArray a;
									p->setPen( optionHandler->UseCustomExpanderColor() ? optionHandler->CustomExpanderColor() : cg.text() );
									if ( child->isOpen() ) {
										a.setPoints( 3, bx - 4, linebot - 2,
										             bx, linebot + 2,
										             bx + 4, linebot - 2 );
										} //DownArrow
									else {
										a.setPoints( 3, bx - 2, linebot - 4,
										             bx + 2, linebot,
										             bx - 2, linebot + 4 );
										} //RightArrow
									p->setBrush( optionHandler->UseCustomExpanderColor() ? optionHandler->CustomExpanderColor() : cg.text() );
									p->drawPolygon( a );

									p->setBrush( NoBrush );
									}
								// dotlinery
								if ( drawDotlines ) {
									dotlines[ c++ ] = QPoint( bx, linetop );
									dotlines[ c++ ] = QPoint( bx, linebot - (/* optionHandler->plusMinus() ? 4 : */5 ) );
									dotlines[ c++ ] = QPoint( bx + 5, linebot );
									dotlines[ c++ ] = QPoint( r.width(), linebot );
									linetop = linebot + 5;
									}
								} else {
								// just dotlinery
								if ( drawDotlines ) {
									dotlines[ c++ ] = QPoint( bx + 2, linebot );
									dotlines[ c++ ] = QPoint( r.width(), linebot );
									}
								}

							y += child->totalHeight();
							child = child->nextSibling();
							}

						// Expand line height to edge of rectangle if there's a
						// child, and it's visible
						if ( child && ( child->height() > 0 ) ) {
							linebot = r.height();
							}

						if ( drawDotlines ) {
							if ( linetop < linebot ) {
								dotlines[ c++ ] = QPoint( bx, linetop );
								dotlines[ c++ ] = QPoint( bx, linebot );
								}
							}
					}

					if ( drawDotlines && optionHandler->DotlineStyle() == Line) {
						int line; // index into dotlines
						p->setPen( optionHandler->DotlineColor() );

						if ( controls & SC_ListViewBranch )
							for ( line = 0; line < c; line += 2 ) {
								p->drawLine( dotlines[ line ].x(), dotlines[ line ].y(),
								             dotlines[ line + 1 ].x(), dotlines[ line + 1 ].y() );
								}

						}
					else if (drawDotlines && (optionHandler->DotlineStyle() == Dots)) {
						int line; // index into dotlines
						if ( controls & SC_ListViewBranch ){
							p->setPen( optionHandler->DotlineColor() );
							for( line = 0; line < c; line += 2 ) {
						// assumptions here: lines are horizontal or vertical.
						// lines always start with the numerically lowest
						// coordinate.

						// point ... relevant coordinate of current point
						// end ..... same coordinate of the end of the current line
						// other ... the other coordinate of the current point/line
								if ( dotlines[line].y() == dotlines[line+1].y() ) {
									int end = dotlines[line+1].x();
									int point = dotlines[line].x();
									int other = dotlines[line].y();
									while( point < end ) {
										int i = 128;
										if ( i+point > end )
										i = end-point;
										p->drawPixmap( point, other, *horizontalLine, 0, 0, i, 1 );
										point += i;
									}
								}
								else {
									int end = dotlines[line+1].y();
									int point = dotlines[line].y();
									int other = dotlines[line].x();
									int pixmapoffset = ((point & 1) != dotoffset ) ? 1 : 0;
									while( point < end ) {
										int i = 128;
										if ( i+point > end )
											i = end-point;
										p->drawPixmap( other, point, *verticalLine, 0, pixmapoffset, 1, i );
										point += i;
									}
								}
							}
						}
					}
				}

				break;
				}
#endif // QT_NO_LISTVIEW

			default:
			KStyle::drawComplexControl( control, p, widget,
			                            r, cg, flags, controls, active, opt );
			break;
		}
	}

int LiquidStyle::styleHint(StyleHint sh, const QWidget * w, const QStyleOption & opt, QStyleHintReturn * shr) const{
		switch (sh){
			case QStyle::SH_GUIStyle:
				return MacStyle;
				break;
			case QStyle::SH_TabBar_Alignment:
				if (optionHandler->CenterTabs()){
				if (!QApplication::reverseLayout())
					return AlignHCenter;
				else
					return KStyle::styleHint(sh, w, opt, shr);
				}
				break;
			default:
				return KStyle::styleHint(sh, w, opt, shr);
		}
}

QRect LiquidStyle::subRect( SubRect r, const QWidget *widget ) const {
	return ( KStyle::subRect( r, widget ) );
	}

int LiquidStyle::pixelMetric( PixelMetric m, const QWidget *widget ) const {
	switch ( m ) {
			case PM_ButtonMargin:
			return ( 5 );
			break;
			case PM_ButtonDefaultIndicator:
			return ( 0 );
			break;
//			case PM_MenuButtonIndicator:
//			return (8);
//			break;
			case PM_ExclusiveIndicatorWidth:
			case PM_ExclusiveIndicatorHeight:
			return ( 16 );
			break;
			case PM_IndicatorWidth:
			case PM_IndicatorHeight:
			return ( 16 );
			break;
			case PM_ScrollBarExtent:
			return ( 15 );
			break;
			case PM_ScrollBarSliderMin:
			return ( 40 );
			break;
			case PM_SliderControlThickness:
			return(15);
			case PM_SliderThickness:
			return ( 22 );
			break;
			case PM_SliderLength:
			return ( 13 );
			break;
			case PM_TabBarTabOverlap:
			case PM_TabBarBaseOverlap:
			return ( 1 );
			break;
			case PM_TabBarTabHSpace:
			return ( 27 );
			break;
			case PM_TabBarTabVSpace:
			return ( 8 );
			break;
			case PM_TabBarBaseHeight:
			return ( 5 );
			break;
			case PM_ButtonShiftHorizontal:
			return( 0 );
			break;
			default:
			break;
		}
	return KStyle::pixelMetric( m, widget );
	}

QSize LiquidStyle::sizeFromContents( ContentsType contents,
                                     const QWidget *widget,
                                     const QSize &contentSize,
                                     const QStyleOption& opt ) const {
	switch ( contents ) {
			case CT_PushButton: {
				// this is a little funky - we give values not based on pixelMetric
				// because we want a custom width/height and we can only give one
				// value in pixelMetric (used in sizeHint). Odd but works well
				const QPushButton * button = ( const QPushButton* ) widget;

				int w = contentSize.width() + 26 > 80 ? contentSize.width() + 26 : 80;
				int h = contentSize.height() > 24 ? contentSize.height() : 25;

				if ( button->text().isEmpty() )
					return ( QSize( contentSize.width() + 2 * pixelMetric( PM_ButtonMargin, widget ), h ) );

				return ( QSize( w, h ) );
				}

/*			case CT_ToolButton: {
				int w = (int)(1.5*widget->height());
				if (contentSize.width() > w)
					w = contentSize.width();
				return ( QSize( w, contentSize.height() + 6));
//				int h = contentSize.height() > 24 ? contentSize.height() : 24;
				}*/

			case CT_Slider: {
//				int w = contentSize.width() + 26 > 80 ? contentSize.width() + 26 : 80;
				int h = contentSize.height() > 24 ? contentSize.height() : 24;
				return ( QSize( contentSize.width(), h ) );
				}

			case CT_ComboBox: {
				QSize sz = KStyle::sizeFromContents( contents, widget, contentSize, opt );
				return ( QSize( sz.width()+3, sz.height() > 25 ? sz.height() : 25 ) );
				}
			case CT_PopupMenuItem: {
				if ( ! widget || opt.isDefault() )
					break;

				const QPopupMenu *popup = ( const QPopupMenu * ) widget;
				bool checkable = popup->isCheckable();
				QMenuItem *mi = opt.menuItem();
				int maxpmw = opt.maxIconWidth();
				int w = contentSize.width();
				int h = contentSize.height();

				if ( mi->custom() ) {
					w = mi->custom() ->sizeHint().width();
					h = mi->custom() ->sizeHint().height();
					if ( !mi->custom() ->fullSpan() )
						h += 2 * windowsItemVMargin + 2 * windowsItemFrame;
					} else if ( mi->widget() ) {}
				else if ( mi->isSeparator() ) {
					w = 10;
					h = windowsSepHeight;
					} else {
					if ( mi->pixmap() )
						h = QMAX( h, mi->pixmap() ->height() + 2 * windowsItemFrame );
					else if ( ! mi->text().isNull() )
						h = QMAX( h, popup->fontMetrics().height() + 2 * windowsItemVMargin +
						          2 * windowsItemFrame );
					if ( mi->iconSet() != 0 )
						h = QMAX( h, mi->iconSet() ->pixmap( QIconSet::Small,
						                                     QIconSet::Normal ).height() +
						          2 * windowsItemFrame );
					}
				if ( !mi->text().isNull() && mi->text().find( '\t' ) >= 0 )
					w += windowsTabSpacing;
				else if ( mi->popup() )
					w += 2 * windowsArrowHMargin;
				if ( checkable && maxpmw < 20 )
					w += 20 - maxpmw;
				if ( maxpmw )
					w += maxpmw + 6;
				if ( checkable || maxpmw > 0 )
					w += windowsCheckMarkHMargin;
				w += 20;
				return ( QSize( w, h ) );
				}
			default:
			break;
		}
	return KStyle::sizeFromContents( contents, widget, contentSize, opt );
	}


QPixmap LiquidStyle::stylePixmap( StylePixmap stylepixmap,
                                  const QWidget* widget,
                                  const QStyleOption& opt ) const {
	return KStyle::stylePixmap( stylepixmap, widget, opt );
	}

bool LiquidStyle::eventFilter( QObject *obj, QEvent *ev ) {
//	if (  obj->inherits( "KMListView" ) )
//		qWarning("Event: %d",ev->type());
//		qWarning("%s, %d",obj->className(),ev->type());
//	if (obj->isA("QTab")){
//		qWarning("Event: %d",ev->type());
//	}
	if (KStyle::eventFilter( obj, ev ))
		return true;
		
//	if (!obj->isWidgetType() ) {qWarning("NO WIDGET!");return false;}
	
		else if ( obj->inherits( "QDockWindow" ) ) {
		QWidget * w = ( QWidget * ) obj;
		if ( ev->type() == QEvent::Paint ) {
			QPaintEvent * pev = ( QPaintEvent * ) ev;
			w->erase( pev->rect() );
			return ( true );
		}
		else if ( w->backgroundMode() != Qt::PaletteBackground ) {
		// Qt resets the background mode during init. We want to
		// change if back right away because it does an erase before
		// painting which would look ugly in the wrong color and toolbar
		// separators got the wrong palette :P
			w->setBackgroundMode( Qt::PaletteBackground );
			w->setBackgroundOrigin( QWidget::WindowOrigin );
			return ( false );
		}
		} else if ( obj->inherits( "QPushButton" ) || obj->inherits( "QComboBox" ) ||
	            obj->inherits( "QSplitterHandle" ) ||
	            obj->inherits( "AppletHandleDrag" ) ) {
		QWidget * btn = ( QWidget * ) obj;
		if ( ev->type() == QEvent::Enter ) {
			if ( btn->isEnabled() ) {
				highlightWidget = btn;
				btn->repaint( false );
				}
			} else if ( ev->type() == QEvent::Leave ) {
			if ( btn == highlightWidget ) {
				highlightWidget = NULL;
				btn->repaint( false );
				}
			}
		} else if ( obj->inherits( "KToolBarButton" ) ) {
		QToolButton * btn = ( QToolButton * ) obj;
		if ( ev->type() == QEvent::Enter ) {
			if ( btn->isEnabled() ) {
				highlightWidget = btn;
				btn->repaint( false );
				}
			} else if ( ev->type() == QEvent::Leave ) {
			QWidget * btn = ( QWidget * ) obj;
			if ( btn == highlightWidget ) {
				highlightWidget = NULL;
				btn->repaint( false );
				}
			}
		}
		else if ( obj->inherits( "QScrollView" ) /* || obj->inherits( "KScrollView" )*/) {
			QScrollView *sv = ( QScrollView * ) obj;
			if ( ( ev->type() == QEvent::Enter )){
				optionHandler->setScrollerActive();
				if (!(highlightWidget == sv->verticalScrollBar()))
					sv->verticalScrollBar()->repaint(false);
				if (!(highlightWidget == sv->horizontalScrollBar()))
					sv->horizontalScrollBar()->repaint(false);
			}
			else if( ev->type() == QEvent::Leave )  {
				optionHandler->setScrollerInactive();
				if (!(highlightWidget == sv->verticalScrollBar()))
					sv->verticalScrollBar()->repaint(false);
				if (!(highlightWidget == sv->horizontalScrollBar()))
					sv->horizontalScrollBar()->repaint(false);
			}
		}
		else if ( obj->inherits( "KateView" ) || obj->inherits( "TEWidget") || obj->inherits("CHexViewWidget")) {
			if ( ( ev->type() == QEvent::Enter )){
				QObjectList *scrollerList = obj->queryList( "QScrollBar" );
				optionHandler->setScrollerActive();
				for (int i= 0; i < scrollerList->count(); i++)
					((QWidget*)(scrollerList->at(i)))->repaint();
			}
			else if( ev->type() == QEvent::Leave )  {
				QObjectList *scrollerList = obj->queryList( "QScrollBar" );
				optionHandler->setScrollerInactive();
				for (int i= 0; i < scrollerList->count(); i++)
					((QWidget*)(scrollerList->at(i)))->repaint();
			}
		} 
		else if (obj->inherits("KDockWidgetAbstractHeaderDrag")){
			if ( ev->type() == QEvent::Enter || ev->type() == QEvent::Leave )
				((QWidget *)obj)->repaint();
		}
		else if ( obj->inherits( "QScrollBar" ) ) {
		QScrollBar * sb = ( QScrollBar * ) obj;
		if ( ev->type() == QEvent::Enter && !sb->draggingSlider() ) {
			if ( sb->isEnabled() ) {
				activeScroller = sb;
				highlightWidget = sb;
				sb->repaint( false );
				}
			} else if ( ev->type() == QEvent::Leave ) {
			if ( sb == highlightWidget && !sb->draggingSlider() ) {
				activeScroller = NULL;
				highlightWidget = NULL;
				sb->repaint( false );
				}
			} else if ( ev->type() == QEvent::MouseButtonPress ){
				activeScroller = NULL;
				sb->repaint( false );
			} else if ( ev->type() == QEvent::MouseButtonRelease ) {
			QMouseEvent * me = ( QMouseEvent * ) ev;
				if ( sb == highlightWidget){
					if ( sb->rect().contains( me->pos() ) ) {
						activeScroller = sb;
						// assume, that the user wants to work on in this scrollview, so keep hW = sb
//						highlightWidget = NULL;
						sb->repaint( false );
					}
					else{
					// this assumes, scrollers are either on the right 
					if ( ((sb->orientation() == Vertical) && (me->pos().x() < 0)) || ((sb->orientation() == Horizontal) && (me->pos().y() < 0)) ) {
						optionHandler->setScrollerActive();
//						activeScroller = NULL;
						sb->repaint( false );
					}
					}
				}
			}
		}

		else if ( obj->inherits( "TaskContainer" ) ) {
		QButton * btn = ( QButton * ) obj;
		if ( ev->type() == QEvent::Enter ) {
			currentTaskContainer = btn;
			btn->repaint( false );
			} else if ( ev->type() == QEvent::Leave ) {
			currentTaskContainer = NULL;
			btn->repaint( false );
			} else if ( ev->type() == QEvent::Paint ) {
			isTaskContainer = true;
			if ( currentTaskContainer == btn )
				taskContainerHover = true;
			else
				taskContainerHover = false;
			}
		} else if ( obj->inherits( "KMiniPagerButton" ) ) {
		QButton * btn = ( QButton * ) obj;
		if ( ev->type() == QEvent::Paint ) {
			if ( pagerBrush.pixmap() == NULL ) {
				// color scheme has changed
				QColor c( optionHandler->usePanelCustomColor() ?
				          optionHandler->panelCustomColor().dark( 110 ) :
				          qApp->palette().active().button().dark( 110 ) );
				QPixmap *pix = smallBevelFillDict.find( c.rgb() );
				if ( !pix ) {
					pix = new QPixmap( *smallBevelFillPix );
					adjustHSV( *pix, c );
					smallBevelFillDict.insert( c.rgb(), pix );
					}
				pagerHoverBrush.setColor( c );
				pagerHoverBrush.setPixmap( *pix );

				c = c.dark( 115 );
				pix = smallBevelFillDict.find( c.rgb() );
				if ( !pix ) {
					pix = new QPixmap( *smallBevelFillPix );
					adjustHSV( *pix, c );
					smallBevelFillDict.insert( c.rgb(), pix );
					}
				pagerBrush.setColor( c );
				pagerBrush.setPixmap( *pix );
				}

			if ( !( btn->isOn() || btn->isDown() ) ) {
				QPalette pal = qApp->palette();
				pal.setBrush( QColorGroup::Dark, btn == highlightWidget ?
				              pagerHoverBrush : pagerBrush );
				btn->setPalette( pal );
				} else {
				QPalette pal = qApp->palette();
				pal.setBrush( QColorGroup::Dark,
				              QApplication::palette().active().brush( QColorGroup::Dark ) );
				btn->setPalette( pal );

				}
			} else if ( ev->type() == QEvent::Enter ) {
			highlightWidget = btn;
			btn->repaint( false );
			} else if ( ev->type() == QEvent::Leave ) {
			highlightWidget = NULL;
			btn->repaint( false );
			}
		} 
		else if ( obj->inherits( "QLineEdit" ) ) {
			if ( obj->parent() && obj->parent() ->inherits( "QComboBox" ) ) {
				QWidget * btn = ( QWidget * ) obj->parent();
				if ( ev->type() == QEvent::Enter ) {
					if ( btn->isEnabled() ) {
						highlightWidget = btn;
						btn->repaint( false );
					}
				}
				else if ( ev->type() == QEvent::Leave ) {
					if ( btn == highlightWidget )
						highlightWidget = NULL;
					btn->repaint( false );
				}
			}
			else if ((ev->type() == 8/*QEvent::FocusIn*/) || (ev->type() == 9/*QEvent::FocusOut*/))
				((QWidget *)obj)->repaint(false);
		} 
		else if ( obj->inherits( "QRadioButton" ) || obj->inherits( "QCheckBox" ) ) {
		QButton * btn = ( QButton * ) obj;
		bool isStatusChild = btn->parent() &&
		                     ( btn->parent() ->inherits( "QStatusBar" ) ||
		                       btn->parent() ->inherits( "KonqFrameStatusBar" ) );
		bool isRadio = obj->inherits( "QRadioButton" );
		if ( ev->type() == QEvent::Paint ) {
			btn->erase();
			QPainter p;
			p.begin( btn );
			QFontMetrics fm = btn->fontMetrics();
			QSize lsz = fm.size( ShowPrefix, btn->text() );
			QSize sz = isRadio ?
			           QSize( pixelMetric( PM_ExclusiveIndicatorWidth ),
			                  pixelMetric( PM_ExclusiveIndicatorHeight ) ) :
			           QSize( pixelMetric( PM_IndicatorWidth ),
			                  pixelMetric( PM_IndicatorHeight ) );
			int x = 0;
			int y = isStatusChild ? 0 :
			        ( btn->height() - lsz.height() + fm.height() - sz.height() ) / 2;
			SFlags flags = Style_Default;
			if ( btn->isEnabled() )
				flags |= Style_Enabled;
			if ( btn->hasFocus() )
				flags |= Style_HasFocus;
			if ( btn->isDown() )
				flags |= Style_Down;
			if ( highlightWidget == btn )
				flags |= Style_MouseOver;

			if ( btn->state() == QButton::On )
				flags |= Style_On;
			else if ( btn->state() == QButton::Off )
				flags |= Style_Off;
			if ( isRadio )
				drawControl( CE_RadioButton, &p, btn,
				             QRect( x, y, sz.width(), sz.height() ),
				             btn->colorGroup(), flags );
			else
				drawControl( CE_CheckBox, &p, btn,
				             QRect( x, y, sz.width(), sz.height() ),
				             btn->colorGroup(), flags );
			x = sz.width() + 6;
			y = 0;
			if ( btn->hasFocus() ) {
				QColor tmp( btn->colorGroup().background().dark( 130 ) );
				drawItem( &p, QRect( sz.width() + 6 + 2, 1, btn->width() - ( sz.width() + 6 + 1 ),
				                     btn->height() ), AlignLeft | AlignVCenter | ShowPrefix,
				          btn->colorGroup(), btn->isEnabled(),
				          btn->pixmap(), btn->text(), -1, &tmp );
				drawItem( &p, QRect( sz.width() + 6 + 3, 2, btn->width() - ( sz.width() + 6 + 1 ),
				                     btn->height() ), AlignLeft | AlignVCenter | ShowPrefix,
				          btn->colorGroup(), btn->isEnabled(),
				          btn->pixmap(), btn->text(), -1, &tmp );

				}
			drawItem( &p, QRect( sz.width() + 6 + 1, 0, btn->width() - ( sz.width() + 6 + 1 ),
			                     btn->height() ), AlignLeft | AlignVCenter | ShowPrefix,
			          btn->colorGroup(), btn->isEnabled(),
			          btn->pixmap(), btn->text() );
			p.end();
			return ( true );
			}
		// for hover, just redraw the indicator (not the text)
		else if ( ( ev->type() == QEvent::Enter && btn->isEnabled() ) ||
		          ( ev->type() == QEvent::Leave && btn == highlightWidget ) ) {
			QButton * btn = ( QButton * ) obj;
			bool isRadio = obj->inherits( "QRadioButton" );

			if ( ev->type() == QEvent::Enter )
				highlightWidget = btn;
			else
				highlightWidget = NULL;
			QFontMetrics fm = btn->fontMetrics();
			QSize lsz = fm.size( ShowPrefix, btn->text() );
			QSize sz = isRadio ?
			           QSize( pixelMetric( PM_ExclusiveIndicatorWidth ),
			                  pixelMetric( PM_ExclusiveIndicatorHeight ) ) :
			           QSize( pixelMetric( PM_IndicatorWidth ),
			                  pixelMetric( PM_IndicatorHeight ) );
			int x = 0;
			int y = isStatusChild ? 0 :
			        ( btn->height() - lsz.height() + fm.height() - sz.height() ) / 2;
			//if(btn->autoMask())
			//    btn->erase(x+1, y+1, sz.width()-2, sz.height()-2);
			QPainter p;
			p.begin( btn );
			SFlags flags = Style_Default;
			if ( btn->isEnabled() )
				flags |= Style_Enabled;
			if ( btn->hasFocus() )
				flags |= Style_HasFocus;
			if ( btn->isDown() )
				flags |= Style_Down;
			if ( highlightWidget == btn )
				flags |= Style_MouseOver;

			if ( btn->state() == QButton::On )
				flags |= Style_On;
			else if ( btn->state() == QButton::Off )
				flags |= Style_Off;
			if ( isRadio )
				drawControl( CE_RadioButton, &p, btn,
				             QRect( x, y, sz.width(), sz.height() ),
				             btn->colorGroup(), flags );
			else
				drawControl( CE_CheckBox, &p, btn,
				             QRect( x, y, sz.width(), sz.height() ),
				             btn->colorGroup(), flags );
			p.end();
			}
		} else if ( obj->inherits( "QHeader" ) ) {
		QHeader * hw = ( QHeader * ) obj;
		if ( ev->type() == QEvent::Enter ) {
			currentHeader = hw;
			headerHoverID = -1;
			} else if ( ev->type() == QEvent::Leave ) {
			currentHeader = NULL;
			if ( headerHoverID != -1 ) {
//				hw->repaint( hw->sectionPos( headerHoverID ), 0, hw->sectionSize( headerHoverID ), hw->height() );
				hw->update();
				}
			headerHoverID = -1;
			} else if ( ev->type() == QEvent::MouseMove ) {
			QMouseEvent * me = ( QMouseEvent * ) ev;
			int oldHeader = headerHoverID;
			headerHoverID = hw->sectionAt( me->x() );
			if ( oldHeader != headerHoverID ) {
				// reset old header
				if ( oldHeader != -1 ) {
//					hw->repaint( hw->sectionPos( oldHeader ), 0, hw->sectionSize( oldHeader ), hw->height() );
					hw->update();
					}
				if ( headerHoverID != -1 ) {
//					hw->repaint( hw->sectionPos( headerHoverID ), 0, hw->sectionSize( headerHoverID ), hw->height() );
					hw->update();
					}
				}
			}
		} else if ( obj->inherits( "QTipLabel" ) ) {
		if ( ev->type() == QEvent::PaletteChange ||
		        ev->type() == QEvent::ApplicationPaletteChange ) {
			qWarning( "Got tiplabel palette change" ); // Debug
			( ( QWidget* ) obj ) ->setPalette( tooltipPalette );
			return ( true );
			}
		} else if ( obj->inherits( "KActiveLabel" ) && !isPlain() ) {
		if ( ev->type() == QEvent::Move || ev->type() == QEvent::Resize ||
		        ev->type() == QEvent::Show ) {
			QWidget * w = ( QWidget * ) obj;
			QPalette pal( w->palette() );
			QPixmap *tile = pal.brush( QPalette::Active,
			                           QColorGroup::Background ).pixmap();
			if ( tile ) {
				QPoint pos( 0, 0 );
				pos = w->mapTo( w->topLevelWidget(), pos );
				QSize sz( ev->type() == QEvent::Resize ?
				          ( ( QResizeEvent* ) ev ) ->size() : w->size() );
				QPixmap pix( 24, sz.height() );
				QPainter p;
				p.begin( &pix );
				p.drawTiledPixmap( 0, 0, 24, sz.height(), *tile,
				                   0, pos.y() );
				p.end();
				QBrush brush( pal.active().background(), pix );
				pal.setBrush( QColorGroup::Base, brush );
				w->setPalette( pal );
				}
			}
		}
	return ( false );
	}

QRect LiquidStyle::querySubControlMetrics( ComplexControl control, const QWidget *widget, SubControl subcontrol, const QStyleOption &opt ) const {
	if ( control == CC_ComboBox && subcontrol == SC_ComboBoxEditField ) {
		return ( QRect( 10, 2, widget->width() - 28, widget->height() - 6 ) );
		} else
		return ( KStyle::querySubControlMetrics( control, widget, subcontrol, opt ) );
	}

QPixmap* LiquidStyle::processEmbedded( const char *label, const QColor &c, bool blend, const QColor *bg ) const {
	QImage img( liquid_findImage( label ) );
	img.detach();
	if ( img.isNull() ) { // shouldn't happen, been tested
		qWarning( "Invalid embedded label %s", label );
		return ( NULL );
		}
	return ( adjustHSV( img, c, blend, bg ) );
	}

QPixmap* LiquidStyle::getPixmap( BitmapData item ) const {
	QColor bgColor( isKicker ? origPanelBrush.color() :
	                qApp->palette().active().background() );
	QColor btnColor( qApp->palette().active().button() );
	QColor btnHoverColor( btnColor.light( 120 ) );
	QColor sbGrooveColor( optionHandler->useCustomColors() ?
	                      optionHandler->customColor( CustomSBGroove ) : bgColor );
	QColor sbSliderColor( optionHandler->useCustomColors() ?
	                      optionHandler->customColor( CustomSBSlider ) : bgColor );
	QColor sbSliderHoverColor( optionHandler->useCustomColors() ?
	                      optionHandler->customColor( CustomSBSliderHover ) : btnColor.light(110) );
	QColor sbSliderPressedColor( optionHandler->useCustomColors() ?
	                      optionHandler->customColor( CustomSBSliderPressed ) : btnColor );

	if ( pixmaps[ item ] )
		return ( pixmaps[ item ] );
	LiquidStyle *ptr = const_cast<LiquidStyle*>( this );
	switch ( item ) {
/*			case transsel:
			ptr->pixmaps[ transsel ] = processEmbedded( "transsel", btnColor, true );
			break;*/
			case RadioOn:
			ptr->pixmaps[ RadioOn ] = processEmbedded( "radio_down", optionHandler->useCustomColors() ? optionHandler->customColor( CustomRadioOn ) : btnColor, true );
			break;
			case RadioOnHover:
			ptr->pixmaps[ RadioOnHover ] = processEmbedded( "radio_down", optionHandler->useCustomColors() ? optionHandler->customColor( CustomRadioOn ).light( 110 ) : btnHoverColor, true );
			break;
			case RadioOffHover:
			ptr->pixmaps[ RadioOffHover ] = processEmbedded( "radio", optionHandler->useCustomColors() ? optionHandler->customColor( CustomRadioOn ) : btnColor, true );
			case RadioOnPressed:
			ptr->pixmaps[ RadioOnPressed ] = processEmbedded( "radio_down", optionHandler->useCustomColors() ? optionHandler->customColor( CustomRadioOn ).dark( 120 ) : btnHoverColor.dark( 120 ), true );
			break;
			case RadioOffPressed:
			ptr->pixmaps[ RadioOffPressed ] = processEmbedded( "radio", optionHandler->useCustomColors() ? optionHandler->customColor( CustomRadioOn ).dark( 120 ) : btnColor.dark( 120 ), true );
			break;
			case TabDown:
			ptr->pixmaps[ TabDown ] = processEmbedded( "tab", optionHandler->useCustomColors() ? optionHandler->customColor( CustomTabOn ) : btnColor, true );
			break;
			case belowTabDown:
			ptr->pixmaps[ belowTabDown ] = processEmbedded( "tab", optionHandler->useCustomColors() ? optionHandler->customColor( CustomTabOn ) : btnColor, true );
			*ptr->pixmaps[ belowTabDown ] = ptr->pixmaps[ belowTabDown ] ->xForm( iMatrix );
			break;
			case TabFocus:
			ptr->pixmaps[ TabFocus ] = processEmbedded( "tab", optionHandler->useCustomColors() ? optionHandler->customColor( CustomTabOn ).light( 120 ) : btnHoverColor, true );
			break;
			case CBDown:
			ptr->pixmaps[ CBDown ] = processEmbedded( "checkboxdown", optionHandler->useCustomColors() ? optionHandler->customColor( CustomCBOn ) : btnColor, true );
			break;
			case CBDownHover:
			ptr->pixmaps[ CBDownHover ] = processEmbedded( "checkboxdown", optionHandler->useCustomColors() ? optionHandler->customColor( CustomCBOn ).light( 110 ) : btnHoverColor, true );
			break;
			case CBHover:
			ptr->pixmaps[ CBHover ] = processEmbedded( "checkbox", optionHandler->useCustomColors() ? optionHandler->customColor( CustomCBOn ) : btnColor, true );
			break;
			case CBDownPressed:
			ptr->pixmaps[ CBDownPressed ] = processEmbedded( "checkboxdown", optionHandler->useCustomColors() ? optionHandler->customColor( CustomCBOn ).dark( 120 ) : btnHoverColor.dark( 120 ), true );
			break;
			case CBPressed:
			ptr->pixmaps[ CBPressed ] = processEmbedded( "checkbox", optionHandler->useCustomColors() ? optionHandler->customColor( CustomCBOn ).dark( 120 ) : btnColor.dark( 120 ), true );
			break;
			case HSlider:
			ptr->pixmaps[ HSlider ] = processEmbedded( "sliderarrow", btnColor, true );
			break;
			case VSlider:
			ptr->pixmaps[ VSlider ] = processEmbedded( "sliderarrow", btnColor, true );
			*ptr->pixmaps[ VSlider ] = ptr->pixmaps[ VSlider ] ->xForm( lMatrix );
			break;
			case VSliderAbove:
			ptr->pixmaps[ VSliderAbove ] = processEmbedded( "sliderarrow", btnColor, true );
			*ptr->pixmaps[ VSliderAbove ] = ptr->pixmaps[ VSliderAbove ] ->xForm( rMatrix );
			break;
			case RadioOff:
			ptr->pixmaps[ RadioOff ] = processEmbedded( "radio", optionHandler->useCustomColors() ? optionHandler->customColor( CustomRadioOff ) : bgColor, true );
			break;
			case Tab:
			ptr->pixmaps[ Tab ] = processEmbedded( "tab", optionHandler->useCustomColors() ? optionHandler->customColor( CustomTabOff ) : optionHandler->InactiveButtonColor(), true );
			break;
			case belowTab:
			ptr->pixmaps[ belowTab ] = processEmbedded( "tab", optionHandler->useCustomColors() ? optionHandler->customColor( CustomTabOff ) : optionHandler->InactiveButtonColor(), true );
			*ptr->pixmaps[ belowTab ] = ptr->pixmaps[ belowTab ] ->xForm( iMatrix );
			break;			
			case CB:
			ptr->pixmaps[ CB ] = processEmbedded( "checkbox", optionHandler->useCustomColors() ? optionHandler->customColor( CustomCBOff ) : bgColor, true );
			break;
			case VSBSliderTop:
			ptr->pixmaps[ VSBSliderTop ] = optionHandler->shadowSbSlider() ? createSliderEnd( sbSliderColor, sbGrooveColor.dark( 120 ), true) : processEmbedded( "sbslider_top", sbSliderColor, true, &sbGrooveColor );
			break;
			case VSBSliderBtm:
			ptr->pixmaps[ VSBSliderBtm ] = optionHandler->shadowSbSlider() ? createSliderEnd( sbSliderColor, sbGrooveColor.dark( 120 ), false) : processEmbedded( "sbslider_btm", sbSliderColor, true, &sbGrooveColor );
			break;
			case VSBSliderMid:
			ptr->pixmaps[ VSBSliderMid ] = processEmbedded( "sbslider_mid", sbSliderColor, &sbGrooveColor );
			break;
			case VSBSliderTopActive:
			ptr->pixmaps[ VSBSliderTopActive ] = optionHandler->shadowSbSlider() ? createSliderEnd( sbSliderHoverColor, sbGrooveColor.dark( 120 ), true) : processEmbedded( "sbslider_top", sbSliderHoverColor, true, &sbGrooveColor );
			break;
			case VSBSliderBtmActive:
			ptr->pixmaps[ VSBSliderBtmActive ] = optionHandler->shadowSbSlider() ? createSliderEnd( sbSliderHoverColor, sbGrooveColor.dark( 120 ), false) : processEmbedded( "sbslider_btm", sbSliderHoverColor, true, &sbGrooveColor );
			break;
			case VSBSliderMidActive:
			ptr->pixmaps[ VSBSliderMidActive ] = processEmbedded( "sbslider_mid", sbSliderHoverColor, false, &sbGrooveColor );
			break;
			case VSBSliderTopHover:
			ptr->pixmaps[ VSBSliderTopHover ] = optionHandler->shadowSbSlider() ? createSliderEnd( sbSliderHoverColor.light(120), sbGrooveColor.dark( 120 ), true) : processEmbedded( "sbslider_top", sbSliderHoverColor.light(120), true, &sbGrooveColor );
			break;
			case VSBSliderBtmHover:
			ptr->pixmaps[ VSBSliderBtmHover ] = optionHandler->shadowSbSlider() ? createSliderEnd( sbSliderHoverColor.light(120), sbGrooveColor.dark( 120 ), false) : processEmbedded( "sbslider_btm", sbSliderHoverColor.light(120), true, &sbGrooveColor );
			break;
			case VSBSliderMidHover:
			ptr->pixmaps[ VSBSliderMidHover ] = processEmbedded( "sbslider_mid", sbSliderHoverColor.light(120), false, &sbGrooveColor );
			break;
			case VSBSliderTopPressed:
			ptr->pixmaps[ VSBSliderTopPressed ] = processEmbedded( "sbslider_top", sbSliderPressedColor, true, &sbGrooveColor );
			break;
			case VSBSliderBtmPressed:
			ptr->pixmaps[ VSBSliderBtmPressed ] = processEmbedded( "sbslider_btm", sbSliderPressedColor, true, &sbGrooveColor );
			break;
			case VSBSliderMidPressed:
			ptr->pixmaps[ VSBSliderMidPressed ] = processEmbedded( "sbslider_mid", sbSliderPressedColor, false, &sbGrooveColor );
			break;

			case HSBSliderTop:
			ptr->pixmaps[ HSBSliderTop ] = optionHandler->shadowSbSlider() ? createSliderEnd( sbSliderColor, sbGrooveColor.dark( 120 ), true) : processEmbedded( "sbslider_top", sbSliderColor, true, &sbGrooveColor );
			*ptr->pixmaps[ HSBSliderTop ] = ptr->pixmaps[ HSBSliderTop ]->xForm( rMatrix );
			break;
			case HSBSliderBtm:
			ptr->pixmaps[ HSBSliderBtm ] = optionHandler->shadowSbSlider() ? createSliderEnd( sbSliderColor, sbGrooveColor.dark( 120 ), false) : processEmbedded( "sbslider_btm", sbSliderColor, true, &sbGrooveColor );
			*ptr->pixmaps[ HSBSliderBtm ] = ptr->pixmaps[ HSBSliderBtm ] ->xForm( rMatrix );
			break;
			case HSBSliderMid:
			ptr->pixmaps[ HSBSliderMid ] = processEmbedded( "sbslider_mid", sbSliderColor, false, &sbGrooveColor );
			*ptr->pixmaps[ HSBSliderMid ] = ptr->pixmaps[ HSBSliderMid ]->xForm( rMatrix );
			break;
			case HSBSliderTopActive:
			ptr->pixmaps[ HSBSliderTopActive ] = optionHandler->shadowSbSlider() ? createSliderEnd( sbSliderHoverColor, sbGrooveColor.dark( 120 ), true) : processEmbedded( "sbslider_top", sbSliderHoverColor, true, &sbGrooveColor );
			*ptr->pixmaps[ HSBSliderTopActive ] = ptr->pixmaps[ HSBSliderTopActive ] ->xForm( rMatrix );
			break;
			case HSBSliderBtmActive:
			ptr->pixmaps[ HSBSliderBtmActive ] = optionHandler->shadowSbSlider() ? createSliderEnd( sbSliderHoverColor, sbGrooveColor.dark( 120 ), false) : processEmbedded( "sbslider_btm", sbSliderHoverColor, true, &sbGrooveColor );
			*ptr->pixmaps[ HSBSliderBtmActive ] = ptr->pixmaps[ HSBSliderBtmActive ] ->xForm( rMatrix );
			break;
			case HSBSliderMidActive:
			ptr->pixmaps[ HSBSliderMidActive ] = processEmbedded( "sbslider_mid", sbSliderHoverColor, false, &sbGrooveColor );
			*ptr->pixmaps[ HSBSliderMidActive ] = ptr->pixmaps[ HSBSliderMidActive ] ->xForm( rMatrix );
			break;
			case HSBSliderTopHover:
			ptr->pixmaps[ HSBSliderTopHover ] = optionHandler->shadowSbSlider() ? createSliderEnd( sbSliderHoverColor.light(120), sbGrooveColor.dark( 120 ), true) : processEmbedded( "sbslider_top", sbSliderHoverColor.light(120), true, &sbGrooveColor );
			*ptr->pixmaps[ HSBSliderTopHover ] = ptr->pixmaps[ HSBSliderTopHover ] ->xForm( rMatrix );
			break;
			case HSBSliderBtmHover:
			ptr->pixmaps[ HSBSliderBtmHover ] = optionHandler->shadowSbSlider() ? createSliderEnd( sbSliderHoverColor.light(120), sbGrooveColor.dark( 120 ), false) : processEmbedded( "sbslider_btm", sbSliderHoverColor.light(120), true, &sbGrooveColor );
			*ptr->pixmaps[ HSBSliderBtmHover ] = ptr->pixmaps[ HSBSliderBtmHover ] ->xForm( rMatrix );
			break;
			case HSBSliderMidHover:
			ptr->pixmaps[ HSBSliderMidHover ] = processEmbedded( "sbslider_mid", sbSliderHoverColor.light(120), false, &sbGrooveColor );
			*ptr->pixmaps[ HSBSliderMidHover ] = ptr->pixmaps[ HSBSliderMidHover ] ->xForm( rMatrix );
			break;
			case HSBSliderTopPressed:
			ptr->pixmaps[ HSBSliderTopPressed ] = processEmbedded( "sbslider_top", sbSliderPressedColor, true, &sbGrooveColor );
			*ptr->pixmaps[ HSBSliderTopPressed ] = ptr->pixmaps[ HSBSliderTopPressed ] ->xForm( rMatrix );
			break;
			case HSBSliderBtmPressed:
			ptr->pixmaps[ HSBSliderBtmPressed ] = processEmbedded( "sbslider_btm", sbSliderPressedColor, true, &sbGrooveColor );
			*ptr->pixmaps[ HSBSliderBtmPressed ] = ptr->pixmaps[ HSBSliderBtmPressed ] ->xForm( rMatrix );
			break;
			case HSBSliderMidPressed:
			ptr->pixmaps[ HSBSliderMidPressed ] = processEmbedded( "sbslider_mid", sbSliderPressedColor, false, &sbGrooveColor );
			*ptr->pixmaps[ HSBSliderMidPressed ] = ptr->pixmaps[ HSBSliderMidPressed ] ->xForm( rMatrix );
			break;

			case VSBSliderTopBg:
			ptr->pixmaps[ VSBSliderTopBg ] = processEmbedded( "sbgroove_top", sbGrooveColor, true, &sbGrooveColor );
			break;
			case VSBSliderBtmBg:
			ptr->pixmaps[ VSBSliderBtmBg ] = processEmbedded( "sbgroove_btm", sbGrooveColor, true, &sbGrooveColor );
			break;
			case VSBSliderMidBg:
			ptr->pixmaps[ VSBSliderMidBg ] = processEmbedded( "sbgroove_mid", sbGrooveColor, false, &sbGrooveColor );
			break;
			case VSBSliderMidBgI:
			ptr->pixmaps[ VSBSliderMidBgI ] = processEmbedded( "sbgroove_mid", sbGrooveColor, false, &sbGrooveColor );
			*ptr->pixmaps[ VSBSliderMidBgI ] = ptr->pixmaps[ VSBSliderMidBgI ] ->xForm( iMatrix );
			break;
			case HSBSliderTopBg:
			ptr->pixmaps[ HSBSliderTopBg ] = processEmbedded( "sbgroove_top", sbGrooveColor, true, &sbGrooveColor );
			*ptr->pixmaps[ HSBSliderTopBg ] = ptr->pixmaps[ HSBSliderTopBg ] ->xForm( rMatrix );
			break;
			case HSBSliderBtmBg:
			ptr->pixmaps[ HSBSliderBtmBg ] = processEmbedded( "sbgroove_btm", sbGrooveColor, true, &sbGrooveColor );
			*ptr->pixmaps[ HSBSliderBtmBg ] = ptr->pixmaps[ HSBSliderBtmBg ] ->xForm( rMatrix );
			break;
			case HSBSliderMidBg:
			ptr->pixmaps[ HSBSliderMidBg ] = processEmbedded( "sbgroove_mid", sbGrooveColor, false, &sbGrooveColor );
			*ptr->pixmaps[ HSBSliderMidBg ] = ptr->pixmaps[ HSBSliderMidBg ] ->xForm( rMatrix );
			break;
			case HSBSliderMidBgI:
			ptr->pixmaps[ HSBSliderMidBgI ] = processEmbedded( "sbgroove_mid", sbGrooveColor, false, &sbGrooveColor );
			*ptr->pixmaps[ HSBSliderMidBgI ] = ptr->pixmaps[ HSBSliderMidBgI ] ->xForm( lMatrix );
			break;

			case Progress:
			ptr->pixmaps[ Progress ] = processEmbedded( "progress", btnColor );
			break;
			case progress2:
			ptr->pixmaps[ progress2 ] = processEmbedded( "progress2", btnColor.light(110) );
			break;

			case HTMLRadioOn:
			ptr->pixmaps[ HTMLRadioOn ] = processEmbedded( "htmlradio_down", optionHandler->useCustomColors() ? optionHandler->customColor( CustomRadioOn ) : btnColor, true );
			break;
			case HTMLRadioOnHover:
			ptr->pixmaps[ HTMLRadioOnHover ] = processEmbedded( "htmlradio_down", optionHandler->useCustomColors() ? optionHandler->customColor( CustomRadioOn ).light( 110 ) : btnHoverColor, true );
			break;
			case HTMLRadioOff:
			ptr->pixmaps[ HTMLRadioOff ] = processEmbedded( "htmlradio", optionHandler->useCustomColors() ? optionHandler->customColor( CustomRadioOff ) : bgColor, true );
			break;
			case HTMLRadioOffHover:
			ptr->pixmaps[ HTMLRadioOffHover ] = processEmbedded( "htmlradio", optionHandler->useCustomColors() ? optionHandler->customColor( CustomRadioOn ) : btnColor, true );
			break;

			case HTMLCBDown:
			ptr->pixmaps[ HTMLCBDown ] = processEmbedded( "checkboxdown", optionHandler->useCustomColors() ? optionHandler->customColor( CustomCBOn ) : btnColor, true );
			drawHTMLCBBorder( *ptr->pixmaps[ HTMLCBDown ], optionHandler->useCustomColors() ? optionHandler->customColor( CustomCBOn ) : btnColor );
			break;
			case HTMLCBDownHover:
			ptr->pixmaps[ HTMLCBDownHover ] = processEmbedded( "checkboxdown", optionHandler->useCustomColors() ? optionHandler->customColor( CustomCBOn ).light( 110 ) : btnHoverColor, true );
			drawHTMLCBBorder( *ptr->pixmaps[ HTMLCBDownHover ], optionHandler->useCustomColors() ? optionHandler->customColor( CustomCBOn ).light( 110 ) : btnHoverColor );
			break;
			case HTMLCBHover:
			ptr->pixmaps[ HTMLCBHover ] = processEmbedded( "checkbox", optionHandler->useCustomColors() ? optionHandler->customColor( CustomCBOn ) : btnColor, true );
			drawHTMLCBBorder( *ptr->pixmaps[ HTMLCBHover ], optionHandler->useCustomColors() ? optionHandler->customColor( CustomCBOn ) : btnColor );
			break;
			case HTMLCB:
			ptr->pixmaps[ HTMLCB ] = processEmbedded( "checkbox", optionHandler->useCustomColors() ? optionHandler->customColor( CustomCBOff ) : bgColor, true );
			drawHTMLCBBorder( *ptr->pixmaps[ HTMLCB ], optionHandler->useCustomColors() ? optionHandler->customColor( CustomCBOff ) : bgColor );
			break;
			default:
			break;
		}
	return ( pixmaps[ item ] );
	}


#include "baghira.moc"
