#ifndef __LIQUID_STYLE_H
#define __LIQUID_STYLE_H

#include <qdrawutil.h>
#include <qpainter.h>
#include <qpointarray.h>
#include <qstyleplugin.h>
#include <qbitmap.h>
#include <qintdict.h>
#include <qimage.h>
//#include <qmap.h>
#include <qcleanuphandler.h>
#include <qpainter.h>
#include <kpixmap.h>
#include <kstyle.h>
#include <kpixmapeffect.h>
#include <kimageeffect.h>

#include <qiconview.h>
#include <qwidgetlist.h>
#include <qapplication.h>
#include <qfile.h>
#include <qfileinfo.h>
//#include <qdatastream.h>
#include <qcstring.h>
#include <qdir.h>
#include <qsettings.h>
#include <qobjectlist.h>
#include <qtimer.h>

// various widgets with special handlers
#include <qscrollbar.h>
#include <qcombobox.h>
#include <qmenubar.h>
#include <qpushbutton.h>
//#include <qscrollbar.h>
#include <qslider.h>
#include <qtabbar.h>
#include <qtoolbutton.h>
#include <qtoolbar.h>
#include <qpopupmenu.h>
#include <qprogressbar.h>
#include <qheader.h>
#include <qtextedit.h>

#include <kiconview.h>
#include <kwordwrap.h>

#define BITMAP_ITEMS 82 // Don't worry, they're demand loaded ;-)
#define LIQUID_MENU_CHANGE 667
#define MOSFET_BUTTON_CHANGE 661

class KWordWrap;

class LiquidStyle;

enum BitmapData{RadioOn = 0, RadioOff, RadioOnHover, RadioOffHover, RadioOnPressed, RadioOffPressed,
		VSBSliderTop, VSBSliderMid, VSBSliderBtm,
		VSBSliderTopActive, VSBSliderMidActive, VSBSliderBtmActive,
		VSBSliderTopHover, VSBSliderMidHover, VSBSliderBtmHover,
		VSBSliderTopPressed, VSBSliderMidPressed, VSBSliderBtmPressed,
		VSBSliderTopBg, VSBSliderMidBg, VSBSliderMidBgI, VSBSliderBtmBg,
                HSBSliderTop, HSBSliderMid, HSBSliderBtm,
		HSBSliderTopActive, HSBSliderMidActive, HSBSliderBtmActive,
		HSBSliderTopHover, HSBSliderMidHover, HSBSliderBtmHover,
		HSBSliderTopPressed, HSBSliderMidPressed, HSBSliderBtmPressed,
		HSBSliderTopBg, HSBSliderMidBg, HSBSliderMidBgI, HSBSliderBtmBg,
		Tab, TabDown, TabFocus, belowTab, belowTabDown,
		ButtonShadow, CB, CBDown, CBHover, CBDownHover, CBPressed, CBDownPressed,
		HSlider, VSlider, VSliderAbove, Progress, HTMLRadioOn, HTMLRadioOff,
                HTMLRadioOnHover, HTMLRadioOffHover, HTMLCBDown, HTMLCBDownHover,
                HTMLCBHover, HTMLCB,rectbutton, combo, comboShadow, progress2};

enum CustomColor{CustomCBOn = 0, CustomCBOff, CustomRadioOn, CustomRadioOff,
                 CustomTabOn, CustomTabOff, CustomSBSlider, CustomSBSliderHover, CustomSBSliderPressed, CustomSBGroove};

enum PulseType{PushButton, ComboBox, AppletHandle, Splitter, ToolButton};

enum myMenuTranslucency{Solid=0, DefaultTrans, CustomTrans, Gradient};

enum InactiveButtonColor{Original=0, Background, Active, Custom};

enum myExpanderStyle{Apple=0, MS};

enum progressStyle{baghira=0, liquid, mac};

enum DotlineStyle{Line=0, Dots};

enum Tile{TileTopLeft = 0, TileTop, TileTopRight,
          TileLeft, TileMiddle, TileRight, TileBtmLeft, TileBtm, TileBtmRight};

enum myPosition{left = 0, center, right, full};

class ButtonTile {
	public:
		ButtonTile() {
			for ( int i = 0;i < 9;++i ) {
				pixmaps[ i ] = 0;
				}
			;
			}
		~ButtonTile() {
			for ( int i = 0;i < 9;++i ) {
				if ( pixmaps[ i ] )
					delete pixmaps[ i ];
				}
			;
			}
		QPixmap* pixmap( Tile pos ) {
			return ( pixmaps[ ( int ) pos ] );
			}
		void setPixmap( Tile pos, QPixmap *pix ) {
			pixmaps[ ( int ) pos ] = pix;
			}
	protected:
		QPixmap *pixmaps[ 9 ];
	};

namespace // menudropshadow stuff bases upon kde code - well... based ;-)
{
	// Drop Shadow
/*	typedef struct _ShadowElements {
		QWidget* w1;
		QWidget* w2;
		QWidget* w3;
	}ShadowElements;

	
	typedef struct _PopupStuff{
		KPixmap *pix;
		KPixmap *cleanPix;
		ShadowElements *shadow;
		int leftOffset;
		bool hasShadows;
	}PopupStuff;*/

class ShadowElements : public QObject{
		Q_OBJECT
	public:
		ShadowElements(){
			w1 = NULL;
			w2 = NULL;
			w3 = NULL;
		}
		~ShadowElements(){
			if (w1) delete w1;
			if (w2) delete w2;
			if (w3) delete w3;
		}
		QWidget* w1;
		QWidget* w2;
		QWidget* w3;
	};

	
class PopupStuff : public QObject{
		Q_OBJECT
	public:
		PopupStuff(){
			pix = NULL;
			cleanPix = NULL;
			shadow = NULL;
			leftOffset = 0;
			hasShadows = false;
		}
		~PopupStuff(){
			if (pix) delete pix;
			if (cleanPix) delete cleanPix;
			if (shadow) delete shadow;
		}
		KPixmap *pix;
		KPixmap *cleanPix;
		ShadowElements *shadow;
		int leftOffset;
		bool hasShadows;
	};
		
	int *top_right_corner;
	int *top_left_corner;
	int *bottom_right_corner;
	int *bottom_left_corner;
	int *shadow_strip;

}
class OptionHandler : public QObject {
		Q_OBJECT
	public:
		OptionHandler( QObject *parent );
		~OptionHandler() {
			if ( fillPixmap )
				delete fillPixmap;
// 			if (indicatedMenuItemRect)
// 				delete indicatedMenuItemRect;
// 			if (lastIndicatedMenuItemRect)
// 				delete lastIndicatedMenuItemRect;
// 			if (indicatedMenuItemPix)
// 				delete indicatedMenuItemPix;
// 			if (lastIndicatedMenuItemPix)
// 				delete lastIndicatedMenuItemPix;
			}
		void reloadSettings();
		KPixmap *pixmap( WId id ) {
			if (id == currentPopupWinID)
				return currentPopupPix;
			else if (PopupStuff *popupStuff = popupDict.find(id)){
				currentPopupWinID = id;
//				return ( currentPopupPix = pixDict.find( id ) );
				return ( currentPopupPix = popupStuff->pix);
			}
			else
				return NULL;
		}
		PopupStuff *popup( WId id ) {
			if (id == currentPopupWinID)
				return currentPopup;
			else if (PopupStuff *popupStuff = popupDict.find(id)){
				currentPopupWinID = id;
//				return ( currentPopupPix = pixDict.find( id ) );
				return ( currentPopup = popupStuff);
			}
			else
				return NULL;
		}		
		QPixmap* bgPixmap() {
			return ( fillPixmap );
			}
		inline bool useShadowText() {
			return ( shadowText );
			}
		const QColor& textColor();
		const QColor& bgColor();
		const QColor& buttonColor();
		inline void reset() {
			menusProcessed = false;
			}

		inline bool useBgStipple() {
			return ( bgStipple );
			}
		inline bool usePanelStipple() {
			return ( panelStipple );
			}
		inline int stippleContrast() {
			return ( contrast );
			}
		inline bool useReverseBtnColor() {
			return ( reverseBtnColor );
			}
		inline bool usePanelCustomColor() {
			return ( panelCustom );
			}
		inline QColor panelCustomColor() {
			return ( customPanelColor );
			}
		inline bool useToolButtonFrame() {
			return ( tbFrame );
			}
		void prepareMenus();

		inline bool useCustomColors() {
			return ( customWidgetColor );
			}
		inline const QColor& customColor( int idx ) {
			return ( customColors[ idx ] );
			}

		inline bool DrawDotlines() {
			return ( drawDotlines );
			}
		inline bool squeezeSbSlider() {
			return ( squeezesbslider );
			}
		inline bool shadowSbSlider(){
			return (shadowsbslider);
			}
		inline bool drawGroupBoxShadow() {
			return ( groupboxshadow );
			}
		inline int InactiveButtonColorType() {
			return ( inactiveButtonColor );
			}
		inline bool StippleMenu(){
			return (stippleMenu);
			}
		inline int MenuTranslucency(){
			return (menuTranslucency);
			}
		inline bool UseCustomMenuColor(){
			return (useCustomMenuColor);
			}
		inline int DotlineStyle(){
			return (dotlineStyle);
			}
		inline bool AlignStipples(){
			return(alignStipples);
			}
		inline bool MenuColorButton(){
			return (menuColorButton);
			}
		inline int ExpanderStyle(){
			return (expanderStyle);
			}
		inline bool UseCustomExpanderColor(){
			return (useCustomExpanderColor);
			}
		inline QColor CustomExpanderColor(){
			return (expanderColor);
			}
		inline QColor DotlineColor(){
			return (dotlineColor);
			}
		inline QColor InactiveButtonColor(){
			switch (inactiveButtonColor){
			case 0 : return (QColor(232,232,232));
			case 1 : return (bgColor());
			case 2 : return (buttonColor());
			case 3 : return (customInactiveButtonColor);
			}
		}
		inline bool CenterTabs(){
			return centerTabs;
		}
		inline bool EngageFB(){
			return engageFB;
		}

		inline bool SmoothListViewHeaders(){
			return smoothListViewHeaders;
		}

		inline bool SmootherLVH(){
			return smootherLVH;
		};
		
		inline bool IcyButtons(){
			return icyButtons;
		}

		inline bool ForceRectButton(){
			return forceRectButton;
		}

		inline int ShadowDarkness(){
			return shadowDarkness;
		}

		inline int Saturation(){
			return saturation;
		}

		inline bool MenuItemActive(){
			return menuItemActive;
		}

		inline void setMenuItemActive(){
			menuItemActive = true;
		}

		inline void setMenuItemInactive(){
			menuItemActive = false;
		}

		inline int MenuLevelCounter(){
			return menuLevelCounter;
		}

		inline int LastPopupID(){
			return lastPopupID;
		}


		inline void SetLastPopupID(int id){
			lastPopupID = id;
		}

		inline int ProgressBar(){
			return progressBar;
		}

		inline bool RemoveKickerBevel(){
			return removeKickerBevel;
		}

		inline bool SmoothToolbuttons(){
			return smoothToolbuttons;
		}

		inline void setGroupShadowButton(){
			groupShadowButton = true;
		}
		inline void setNotGroupShadowButton(){
			groupShadowButton = false;
		}
		inline bool GroupShadowButton(){
			return groupShadowButton;
		}

		inline void setScrollerActive(){
			scrollerActive = true;
		}

		inline void setScrollerInactive(){
			scrollerActive = false;
		}

		inline bool ScrollerActive(){
			return scrollerActive;
		}

		inline bool MenuDropShadows(){
			return menuDropShadows;
		}

		inline QColor Color(){
			return color;
		}
		
		inline int ShadowOffset(){
			return shadowOffset;
		}
		inline bool DrawProgressLabel(){
			return drawProgressLabel;
		}

		void renderMenuBlendPixmap( KPixmap *blendPix, QColor c, QPopupMenu *p, int leftOffset);
		int currentPopupWinID;
		PopupStuff *currentPopup;
		QPixmap *indicatedMenuItemPix;
		QRect *indicatedMenuItemRect;
		QPixmap *lastIndicatedMenuItemPix;
		QRect *lastIndicatedMenuItemRect;
		bool daddyWasAPopup;
		int lastIndicatedMenuItemID;

		QRect *sharedRect(QRect *r1, QRect *r2);
//		QIntDict<KPixmap>pixDict;
//		QIntDict<KPixmap>cleanPixDict;
		QIntDict<PopupStuff>popupDict;

	protected:

//		void createShadowWindows(const QPopupMenu* p, QPixmap *cleanPix, int swh, int leftOffset);
		void createShadowWindows(const QPopupMenu* p, PopupStuff *popupStuff, int swh);
		void removeShadowWindows(const QPopupMenu* p);
		void rightShadow(QImage& dst, int swh);
		void leftShadow(QImage& dst, int swh);
		void bottomShadow(QImage& dst, int swh);

		void stripePixmap( KPixmap &pix, const QColor &color );
		void stripePixmap( KPixmap &pix, const QColor &color, int density );
		bool eventFilter( QObject *obj, QEvent *ev );
		void initDropShadows(int swh);


		// Options? **********************************************************************************************************************
		// menu
		bool stippleMenu;
		bool directFollower;
		int menuTranslucency;
		int opacity;//int customMenuOpacity;
		bool menuColorButton;
		bool menuDropShadows;
		bool shadowText;
		//color
		//widgets
		bool customWidgetColor;
		QColor customColors[ 10 ];
		//menu
		bool useCustomMenuColor;
		QColor color, fgColor;
		//Panel
		bool panelCustom;
		QColor customPanelColor;
		//incativeButton
		int inactiveButtonColor;
		QColor customInactiveButtonColor;

		//Design
		//stipples
		bool bgStipple, panelStipple;
		int contrast;
		//shadows
		bool groupboxshadow;
		int shadowDarkness;
		//istviews;
		bool drawDotlines, useCustomExpanderColor;
		int expanderStyle;
		QColor expanderColor, dotlineColor;
		int dotlineStyle;
		//slider
		bool squeezesbslider;
		bool shadowsbslider;
		//toolbar
		bool reverseBtnColor, tbFrame;
		//tweaks
		bool alignStipples;
		bool centerTabs;
		bool engageFB;
		bool smoothListViewHeaders;
		bool smootherLVH;
		bool icyButtons;
		bool forceRectButton;
		int saturation;
		// Options! **********************************************************************************************************************

		bool menusProcessed;
		bool menuActive;
		bool scrollerActive;
		bool menuItemActive;
		int menuLevelCounter;
		int lastPopupID;
		bool groupShadowButton;
		QRect lastPopupRect;
		QPixmap *fillPixmap;
		int progressBar;
		bool removeKickerBevel;
		bool smoothToolbuttons;
		int shadowOffset;
		bool dropShadowsInited;
		int dropShadowDarkness;
		KPixmap *currentPopupPix;
		bool drawProgressLabel;

		QString colorStr, fgColorStr, panelColorStr;
	};
	
class WidgetAnimator : public QWidget{
		Q_OBJECT
	public:
		WidgetAnimator( QWidget *parent ){myWidget = parent;}
		~WidgetAnimator(){}
		
		void setMyWidget(QWidget *myNewWidget){
			myWidget = myNewWidget;
		}
		void setActiveWidget(QWidget **newActiveWidget){
			activeWidget = newActiveWidget;
		}
		
	private:
		QWidget *myWidget;
		QWidget **activeWidget;
	public slots:
		inline void animateSingleWidget(){
			if (*activeWidget == myWidget) emit animate(false);
		}
		inline void animateMultipleWidgets(){
			if (*activeWidget != NULL) emit animate();
		}
		inline void animateProgressBar(){
			if (((QProgressBar *)myWidget)->progress() > 0) emit animate();
		}
		signals:
		void animate(bool);
		void animate();
	};
	
class LiquidStyle : public KStyle {
		Q_OBJECT
	public:
		friend class OptionHandler;
//		friend class ScrollbarAnimator;
		LiquidStyle();
		virtual ~LiquidStyle();
		bool isPlain() const;
		
		virtual void polish( QWidget *w );
		virtual void unPolish( QWidget *w );
		virtual void polish( QPalette &p );
		virtual void unPolish( QApplication *a );
		int styleHint(StyleHint sh, const QWidget * w, const QStyleOption & opt, QStyleHintReturn * shr) const;
		void drawKStylePrimitive( KStylePrimitive kpe, QPainter* p, const QWidget* widget, const QRect &r, const QColorGroup &cg, SFlags flags = Style_Default, const QStyleOption& = QStyleOption::Default ) const;
		void drawPrimitive( PrimitiveElement pe, QPainter* p, const QRect &r, const QColorGroup &cg, SFlags flags = Style_Default, const QStyleOption& = QStyleOption::Default ) const;
		void drawControl( ControlElement element, QPainter *p, const QWidget *widget, const QRect &r, const QColorGroup &cg, SFlags flags = Style_Default, const QStyleOption& = QStyleOption::Default ) const;
		void drawControlMask( ControlElement element, QPainter *p, const QWidget *widget, const QRect &r, const QStyleOption& = QStyleOption::Default ) const;
		void drawComplexControl( ComplexControl control, QPainter *p, const QWidget *widget, const QRect &r, const QColorGroup &cg, SFlags flags = Style_Default, SCFlags controls = SC_All, SCFlags active = SC_None, const QStyleOption& = QStyleOption::Default ) const;
		void drawComplexControlMask( ComplexControl control, QPainter *p, const QWidget *widget, const QRect &r, const QStyleOption& = QStyleOption::Default ) const;

		int pixelMetric( PixelMetric m, const QWidget *widget = 0 ) const;

		QSize sizeFromContents( ContentsType contents, const QWidget *widget, const QSize &contentSize, const QStyleOption& opt ) const;
		QRect subRect( SubRect r, const QWidget *widget ) const;
		QRect querySubControlMetrics( ComplexControl control, const QWidget *widget, SubControl subcontrol, const QStyleOption &opt = QStyleOption::Default ) const;
		// Fix Qt3's wacky image positions
		QPixmap stylePixmap( StylePixmap stylepixmap, const QWidget *widget = 0, const QStyleOption& = QStyleOption::Default ) const;
		bool eventFilter( QObject *object, QEvent *event );
		//    void renderMenuBlendPixmap( KPixmap& pix, const QColorGroup &cg, const QPopupMenu* popup) const;
		
	public slots:
		void updateProgressPos();
		void updateSliderPos();
/*		void helpSlot(){
			emit helpSignal(false);
		}
		signals:
		void helpSignal(bool);*/
	protected:
		void clearImage( QImage &img ) const;
		ButtonTile* createButtonTile( const QColor &c, const QColor &bgColor, QImage *buttonImage, QImage *shadowImage, QImage *glowImage, QIntDict <ButtonTile>*buttonDict, QIntDict<ButtonTile>*shadowDict, QIntDict<ButtonTile>*glowDict, int w, int h, int xOff, int yOff, int centerW, int centerH, int shadowH, int glowWH, bool sunken, bool hover ) const;
		QPixmap* createSliderEnd( const QColor &c, const QColor &bgColor, bool top/*, bool vertical*/ ) const;
		ButtonTile* separateTiles( QPixmap *pix, int xO, int yO, int w, int h, int sh, bool sunken, bool forceAlpha ) const;

		QPixmap* getPixmap( BitmapData item ) const;
		QPixmap* adjustHSV( QImage &img, const QColor &c, bool blend = false, const QColor *bg = NULL ) const;
		QImage* apple(QImage *img, const QColor *c, bool blend, const QColor *bg ) const;
//		QImage* grain_merge(QImage *image, const QColor *color) const;
//		int clamp(int v, int min, int max) const;
		QImage* adjustHSVImage( QImage &img, const QColor &c, bool blend = false, const QColor *bg = NULL ) const;
		void adjustHSV( QPixmap &pix, const QColor &c ) const;
		QPixmap* processEmbedded( const char *label, const QColor &c, bool blend = false, const QColor *bg = NULL ) const;
		void drawRoundButton( QPainter *p, const QColorGroup &cg, const QColor &c, const QColor &bg, int x, int y, int w, int h, bool supportPushDown = false, bool pushedDown = false, bool hover = false, bool autoDefault = false, bool isHTML = false, int bgX = -1, int bgY = -1 ) const;
		void drawClearBevel( QPainter *p, int x, int y, int w, int h, const QColor &c, const QColor &bg ) const;
		void drawRectangularButton( QPainter *p, const QColor &c, int x, int y, int w, int h, bool sunken = false, bool hover = false, bool isCombo = false ) const;
		void drawCombo( QPainter *painter, const QColorGroup &cg, const QColor &c, int x, int y, int w, int h, bool sunken, bool hover, bool isCombo, int position = full ) const;
		void drawEditFrame( QPainter *p, const QRect &r, const QColorGroup &cg, bool isHTML = false, bool focused = false ) const;
		void drawHTMLCBBorder( const QPixmap &pix, const QColor &c ) const;
		bool isHTMLWidget( const QWidget *w ) const;


	private:
		LiquidStyle( const LiquidStyle & );
		LiquidStyle& operator=( const LiquidStyle & );
		int getBrightness(unsigned int rgb) const;
		
		
		QBitmap *sbLeft, *sbRight, *sbUp, *sbDown;
		QImage *btnBorderImg, *btnShadowImg, *slider_top, *slider_btm, *slider_top_shd, *slider_btm_shd, *rectbutton, *combo, *comboShadow, *buttonGlow /*, tabImg*/;
		QPixmap *btnBlendPix, *bevelFillPix, *smallBevelFillPix, *menuPix, *groupShadow ;
		QBrush pagerBrush, pagerHoverBrush;
		QBrush origPanelBrush;
		QPalette origPanelPalette;

		QPixmap *pixmaps[ BITMAP_ITEMS ];
		QPixmap sbBuffer;
		QScrollBar *currentScrollBar;
		QWMatrix lMatrix;
		QWMatrix rMatrix;
		QWMatrix iMatrix;

		bool isKicker, isHTMLButton, initialPaletteLoaded, inExitPolish;

		QHeader *currentHeader;
		int headerHoverID;
		QPoint btnOffset;
		QWidget *currentTaskContainer;
		bool isTaskContainer, taskContainerHover;

		QPalette polishedPalette, tooltipPalette;
		unsigned int qtrcModificationTime;
		
		int progAnimShift;
		int prog2AnimShift;
		int sliderAnimShift;

		OptionHandler *optionHandler;

		QIntDict<ButtonTile>btnDict;
		QIntDict<ButtonTile>btnShadowedDict;
		QIntDict<ButtonTile>buttonGlowDict;
		QIntDict<ButtonTile>comboDict;
		QIntDict<ButtonTile>comboShadowedDict;
		QIntDict<ButtonTile>tabDict;
		QIntDict<ButtonTile>inverseTabDict;
		QIntDict<ButtonTile>rectBtnDict;
		QIntDict<ButtonTile>progress2Dict;
		QIntDict<QPixmap>bevelFillDict;
		QIntDict<QPixmap>smallBevelFillDict;

		QPixmap *tmpBtnPix;
		
		QWidget *highlightWidget;
		QScrollBar *activeScroller;
//		QProgressBar *activeProgress;

	};

#endif
